SystemOrganization addCategory: #'SqSave-Base'!
SystemOrganization addCategory: #'SqSave-Tests'!
SystemOrganization addCategory: #'SqSave-Connection'!
SystemOrganization addCategory: #'SqSave-UsageExamples'!
SystemOrganization addCategory: #'SqSave-Base-Structures'!
SystemOrganization addCategory: #'SqSave-Analysis'!
SystemOrganization addCategory: #'SqSave-Query'!
SystemOrganization addCategory: #'SqSave-Apps'!
SystemOrganization addCategory: #'SqSave-Apps-OO7'!
SystemOrganization addCategory: #'SqSave-Traits'!
SystemOrganization addCategory: #'SqSave-Apps-Weblog-Models'!
SystemOrganization addCategory: #'SqSave-Apps-Weblog-Database'!
SystemOrganization addCategory: #'SqSave-Apps-Weblog-Components'!

Trait named: #TSqsLogger
	uses: {}
	category: 'SqSave-Traits'!

!TSqsLogger methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 21:09'!
log: aString
	self log: aString loggerName: self class category! !

!TSqsLogger methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 13:00'!
log: aString loggerName: aName
	[(LogClient for: aName) info: aString] fork! !

Trait named: #TSqsSearch
	uses: {}
	category: 'SqSave-Traits'!

!TSqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 19:32'!
doesNotUnderstand: aMessage 
	| attributes limit |
	attributes := self findAttributesInSelector: aMessage selector forClass: self.
	attributes 
		ifNil: [ ^ super doesNotUnderstand: aMessage ]
		ifNotNil: 
			[ limit := self findLimitInSelector: aMessage selector.
			^ (SqsSearch for: self) 
				searchBy: attributes
				withValues: aMessage arguments
				limit: limit ]! !

!TSqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 19:33'!
findAttributesInSelector: aSelector forClass: aClass
	| finderMethod all startWord attributes |

	finderMethod := aSelector prefixMatchesRegex: 'find[[:alpha:]]*By'.
	finderMethod ifTrue: [
		all := aSelector prefixMatchesRegex: 'findAllBy[[:upper:]]+'.
		startWord := all ifTrue:['findAllBy'] ifFalse: [	startWord := 'findBy'].
		attributes := self findAttributesInSelector: aSelector forClass: aClass beginWith: startWord.
	].
	^ attributes! !

!TSqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 19:34'!
findAttributesInSelector: aSelector forClass: aClass beginWith: aString
	| elements searchedAttributes attrName |
	elements := aSelector subStrings: ':'.
	searchedAttributes := OrderedCollection new.
	elements at: 1 put: ((elements first) allButFirst: (aString size)).
	elements do:[ :el |
		attrName := el.
		(el beginsWith: 'and') ifTrue:[attrName := el allButFirst: 3].
		attrName := attrName withFirstCharacterDownshifted.
		((aClass allInstVarNames includes: attrName) or: [attrName = SqsSearch searchForIdField]) ifTrue: [
			searchedAttributes add: attrName.	
		] ifFalse: [			
			^nil
		]
	].
	^searchedAttributes! !

!TSqsSearch methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 19:34'!
findLimitInSelector: aSelector
	| limit |
	limit := nil.
	(aSelector prefixMatchesRegex: 'findAllBy[[:upper:]]+') ifFalse: [
		limit := 1.	
	].
	^ limit! !

Trait named: #TSqsSelfPrinting
	uses: {}
	category: 'SqSave-Traits'!

!TSqsSelfPrinting methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!TSqsSelfPrinting methodsFor: 'printing' stamp: 'test 1/27/2009 11:28'!
storeOn: aStream
	aStream nextPutAll: self codeForObjectCreation! !

!JdmConnection methodsFor: '*sqsave' stamp: 'tkow 10/29/2008 14:11'!
finalize
	[self close] ifError: []! !

!JdmConnection methodsFor: '*sqsave' stamp: 'tk 7/18/2008 16:02'!
socket
	^socket! !

!Time class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:31'!
sqsType
	^#time! !

!Time methodsFor: '*sqsave' stamp: 'wh 8/9/2006 01:01'!
asSqlValueString
	^'''',self asString,''''.! !

!String class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:29'!
sqsType
	^#string! !

!String methodsFor: '*sqsave' stamp: 'lr 7/14/2003 11:34'!
asEscapedSql
	^String streamContents: [ :stream |
		self do: [ :char |
			(#($' $\) includes: char)
				ifTrue: [ stream nextPut: char ].
			stream nextPut: char ] ]! !

!String methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:39'!
asSqSaveDescriptionSelector
	| selector |
	selector := self copy asString.
	self ifNotEmpty: [
		selector at: 1 put: (((self at: 1) asUppercase)).	
	].
	^('sqsDescr',selector) asSymbol.! !

!String methodsFor: '*sqsave' stamp: 'tkow 10/6/2008 11:31'!
asSqSaveDescriptorClassName
	^(self capitalized, 'PersistenceDescriptor') asSymbol! !

!String methodsFor: '*sqsave' stamp: 'tk 7/7/2008 15:19'!
asSqSaveTableName
	| |
	^self decamelized,'s'! !

!String methodsFor: '*sqsave' stamp: 'wh 3/2/2006 11:13'!
asSqlValueString
	^'''',self asEscapedSql,''''.! !

!String methodsFor: '*sqsave' stamp: 'tkow 11/18/2008 18:11'!
camelized
	| result prevChar |
	result := WriteStream on: String new.
	prevChar := $t.
	self do: [:char |
		char ~= $_ ifTrue: [
			result nextPut: ((prevChar = $_) ifTrue: [char asUppercase] ifFalse: [char ]).
		]. 
		prevChar := char.		
	].
	^result contents! !

!String methodsFor: '*sqsave' stamp: 'tk 7/7/2008 15:19'!
decamelized
	| result nextChar |
	result := WriteStream on: String new.
	self withIndexDo: [:char :index |
		nextChar := self at: (index + 1) ifAbsent: [$t].
		(((nextChar isLowercase) and: [char isUppercase]) and:[index > 1]) ifTrue: [
			result nextPutAll: '_'.
		].
		result nextPutAll: char asLowercase asString.
	].
	^result contents! !

!String methodsFor: '*sqsave' stamp: 'tkow 12/11/2008 18:22'!
splitBy: aString
	| curPosition results nextString nextPosition |
	(self size < 3) ifTrue: [^self].
	curPosition := 1.
	results := OrderedCollection new.
	[curPosition < self size] whileTrue: [
		nextPosition := self findString: aString startingAt: curPosition.
		(nextPosition = 0) ifTrue: [
			nextString := self copyFrom: curPosition to: self size.
			curPosition := self size.	
		] ifFalse: [
			nextString := self copyFrom: curPosition to: (nextPosition - 1).	
			curPosition := nextPosition + aString size.
		].
		nextString ifNotEmpty:[results add: nextString]
	].
	^ results! !

!String methodsFor: '*sqsave' stamp: 'tkow 2/5/2009 19:40'!
sqsType
	(self size > 254) ifTrue: [
		^#text	
	] ifFalse: [
		^#string
	]! !

ProtoObject subclass: #SqsProxy
	instanceVariableNames: 'sqsProxiedObject sqsProxyOwner sqsProxiedVariable sqsInitialized'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsProxy subclass: #SqsCollectionProxy
	instanceVariableNames: 'sqsSimpleValues sqsCollectionMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsCollectionProxy class methodsFor: 'cached-creation' stamp: 'tkow 2/19/2009 21:47'!
for: aCollection ofInstVar: anIvarName in: anObject simpleValues: aBool 
	| |
	^ self basicNew
		sqsProxyOwner: anObject;
		sqsSimpleValues: aBool;
		sqsProxiedObject: aCollection;
		sqsProxiedVariable: anIvarName;
		sqsInitialized: true.! !

!SqsCollectionProxy methodsFor: 'as yet unclassified' stamp: 'tkow 2/19/2009 21:19'!
isCollection
	"well, not really...but acts as one"
	^ true! !

!SqsCollectionProxy methodsFor: 'as yet unclassified' stamp: 'tkow 2/19/2009 21:21'!
isString
	"well, not really...but acts as one"
	^ false! !

!SqsCollectionProxy methodsFor: 'as yet unclassified' stamp: 'tkow 2/16/2009 17:52'!
sqsClass
	| descr |
	^ sqsProxiedObject ifNil: [
		descr := (SqsStorage for: sqsProxyOwner) descriptionHandler sqsDescriptionForInstVar: sqsProxiedVariable.
		Smalltalk at: descr collectionClass
	] ifNotNil: [
		sqsProxiedObject class
	]! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:06'!
sqsCollectionMap
	^ sqsCollectionMap! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:13'!
sqsCreateCollectionMap
	| tmpMap |
	sqsProxiedObject ifNotNil: 
		[ tmpMap := OrderedCollection new.
		sqsProxiedObject do: 
			[ :obj | 
			| value |
			value := obj ifNotNil: 
				[ sqsSimpleValues 
					ifTrue: [ obj ]
					ifFalse: [ obj oid ] ].
			tmpMap add: value ] ].
	^ tmpMap! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:38'!
sqsGetCollectionChanges
	| counter changes newCollectionMap |
	counter := 0.
	newCollectionMap := self sqsCreateCollectionMap.
	changes := SqsCollectionChanges new.
	sqsCollectionMap ifNil: [ ^ changes ].
	sqsCollectionMap do: 
		[ :oid | 
		| newOid |
		counter := counter + 1.
		counter > newCollectionMap size 
			ifTrue: 
				[ changes deletedObjects add: (OrderedCollection 
						with: oid
						with: counter) ]
			ifFalse: 
				[ newOid := newCollectionMap at: counter.
				newOid ~= oid ifTrue: 
					[ changes movedObjects add: (OrderedCollection 
							with: newOid
							with: counter) ] ] ].
	[ counter < newCollectionMap size ] whileTrue: 
		[ counter := counter + 1.
		changes addedObjects add: (OrderedCollection 
				with: (newCollectionMap at: counter)
				with: counter) ].
	sqsCollectionMap := newCollectionMap.
	^ changes! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 3/5/2009 16:45'!
sqsLoadProxiedObject
	sqsInitialized ifNotNil: [ 
		sqsProxiedObject ifNil: [
			Transcript show: 'Loading collection proxy'.
			sqsProxiedObject := (SqsStorage for: sqsProxyOwner) loadProxiedCollectionFor: sqsProxiedVariable.
			sqsCollectionMap := self sqsCreateCollectionMap 
		] 
	]! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 14:23'!
sqsProxiedObject: anObject 
	super sqsProxiedObject: anObject.
	"only update the map when there is not already one present"
	sqsCollectionMap := self sqsCreateCollectionMap.! !

!SqsCollectionProxy methodsFor: 'accessing' stamp: 'tkow 9/23/2008 17:35'!
sqsSimpleValues: anObject
	sqsSimpleValues := anObject! !

!SqsProxy class methodsFor: 'cached-creation' stamp: 'tkow 12/1/2008 11:42'!
for: aCollection ofInstVar: anIvarName in: anObject 
	^ self basicNew
		sqsProxyOwner: anObject;
		sqsProxiedObject: aCollection;
		sqsProxiedVariable: anIvarName;
		sqsInitialized: true! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 3/6/2009 18:52'!
doesNotUnderstand: aMessage 
	self sqsLoadProxiedObject.
	^ aMessage sendTo: sqsProxiedObject! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 3/6/2009 17:23'!
isCollection
	^ false! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 3/6/2009 18:51'!
oid
	^ (sqsProxiedObject isInteger or: [sqsProxiedObject isNil]) ifTrue: [
		sqsProxiedObject	
	] ifFalse: [
		sqsProxiedObject oid
	]! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 3/6/2009 18:50'!
sqsClass
	| descr |
	^ (sqsProxiedObject isInteger or: [sqsProxiedObject isNil]) ifTrue: [
		descr := (SqsStorage for: sqsProxyOwner) descriptionHandler sqsDescriptionForInstVar: sqsProxiedVariable.
		Smalltalk at: descr associatedClass
	] ifFalse: [
		sqsProxiedObject class
	]! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:36'!
sqsInitialized: aBool
	sqsInitialized := aBool ! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 3/6/2009 18:53'!
sqsLoadProxiedObject
	sqsProxiedObject isInteger ifTrue: [ 
		sqsProxiedObject := (SqsStorage for: sqsProxyOwner) 
			loadProxiedObjectFor: sqsProxiedVariable
			withOid: sqsProxiedObject 
	]! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/2/2008 18:44'!
sqsProxiedObject
	^ sqsProxiedObject! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:42'!
sqsProxiedObject: anObject 
	sqsProxiedObject := anObject! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:42'!
sqsProxiedVariable: anObject 
	sqsProxiedVariable := anObject! !

!SqsProxy methodsFor: 'accessing' stamp: 'tkow 12/1/2008 11:41'!
sqsProxyOwner: anObject 
	sqsProxyOwner := anObject! !

!Behavior methodsFor: '*sqsave' stamp: 'tkow 3/8/2009 23:28'!
sqsBaseClass
	| |
	^ ((superclass = Object) or: [superclass class selectors includes: #sqsAbstractBaseClass]) ifTrue: [
		self	
	] ifFalse: [
		self superclass sqsBaseClass
	]! !

!Behavior methodsFor: '*sqsave' stamp: 'tkow 2/27/2009 12:46'!
sqsIsComplexClass
	^ (self respondsTo: SqsDescriptionHandler sqlTypeSelector) not! !

!Class class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:22'!
sqsType
	^#string! !

!Class methodsFor: '*sqsave' stamp: 'wh 9/5/2006 10:58'!
asSqlValueString
	^'''',self name asString asEscapedSql,''''.! !

!DateAndTime class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:25'!
sqsType
	^#dateAndTime! !

!DateAndTime methodsFor: '*sqsave' stamp: 'wh 3/2/2006 15:27'!
asSqlValueString
	^'''', self asString,''''. ! !

!LargePositiveInteger class methodsFor: '*sqsave' stamp: 'tkow 1/19/2009 17:49'!
fromSqlValue: anObject
	^ anObject asString asInteger! !

!LargePositiveInteger class methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 03:14'!
sqsType
	^#largeInteger! !

!LargePositiveInteger methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 13:24'!
asSqlValueString
	^'''', self asString, ''''! !

TestCase subclass: #SqsTestCase
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsTestCase subclass: #SqsBaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsBaseTest methodsFor: 'private' stamp: 'tkow 1/19/2009 15:06'!
setUp
	super setUp.
	self setupTestConnection.
	self clearDatabase.
	self removeDescriptions.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/19/2009 21:13'!
testAssociationAfterCollection
	| testObject1 testObject2 |
	self clearDatabase.
	self removeDescriptions.
	testObject1 := SqsTestObject new
		testInteger: 42;
		testString: 'foo';
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 21;
		testString: 'foo-bar';
		testSomething: (OrderedCollection with: testObject1);
		yourself.
		
	testObject2 save.
	
	testObject2 testSomething: testObject1.
	testObject2 save.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'test 3/5/2009 15:53'!
testChangeAssociation
	| testObject1 testObject2 testObject3 t2oid testResult |
	self clearDatabase.
	self removeDescriptions.
	testObject1 := SqsTestObject new
		testInteger: 42;
		testString: 'foo';
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 21;
		testString: 'foo-bar';
		testSomething: testObject1;
		yourself.
	
	testObject2 save.
	t2oid := testObject2 oid.
	testObject2 := nil.
	SqsStorage flushObjectCache.
	self assert: (SqsStorage objectCache cachedObjectOfClass: SqsTestObject withOid: t2oid) isNil.
	
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult notNil.
	self assert: testResult testSomething notNil.
	self assert: testResult testSomething testInteger = 42.

	testObject3 := SqsTestObject new
		testInteger: 84;
		testString: 'foo';
		yourself.
				
	testResult testSomething: testObject3.
	testResult save.
	testResult := nil.	
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult notNil.
	self assert: testResult testSomething notNil.
	self assert: testResult testSomething testInteger = 84.
	

! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/27/2009 21:01'!
testChangingAssociationClasses
	| testObject1 testObject2 testConnector columnDescription |
	self clearDatabase.
	self removeDescriptions.
	testObject1 := SqsTestObject new
		testInteger: 42;
		testString: 'foo';
		yourself.
		
	testConnector := SqsTestObjectConnector new
		test1: 'foo';
		test2: 'bar';
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 21;
		testString: 'foo-bar';
		testSomething: testObject1;
		yourself.
		
	testObject2 save.
	
	testObject2 testSomething: testConnector.
	testObject2 save.
	
	columnDescription := (SqsClassInfo for: SqsTestObject) descriptionHandler sqsDescriptionForInstVar: 'testSomething'.
	self assert: columnDescription associatedClass = SqsTestObjectConnector name.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/19/2009 21:07'!
testCollectionAfterAssociation
	| testObject1 testObject2 |
	self clearDatabase.
	self removeDescriptions.
	testObject1 := SqsTestObject new
		testInteger: 42;
		testString: 'foo';
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 21;
		testString: 'foo-bar';
		testSomething: testObject1;
		yourself.
		
	testObject2 save.
	
	testObject2 testSomething: (OrderedCollection with: testObject1).
	testObject2 save.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/25/2009 16:17'!
testConnectionIdentityStringCreation
	self assert: self standardConfiguration connectionIdentityString = self standardConnectionSpecification connectionIdentityString.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/5/2009 16:39'!
testDirtyAttributes
	| testObject2 testObject dirtyAttributes |

	testObject2 := SqsTestObjectChild new
		testSubString: 'test';
		testBool: true;
		yourself.

	testObject := SqsTestObjectChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: testObject2;
		testUnstoredVariable: true;
		yourself.
		
	testObject save.
	
	self assert: (SqsStorage for: testObject) dirtyAttributes isEmpty.
	testObject2 testInteger: 42.
	dirtyAttributes := (SqsStorage for: testObject2) dirtyAttributes.
	self assert: dirtyAttributes size = 1.
	self assert: (dirtyAttributes includes: 'testInteger').
	
	self assert: (SqsStorage for: testObject) dirtyAttributes isEmpty.
	testObject testUnstoredVariable: false.
	self assert: (SqsStorage for: testObject) dirtyAttributes isEmpty.
	testObject testBool: true.
	
	dirtyAttributes := (SqsStorage for: testObject) dirtyAttributes.
	self assert: dirtyAttributes size = 1.
	self assert: (dirtyAttributes includes: 'testBool').
	
	testObject save.
	self assert: (SqsStorage for: testObject) dirtyAttributes isEmpty.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testGetDirectlyReferencedObjects
	| testObject testObject2 directlyReferencedObjects base |
	self removeDescriptions.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject2 := SqsTestObject new.
	testObject testInteger: 4.
	testObject testSomething: testObject2.
	base := SqsStorage for: testObject.
	base descriptionHandler createDescriptions.
	directlyReferencedObjects := base directlyReferencedObjects.
	self assert: directlyReferencedObjects size == 1.
	self assert: directlyReferencedObjects first == testObject2! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 1/18/2009 17:07'!
testGetIndirectlyReferencedObjects
	| testObject testObject2 indirectlyReferencedObjects base |
	self removeDescriptions.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject2 := SqsTestObject new.
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	base := SqsStorage for: testObject.
	base descriptionHandler createDescriptions.
	indirectlyReferencedObjects := base indirectlyReferencedObjects.
	self assert: indirectlyReferencedObjects size == 1.
	self assert: indirectlyReferencedObjects first collection first == testObject2.
	self assert: indirectlyReferencedObjects first collectionDescription class = SqsCollectionDescription! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/27/2009 11:49'!
testIsComplexClassProperty
	self assert: String sqsIsComplexClass not.
	self assert: Integer sqsIsComplexClass not.
	self assert: Time sqsIsComplexClass not.
	self assert: nil class sqsIsComplexClass not.
	self assert: SqsTestObject sqsIsComplexClass.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/16/2009 17:06'!
testIsDirtyFlag

	| testObject2 testObject |
	testObject2 := SqsTestObjectChild new
		testSubString: 'test';
		testBool: true;
		yourself.

	testObject := SqsTestObject new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: testObject2;
		yourself.
	testObject save.
	
	self assert: (SqsStorage for: testObject) isDirty not.
	testObject2 testInteger: 42.
	self assert: (SqsStorage for: testObject2) isDirty.
	self assert: (SqsStorage for: testObject) isDirty not.
	testObject testBool: true.
	self assert: (SqsStorage for: testObject) isDirty.
	testObject save.
	self assert: (SqsStorage for: testObject) isDirty not.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 21:23'!
testNewRecordAttribute
	| obj obj2 oid |
	obj := SqsTestObject new.
	obj testInteger: 42.
	self assert: (SqsStorage oidFor: obj) isNil.
	obj save.
	self assert: (SqsStorage oidFor: obj) isNil not.
	oid := SqsStorage oidFor: obj.
	self assert: (SqsStorage 
			cachedObjectOfClass: SqsTestObject
			withOid: oid) == obj.
	obj2 := SqsTestObject findByTestInteger: 42.
	self assert: (SqsStorage oidFor: obj2) isNil not! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 3/6/2009 11:23'!
testObjectIdAssignment
	| testObject testObject2 |
	testObject := SqsTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: testObject oid == 1.
	testObject2 := SqsTestObject new.
	testObject2 testInteger: 4.
	testObject2 save.
	self assert: testObject2 oid == 2! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testPersistenceDescriptorCreationOnSave
	| testObject description targetClass |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqsTestObject new.
	testObject
		testDate: Date today;
		testInteger: 42;
		testString: 'calculon';
		testSomething: SqsTestObject new.
	testObject save.
	targetClass := (SqsClassInfo for: SqsTestObject) descriptionHandler targetClass.
	self 
		shouldnt: 
			[ description := targetClass perform: 'TestInteger' asSqSaveDescriptionSelector ]
		raise: [ Error ].
	self assert: description class = SqsColumn.
	self assert: description sqlType = #integer.
	self assert: description columnName = 'test_integer'.
	self assert: description associatedClass isNil.
	self assert: description linkedVariable = 'testInteger'! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testPersistenceDescriptorCreationOnSaveHappensOnlyInTheClassesDefiningTheVariable
	| testObject targetClass1 targetClass2 targetClass3 |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject testSubString: 'test'.
	testObject testExtremelyDeepSubString: 'test'.
	testObject save.
	targetClass1 := (SqsClassInfo for: SqsTestObject) descriptionHandler targetClass.
	targetClass2 := (SqsClassInfo for: SqsTestObjectChild) descriptionHandler targetClass.
	targetClass3 := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) descriptionHandler targetClass.
	self assert: (targetClass1 class includesSelector: 'testDate' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testInteger' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testString' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testSomething' asSqSaveDescriptionSelector) not.
	self assert: (targetClass2 class includesSelector: 'testSubString' asSqSaveDescriptionSelector).
	self assert: (targetClass3 class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector).
	self assert: (targetClass1 class includesSelector: 'testSubString' asSqSaveDescriptionSelector) not.
	self assert: (targetClass1 class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector) not! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/28/2009 15:31'!
testSaveLevel
	| testObject1 testObject2 testObject3 |
	testObject1 := SqsTestObject new
		testInteger: 42;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 42;
		testSomething: testObject1;
		yourself.
		
	testObject3 := SqsTestObject new
		testInteger: 42;
		testSomething: testObject2;
		yourself.
		
	testObject3 flatSave.
	self assert: testObject3 oid notNil.
	self assert: testObject2 oid isNil.
	self assert: testObject1 oid isNil.
	testObject3 save.
	self assert: testObject2 oid notNil.
	self assert: testObject1 oid isNil.
	testObject3 deepSave.
	self assert: testObject1 oid notNil.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testTableCreationOnSave
	| testObject |
	self clearDatabase.
	testObject := SqsTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	self assert: (SqsStorage for: testObject) tableForClassExists not.
	testObject save.
	self assert: (SqsStorage for: testObject) tableForClassExists! !

!SqsBaseTest methodsFor: 'tests' stamp: 'test 3/6/2009 13:20'!
testTableCreationOnStoringElementsWithinCollection
	| testObject testCon testResult |
	"this test is supposed to show that storing an object with a 
	collection of objects, for which the table not already exists does not fail"
	testCon := SqsTestObjectConnector new
		test1: 'test';
		test2: 42;
		yourself.
		
	testObject := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: testCon).
	self shouldnt: [testObject save] raise: Error.
	testObject := nil.
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult notNil.
	self assert: testResult testSomething notEmpty.
	self assert: (testResult testSomething at: 1) = testCon! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 3/5/2009 21:18'!
testTransactionRollback
	| testObject1 testObject2 session testResult |
	testObject1 := SqsTestObject new
		testInteger: 42;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 84;
		yourself.
		
	session := SqsConnectionManager getInstance sessionForConfiguration: self standardConfiguration.
	session inTransactionDo: [
		testObject1 save: session.
		testObject2 save: session.
		"nil should not understand this - ergo complete rollback, and both objects are not stored within the db"
		testObject1 testSomething testInteger: 42.	
	] ifError: [:err | self assert: true].

	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult isNil.! !

!SqsBaseTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 21:24'!
testUnwantedColumnAlteration

	| stream longString testObject testObject2 result |
	stream := TextStream on: (String new: 1000).
	1000 timesRepeat: [stream nextPutAll: 'd'].
	longString := stream contents.

	testObject := SqsTestObject new
		testString: longString;
		testInteger: 42;
		yourself.
		
	testObject2 := SqsTestObject new
		testString: 'xxx';
		testInteger: 21;
		yourself.
		
	testObject2 save.
	testObject save.
	testObject2 testString: 'xxxx'.
	testObject2 save.
	
	testObject2 := nil.
	testObject := nil.
	result := SqsTestObject findByTestInteger: 42.
	self assert: result notNil.
	self assert: result testString size = 1000.
	! !

SqsTestCase subclass: #SqsCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsCollectionTest subclass: #SqsCTICollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsCTICollectionTest methodsFor: 'private' stamp: 'tkow 12/12/2008 17:44'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance! !

!SqsCollectionTest class methodsFor: 'as yet unclassified' stamp: 'tkow 12/1/2008 13:01'!
shouldInheritSelectors
	^ true! !

!SqsCollectionTest methodsFor: 'private' stamp: 'tkow 1/19/2009 15:05'!
setUp
	super setUp.
	self setupTestConnection.
	self clearDatabase.
	self removeDescriptions.! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 21:13'!
testCollectionAdding
	| testObject2 testObject1 testResult testObject3 testResult2 t2Oid t3Oid |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject1 save.
	t2Oid := testObject2 oid.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething class includesBehavior: SqsProxy).
	self assert: (testResult testSomething size = 1).
	self assert: (testResult testSomething at: 1) oid = t2Oid.
	testObject3 := SqsTestObject new
		testInteger: 84;
		yourself.
	testResult testSomething add: testObject3.
	testResult save.
	t3Oid := testObject3 oid.
	self assert: testObject3 oid notNil.
	self assert: (testResult testSomething at: 2) = testObject3.
	testResult := nil.
	SqsStorage flushObjectCache.
	testResult2 := SqsTestObject findByTestInteger: 21.
	self assert: testResult2 isNil not.
	self assert: testResult2 testSomething isCollection.
	self assert: (testResult2 testSomething class includesBehavior: SqsProxy).
	self assert: (testResult2 testSomething at: 1) oid = t2Oid.
	self 
		shouldnt: [ testResult2 testSomething at: 2 ]
		raise: Error.
	self assert: (testResult2 testSomething at: 2) oid = t3Oid! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 21:25'!
testCollectionAddingSimpleObjects
	| testObject1 testResult testResult2 collection |
	collection := OrderedCollection 
		with: 21
		with: 42
		with: 84.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: collection;
		yourself.
	testObject1 save.
	testObject1 := nil.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: testResult testSomething size = 3.
	self assert: (testResult testSomething at: 1) = 21.
	testResult testSomething add: 168.
	testResult save.
	testResult := nil.
	testResult2 := SqsTestObject findByTestInteger: 21.
	self assert: testResult2 isNil not.
	self assert: testResult2 testSomething isCollection.
	self assert: testResult2 testSomething size = 4.
	self assert: (testResult2 testSomething at: 1) = 21.
	self 
		shouldnt: [ testResult2 testSomething at: 4 ]
		raise: Error.
	self assert: (testResult2 testSomething at: 4) = 168! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCollectionIsProxyAfterSaving
	| testObject2 testObject1 |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject1 save.
	self assert: (testObject1 testSomething class includesBehavior: SqsProxy)! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 21:12'!
testCollectionRemoving
	| testObject2 testObject1 testResult testObject3 |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject3 := SqsTestObject new
		testInteger: 84;
		yourself.
	testObject1 testSomething add: testObject3.
	testObject1 save.
	testObject1 testSomething removeAt: 2.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: testResult testSomething size = 1.
	self assert: (testResult testSomething at: 1) testInteger = testObject2 testInteger.
	self 
		should: [ testResult testSomething at: 2 ]
		raise: Error! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 21:11'!
testCollectionShuffling
	| testObject2 testObject1 testResult testObject3 testResult2 t2Oid t3Oid |
	testObject2 := SqsTestObject new testInteger: 42.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2).
	testObject3 := SqsTestObject new testInteger: 42.
	testObject1 testSomething add: testObject3.
	testObject1 save.
	t2Oid := testObject2 oid.
	t3Oid := testObject3 oid.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult notNil.
	self assert: testResult testSomething notNil.
	testResult testSomething: testResult testSomething reversed.
	testResult save.
	testResult := nil.
	SqsStorage flushObjectCache.
	testResult2 := SqsTestObject findByTestInteger: 21.
	self assert: testResult2 testSomething isCollection.
	self assert: testResult2 testSomething size = 2.
	self assert: (testResult2 testSomething at: 1) oid = t3Oid.
	self assert: (testResult2 testSomething at: 2) oid = t2Oid! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/16/2009 20:55'!
testCollectionTypeChange
	| testObject testResult |
	testObject := SqsTestObject new
		testSomething: (Set with: 1 with: 2 with: 3);
		testInteger: 42;
		yourself.
		
	testObject save.
	SqsStorage flushObjectCache.
	

	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult notNil.
	self assert: testResult testSomething sqsClass = Set.
	self assert: testResult testSomething sqsClass sqsRequiresOrderField not.
	
	testObject testSomething: testObject testSomething asArray.
	testObject save.
	
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult notNil.
	self assert: testResult testSomething sqsClass = Array.
	self assert: testResult testSomething sqsClass sqsRequiresOrderField.
! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCollectionWithSimpleValues
	| testCollection testObject testResult |
	testCollection := Set 
		with: 42
		with: 21
		with: 84.
	testObject := SqsTestObject new
		testInteger: 42;
		testString: 'fortyTwo';
		testSomething: testCollection.
	testObject save.
	testObject := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething includes: 21).
	self assert: (testResult testSomething includes: 42).
	self assert: (testResult testSomething includes: 84)! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/19/2009 14:07'!
testDescriptionCreation
	| testObject testObject2 description referenceColumn ownerColumn base targetClass |
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject2 := SqsTestObject new.
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	base := SqsStorage for: testObject.
	base descriptionHandler createDescriptions.
	targetClass := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) descriptionHandler targetClass.
	self 
		shouldnt: 
			[ description := targetClass perform: 'testSomething' asSqSaveDescriptionSelector ]
		raise: Error.
	self assert: description isNil not.
	self assert: description describesCollection.
	self assert: description tableName = 'sqs_test_objects_test_something'.
	referenceColumn := description referenceColumn.
	self assert: referenceColumn columnName = ('testSomething' decamelized, '_id').
	ownerColumn := description ownerColumn.
	self assert: ownerColumn columnName = 'sqs_test_object_id'! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/24/2009 17:46'!
testDictionaryCreation
	| testObject1 testObject2 testResult testDictionary |
	testObject1 := SqsTestObjectEvenDeeperChild new
		testString: 'test1';
		testSomething: Dictionary new.
	testObject2 := SqsTestObjectChild new testString: 'test2'.
	testObject1 testSomething 
		at: #test
		put: testObject2.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestString: 'test1'.
	self assert: testResult isNil not.
	testDictionary := testResult testSomething.
	self assert: testDictionary isDictionary.
	self assert: (testDictionary includesKey: 'test').
	self assert: ((testDictionary at: 'test') = testObject2).! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/27/2009 11:17'!
testLazyCollectionCreation
	| testObject2 testObject1 testResult |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqsTestObject new
		testInteger: 21;
		yourself.
	testObject1 save.
	testObject1 testSomething: (OrderedCollection with: testObject2).
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult notNil.
	self assert: testResult testSomething size = 1.
	self assert: (testResult testSomething at: 1) testInteger = 42! !

!SqsCollectionTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 21:10'!
testNilObjectsInCollections
	| testObject2 testObject1 testResult testObject3 |
	testObject2 := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject1 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
	testObject3 := SqsTestObject new
		testInteger: 84;
		yourself.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: testObject3.
	testObject1 testSomething add: nil.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: testResult testSomething size = 5.
	self assert: (testResult testSomething at: 1) testInteger = 42.
	self 
		shouldnt: [ testResult testSomething at: 4 ]
		raise: Error.
	self assert: (testResult testSomething at: 2) isNil! !

SqsCollectionTest subclass: #SqsSTICollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsSTICollectionTest methodsFor: 'private' stamp: 'tkow 12/12/2008 17:44'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance! !

SqsTestCase subclass: #SqsColumnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsColumnTest methodsFor: 'tests' stamp: 'test 1/27/2009 11:29'!
testCreationCode
	| column column2 |
	column := SqsColumn new.
	column columnName: 'testColumn'.
	column sqlType: #integer.
	column2 := Compiler evaluate: column codeForObjectCreation.
	self assert: column2 class = SqsColumn.
	self assert: column2 sqlType = #integer.
	self assert: column2 columnName = 'testColumn'! !

!SqsColumnTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:40'!
testCustomEquals
	| column1 column2 |
	column1 := SqsColumn new.
	column1 columnName: 'testColumn'.
	column1 sqlType: #integer.
	column2 := SqsColumn new.
	column2 columnName: 'testColumn'.
	column2 sqlType: #integer.
	self assert: column1 = column2! !

SqsTestCase subclass: #SqsConnectionManagerTest
	instanceVariableNames: 'connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsConnectionManagerTest methodsFor: 'running' stamp: 'tkow 2/27/2009 12:51'!
setUp
	connections := OrderedCollection new.
	SqsConnectionManager reset.! !

!SqsConnectionManagerTest methodsFor: 'running' stamp: 'tkow 2/25/2009 15:19'!
tearDown
	SqsConnectionManager getInstance closeAllConnections.
	SqsConnectionManager reset.! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 2/23/2009 17:10'!
testAdapterLimitiationToThreads
	| configuration manager session1 session2 session3 |
	configuration := self standardConfiguration.
	manager := SqsConnectionManager getInstance.
	session1 := manager sessionForConfiguration: configuration.
	session2 := manager sessionForConfiguration: configuration.
	self assert: session1 == session2.
	[ session3 := manager sessionForConfiguration: configuration ] fork.

	"kind of dirty...why is there now join, or waitFor for Process?"
	(Delay forMilliseconds: 2000) wait.
	self assert: session3 notNil.
	self assert: session3 ~= session1! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 2/23/2009 17:15'!
testAddConnectionSpecification
	| conManager testSession |
	conManager := SqsConnectionManager getInstance.
	conManager configurationDict: Dictionary new.
	conManager 
		setConfiguration: self standardConfiguration
		for: self standardCategory.
	self assert: (conManager configurationDict includesKey: self standardCategory).
	self assert: (conManager configurationDict at: self standardCategory) class == SqsConfiguration.
	testSession := conManager sessionForCategory: self standardCategory.
	self assert: testSession notNil.
	self assert: testSession sqsDbAdapter notNil.
	self assert: testSession connectionIdentityString = self standardConnectionSpecification connectionIdentityString! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 3/10/2009 16:28'!
testConfigurationSetupPrecedence
	| conf1 conf2 conf3 session connectionManager |
	conf1 := SqsConfiguration conSpec: self standardConnectionSpecification.
	conf1 tableConfiguration idField: 'sqs_oid'.
	
	conf2 := SqsConfiguration conSpec: self standardConnectionSpecification.
	conf2 tableConfiguration idField: 'oid'.
	
	conf3 := SqsConfiguration conSpec: self standardConnectionSpecification.
	conf3 tableConfiguration idField: 'id'.
	
	connectionManager := SqsConnectionManager getInstance.
	connectionManager setConfiguration: conf1 for: SqsTestObject name asString.
	connectionManager setConfiguration: conf2 for: SqsTestObject basicCategory asString.
	connectionManager setConfiguration: conf3 for: 'SqSave'.
	
	session := connectionManager sessionForClass: SqsTestObject.
	self assert: session configuration = conf1.
	session := connectionManager sessionForClass: SqsTestObjectChild.
	self assert: session configuration = conf2.
	session := connectionManager sessionForClass: SqsClassInfo.
	self assert: session configuration = conf3.! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 3/6/2009 14:08'!
testConnectionCounting
	| conSpec conManager |
	conSpec := self standardConnectionSpecification.
	conSpec maxConnections: 10.
	conManager := SqsConnectionManager getInstance.
	conManager 
		setConfiguration: (SqsConfiguration conSpec: conSpec)
		for: 'Test-Category'.
	1 
		to: 10
		do: 
			[ :i | 
			connections add: (conManager getConnectionFor: conSpec).
			self assert: (connections last class includesBehavior: SqsConnection) ].
	self 
		should: [ conManager getConnectionFor: conSpec ]
		takeMoreThanMilliseconds: 2000.
	conManager 
		releaseConnection: connections removeFirst
		for: conSpec.
	self 
		should: [ conManager getConnectionFor: conSpec ]
		notTakeMoreThanMilliseconds: 2000.
	connections do: 
		[ :con | 
		conManager 
			releaseConnection: con
			for: conSpec ]! !

!SqsConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 2/23/2009 16:52'!
testConnectionFreeing
	| conSpec conManager adapter queue oldQueueSize |
	conSpec := self standardConnectionSpecification.
	conManager := SqsConnectionManager getInstance.
	conManager 
		setConfiguration: (SqsConfiguration conSpec: conSpec)
		for: 'Test'.
	adapter := (conManager sessionForCategory: 'Test') sqsDbAdapter.
	queue := conManager connectionPool 
		at: conSpec connectionIdentityString
		ifAbsentPut: [ SharedQueue2 new ].
	oldQueueSize := queue size.
	self assert: ((adapter checkTableExistance: 'testtable') class includesBehavior: Boolean).
	oldQueueSize = 0 
		ifTrue: [ self assert: queue size = 1 ]
		ifFalse: [ self assert: queue size = oldQueueSize ]! !

SqsTestCase subclass: #SqsConnectionSpecificationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsConnectionSpecificationTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/13/2008 11:19'!
testConnectionIdentityString
	| testConSpec |
	testConSpec := SqsConnectionSpecification new
		database: 'testDb';
		username: 'testUser';
		port: '3306';
		password: 'test';
		hostname: 'localhost';
		driverClass: #SqsMysqlAdapter.
	self assert: testConSpec connectionIdentityString = 'SqsMysqlAdapter#testUser@localhost:3306/testDb'! !

SqsTestCase subclass: #SqsDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testCollectionCheck
	"a collection with simple values"
	| collection descriptionHandler |
	collection := OrderedCollection 
		with: 1
		with: 2
		with: 3.
	descriptionHandler := SqsDescriptionHandler new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection) not.

	"a collection with simple values and nil"
	collection add: nil.
	descriptionHandler := SqsDescriptionHandler new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection) not.

	"a collection with values from completely different classes"
	collection add: 'test'.
	self 
		should: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.

	"a collection with complex values"
	collection := OrderedCollection 
		with: SqsTestObject new
		with: SqsTestObjectChild new.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection).

	"a collection with complex values and nil values"
	collection add: nil.
	self 
		shouldnt: [ descriptionHandler isComplexCollection: collection ]
		raise: Error.
	self assert: (descriptionHandler isComplexCollection: collection).

	"a collection with complex values and simple values"
	collection add: 42.
	self 
		should: [ descriptionHandler isComplexCollection: collection ]
		raise: Error! !

!SqsDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:42'!
testDictionaryKeyRecognition
	| dictionary handler |
	dictionary := Dictionary new.
	dictionary 
		at: #test
		put: #test.
	dictionary 
		at: 'test2'
		put: #test2.
	handler := SqsDescriptionHandler new.
	self assert: (handler indexClassOfDictionary: dictionary) = ByteSymbol.
	dictionary := Dictionary new.
	dictionary 
		at: 432
		put: #test.
	dictionary 
		at: 41235
		put: #test2.
	handler := SqsDescriptionHandler new.
	self 
		shouldnt: [ handler indexClassOfDictionary: dictionary ]
		raise: Error.
	self assert: (handler indexClassOfDictionary: dictionary) = SmallInteger.
	dictionary := Dictionary new.
	dictionary 
		at: 432
		put: #test.
	dictionary 
		at: #test
		put: #test2.
	handler := SqsDescriptionHandler new.
	self 
		should: [ handler indexClassOfDictionary: dictionary ]
		raise: Error! !

!SqsDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testSqlTypeRecognition
	| handler |
	handler := SqsDescriptionHandler new.
	self assert: (handler sqlTypeForObject: 42) = #integer.
	self assert: (handler sqlTypeForObject: SqsTestObject new) = #integer.
	self assert: (handler sqlTypeForObject: true) = #boolean! !

!SqsDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 3/5/2009 21:23'!
testTypeChangeChecking
	
	| ivn oldDescription stream longString descrHandler shortString |
	ivn := 'test'.
	oldDescription := SqsColumn new
		sqlType: #string;
		yourself.
		
	stream := TextStream on: (String new: 1000).
	1000 timesRepeat: [ stream nextPutAll: 't'].
	longString := stream contents.
	
	descrHandler := SqsStandardDescriptionHandler new
		classInfo: (SqsClassInfo for: SqsTestObject);
		currentObject: (SqsStorage for: SqsTestObject new).
		
	self assert: (descrHandler changeDescriptionOf: ivn from: oldDescription becauseOf: longString).
	
	shortString := 'hello world'.
	oldDescription sqlType: #text.
	self assert: (descrHandler changeDescriptionOf: ivn from: oldDescription becauseOf: shortString) not.
	"jsut to be sure, that everything still cahnges upon completely new types"
	self assert: (descrHandler changeDescriptionOf: ivn from: oldDescription becauseOf: 54).
	
	
	! !

SqsTestCase subclass: #SqsDictionaryExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsDictionaryExtensionTests methodsFor: 'tests' stamp: 'tk 8/15/2008 14:49'!
testValueJoin
	| dict1 dict2 result |
	dict1 := Dictionary new.
	dict1 at: #test1 put: (OrderedCollection with: 42).
	dict1 at: #test2 put: 42.
	dict1 at: #test3 put: (OrderedCollection with: 84).
	
	dict2 := Dictionary new.
	dict2 at: #test1 put: (OrderedCollection with: 21).
	dict2 at: #test2 put: 21.
	
	result := dict1 valueJoin: dict2.
	self assert: ((result at: #test1) isCollection).
	self assert: ((result at: #test1) includes: (42)).
	self assert: ((result at: #test1) includes: (21)).

	self assert: ((result at: #test2) isCollection).
	self assert: ((result at: #test2) includes: (42)).
	self assert: ((result at: #test2) includes: (21)).

	self assert: ((result at: #test3) isCollection).
	self assert: ((result at: #test3) includes: (84)).
	! !

SqsTestCase subclass: #SqsDriverTest
	instanceVariableNames: 'adapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsDriverTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:37'!
setUp
	adapter := SqsMysqlAdapter new! !

!SqsDriverTest methodsFor: 'tests' stamp: 'tkow 2/25/2009 17:19'!
testQueryToCreateColumn
	| column sql referenceSql |
	SqsClassInfo clearInfoCache.
	column := SqsColumn new
		columnName: 'test_column';
		sqlType: #integer;
		tableName: 'test_table';
		canBeNull: false;
		foreignKey: (SqsForeignKeyDescription new
				referencedColumns: (OrderedCollection with: 'test_reference');
				referencedTable: 'test_table';
				referencingColumns: (OrderedCollection with: 'test_column');
				deleteActions: #(#CASCADE )).
	sql := adapter queryToCreateColumn: column.
	referenceSql := 'test_column INTEGER NOT NULL'.
	self assert: sql = referenceSql! !

!SqsDriverTest methodsFor: 'tests' stamp: 'tkow 2/16/2009 16:51'!
testTableCreation
	| testObject table sql referenceSql classInfo |
	self removeDescriptions.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	testObject := SqsTestObjectChild new
		testInteger: 42;
		testSomething: 4.12;
		testString: 'test';
		testDate: Date today;
		testSubString: 'subString'.
	(SqsStorage for: testObject) createClassDescription.
	classInfo := SqsClassInfo for: SqsTestObject.
	table := classInfo newClassTable.
	sql := adapter queryToCreateTable: table.
	referenceSql := 'CREATE TABLE sqs_test_objects ('.
	referenceSql := referenceSql , ((table columns collect: [ :column | adapter queryToCreateColumn: column ]) join: ', ').
	referenceSql := referenceSql , ', PRIMARY KEY (' , classInfo configuration tableConfiguration idField , ')) ENGINE=INNODB'.
	self assert: sql = referenceSql! !

SqsTestCase subclass: #SqsInheritanceSensitiveTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsInheritanceSensitiveTest subclass: #SqsClassTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:44'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance! !

!SqsClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 11:44'!
testCascadingDelete
	| dbConnection testObject resultDicts oid query oidField |
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	SqsStorage for: testObject.
	oid := testObject oid.
	testObject destroy.
	dbConnection := (SqsConnectionManager getInstance sessionForCategory: 'SqSave') sqsDbAdapter.
	oidField := (SqsClassInfo for: SqsTestObjectChild) configuration tableConfiguration idField.
	query := 'SELECT * FROM ' , SqsTestObjectChild name asSqSaveTableName.
	query := query , ' WHERE ' , oidField , ' = ' , oid asString.
	resultDicts := dbConnection executeQuery: query.
	self assert: resultDicts isEmpty.
	
	query := 'SELECT * FROM ' , SqsTestObjectEvenDeeperChild name asSqSaveTableName.
	query := query , ' WHERE ' , oidField , ' = ' , oid asString.
	resultDicts := dbConnection executeQuery: query.
	self assert: resultDicts isEmpty! !

!SqsClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testGetClassTableColumns
	self assert: (SqsClassInfo for: SqsTestObject) classTableColumns size = 5.
	self assert: (SqsClassInfo for: SqsTestObjectChild) classTableColumns size = 1.
	self assert: (SqsClassInfo for: SqsTestObjectEvenDeeperChild) classTableColumns size = 1! !

!SqsClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.5243;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: (SqsStorage for: SqsTestObject new) tableForClassExists.
	self assert: (SqsStorage for: SqsTestObjectChild new) tableForClassExists.
	self assert: (SqsStorage for: SqsTestObjectEvenDeeperChild new) tableForClassExists! !

!SqsClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testTableNames
	self assert: (SqsClassInfo for: SqsTestObject) tableName = SqsTestObject name asSqSaveTableName.
	self assert: (SqsClassInfo for: SqsTestObjectChild) tableName = SqsTestObjectChild name asSqSaveTableName.
	self assert: (SqsClassInfo for: SqsTestObjectEvenDeeperChild) tableName = SqsTestObjectEvenDeeperChild name asSqSaveTableName! !

!SqsClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 2/16/2009 16:44'!
testTableObjectChildren
	| testObject table1 table2 table3 |
	testObject := SqsTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: SqsTestObject new;
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqsStorage for: testObject) createClassDescription.
	table1 := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) newClassTable.
	table2 := (SqsClassInfo for: SqsTestObjectChild) newClassTable.
	table3 := (SqsClassInfo for: SqsTestObject) newClassTable.
	self assert: table1 allChildTables isEmpty.
	self assert: table2 allChildTables size = 1.
	self 
		assert: table2 allChildTables
		includes: table1.
	self assert: table3 allChildTables size = 2.
	self 
		assert: table3 allChildTables
		includes: table1! !

!SqsClassTableInheritanceTest methodsFor: 'running' stamp: 'tkow 2/16/2009 16:45'!
testTableObjectCreation
	| testObject table parent |
	testObject := SqsTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: SqsTestObject new;
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqsStorage for: testObject) createClassDescription.
	table := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) newClassTable.
	self assert: table tableName = SqsTestObjectEvenDeeperChild name asSqSaveTableName.
	self assert: table children isEmpty.
	self assert: table columns size = 2.
	self assert: table parent isNil not.
	parent := table parent.
	self assert: parent tableName = SqsTestObjectChild name asSqSaveTableName! !

!SqsInheritanceSensitiveTest class methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 13:08'!
shouldInheritSelectors
	^true! !

!SqsInheritanceSensitiveTest methodsFor: 'running' stamp: 'test 12/13/2008 11:28'!
setUp
	self setupTestConnection.
	self clearDatabase.
	self removeDescriptions! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 3/5/2009 15:35'!
testCircularReferenceHandling
	| testObject1 testObject2 testResult1 testResult2 t1oid t2oid |
	
	testObject1 := SqsTestObject new testInteger: 42.
	testObject2 := SqsTestObject new
		testInteger: 21;
		testSomething: testObject1.
	testObject1 testSomething: testObject2.

	"why 3000? because when logging is on, this can take a while..."
	self 
		should: [ testObject1 deepSave ]
		notTakeMoreThanMilliseconds: 3000.
	t1oid := testObject1 oid.
	t2oid := testObject2 oid.
	self assert: t1oid notNil.
	self assert: t2oid notNil.
	testObject1 := nil.
	testObject2 := nil.
	
	SqsStorage flushObjectCache.
	testResult1 := SqsTestObject findByTestInteger: 42.
	testResult2 := SqsTestObject findByTestInteger: 21.
	self assert: testResult2 testSomething testInteger = 42.
	self assert: testResult1 testSomething notNil.
	self assert: testResult1 testSomething testInteger = 21
	! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 2/19/2009 22:36'!
testComplexCollectionStorage
	| testObject testObject2 testResult |
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject2 := SqsTestObject new
		testInteger: 21;
		yourself.
	testObject testSomething: (OrderedCollection with: testObject2).
	testObject testInteger: 42.
	testObject save.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult notNil.
	self assert: testObject = testResult.
	"we still are ahold of the object, thus no proxy will be created"
	self assert: testResult testSomething first testInteger = 21.! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testCorrectObjectCreation
	| testObject1 testObject2 result |
	testObject1 := SqsTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	result := SqsTestObject findByTestInteger: 42.
	self assert: result class = SqsTestObject.
	testObject2 := SqsTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save.
	testObject2 := nil.
	SqsStorage flushObjectCache.
	result := SqsTestObject findByTestInteger: 21.
	self assert: result class = SqsTestObjectChild! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testDestroyObjects
	| testObject searchResult newSearchResult |
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	SqsStorage flushObjectCache.
	searchResult := SqsTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: searchResult isNil not.
	searchResult destroy.
	SqsStorage flushObjectCache.
	newSearchResult := SqsTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: newSearchResult isNil! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testGetPersistedInstanceVariables
	| ivars1 ivars2 ivars3 |
	ivars1 := (SqsClassInfo for: SqsTestObject) persistedInstVars.
	ivars2 := (SqsClassInfo for: SqsTestObjectChild) persistedInstVars.
	ivars3 := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) persistedInstVars.
	self assert: ivars1 size = 5.
	self assert: ivars2 size = 6.
	self assert: ivars3 size = 7.
	self assert: (ivars3 includes: 'testUnstoredVariable') not! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testNamingBasedSearch
	| testObject searchResult1 searchResult2 searchResult3 searchResult0 |
	testObject := SqsTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	SqsStorage flushObjectCache.
	searchResult0 := SqsTestObject 
		findByTestInteger: 5
		andTestDate: Date today.
	SqsStorage flushObjectCache.
	searchResult1 := SqsTestObject findByTestInteger: 5.
	searchResult2 := SqsTestObject 
		findByTestDate: Date today
		andTestString: 'test'.
	SqsStorage flushObjectCache.
	searchResult3 := SqsTestObject findByTestString: 'test'.
	self assert: searchResult0 isNil not.
	self assert: searchResult0 testInteger = 5.
	self assert: searchResult0 testDate = Date today.
	self assert: searchResult0 testString = 'test'.
	self assert: testObject = searchResult1.
	self assert: testObject = searchResult2.
	self assert: testObject = searchResult3! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 2/27/2009 16:28'!
testObjectCompleteness
	| testObject testResult |
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject
		testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testSubString: 'twentyOne';
		testExtremelyDeepSubString: #elevenAndAHalf;
		testBool: true.
	testObject save.
	testObject := nil.
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testInteger = 42.
	self assert: testResult testString = 'fortyTwo'.
	self assert: testResult testDate = Date today.
	self assert: testResult testSomething = 3.
	self assert: testResult testSubString = 'twentyOne'.
	self assert: testResult testExtremelyDeepSubString = #elevenAndAHalf.
	self assert: testResult testBool = true! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testSaveRelatedObjectAlongWithObject
	| testObject testObject2 result base |
	testObject := SqsTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject2 := SqsTestObject new.
	testObject2 testInteger: 6.
	testObject2 testString: 'test2'.
	testObject testSomething: testObject2.
	base := SqsStorage for: testObject2.
	self assert: base newRecord.
	testObject save.
	self assert: base newRecord not.
	self assert: base oid isNil not.
	result := SqsTestObject findByTestInteger: 6.
	self assert: result == testObject2! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'test 1/22/2009 19:43'!
testSearchForCollections
	| results testObject1 |

	testObject1 := SqsTestObject new
		testInteger: 21;
		yourself.
	testObject1 save.

	10 timesRepeat: [
		SqsTestObject new
			testInteger: 42;
			testString: #helloWorld;
			testDate: Date today;
			testBool: true;
			testSomething: testObject1;
			save	
	].

	results := SqsTestObject findAllByTestInteger: 42.
	self assert: (results size = 10).
	results := SqsTestObject findAllByTestString: #helloWorld.
	self assert: (results size = 10).	
	results := SqsTestObject findAllByTestDate: Date today.
	self assert: (results size = 10).
	results := SqsTestObject findAllByTestBool: true.
	self assert: (results size = 10).		
	results := SqsTestObject findAllByTestSomething: testObject1.
	self assert: (results size = 10).

! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'test 1/22/2009 17:47'!
testSearchForMultipleArguments
	| results testObject1 testObject2 |

	testObject1 := SqsTestObject new
		testInteger: 42;
		testString: #hello;
		testDate: Date today;
		yourself.
		
	testObject1 save.
	
	testObject2 := SqsTestObject new
		testInteger: 42;
		testString: #world;
		testDate: Date today;
		testSomething: testObject1;
		yourself.
		
	testObject2 save.

	results := SqsTestObject findAllByTestInteger: 42 andTestString: #hello.
	self assert: (results size = 1).
	self assert: (results first = testObject1).
	
	results := SqsTestObject findAllByTestString: #world andTestInteger: 42.
	self assert: (results size = 1).	
	self assert: (results first = testObject2).
		
	results := SqsTestObject findAllByTestSomething: testObject1 andTestInteger: 42.
	self assert: (results size = 1).
	self assert: (results first = testObject2).
		
	results := SqsTestObject findAllByTestDate: Date today andTestInteger: 42.
	self assert: (results size = 2).	
! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testSearchRestrictionToClasses
	| testObject testResult oldOid testResult2 |
	testObject := SqsTestObject new.
	testObject
		testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testBool: true.
	testObject save.
	oldOid := testObject oid.
	testObject := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: testResult isNil.
	testResult2 := SqsTestObject findByTestInteger: 42.
	self assert: testResult2 notNil.
	self assert: testResult2 oid = oldOid! !

!SqsInheritanceSensitiveTest methodsFor: 'tests' stamp: 'test 2/5/2009 19:21'!
testUpdate
	| testObject testResult |
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 3.14;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'deepSubString'.
	testObject save.
	testObject testString: 'newTest'.
	testObject save.
	testObject := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: testResult testString = 'newTest'! !

SqsInheritanceSensitiveTest subclass: #SqsSingleTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsSingleTableInheritanceTest methodsFor: 'running' stamp: 'tkow 12/12/2008 17:44'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testGetClassTableColumns
	self assert: (SqsClassInfo for: SqsTestObject) classTableColumns size = 5.
	self assert: (SqsClassInfo for: SqsTestObjectChild) classTableColumns size = 1.
	self assert: (SqsClassInfo for: SqsTestObjectEvenDeeperChild) classTableColumns size = 1! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testSaveSubclassWithSingleTableInheritance
	| testObject base |
	base := SqsClassInfo for: SqsTestObjectChild.
	self assert: base tableName = SqsTestObject name asSqSaveTableName.
	self assert: base tableForClassExists not.
	testObject := SqsTestObjectChild new.
	testObject testSubString: 'Subtest'.
	testObject save.
	self assert: base tableForClassExists! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:55'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new.
	testObject
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.524;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: (SqsStorage for: testObject) tableForClassExists! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 2/16/2009 16:53'!
testTableObjectChildren
	| testObject table1 table2 table3 |
	testObject := SqsTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: SqsTestObject new;
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqsStorage for: testObject) createClassDescription.
	table1 := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) newClassTable.
	table2 := (SqsClassInfo for: SqsTestObjectChild) newClassTable.
	table3 := (SqsClassInfo for: SqsTestObject) newClassTable.
	self assert: table1 allChildTables isEmpty.
	self assert: table2 allChildTables isEmpty.
	self assert: table3 allChildTables isEmpty! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 2/16/2009 16:53'!
testTableObjectCreation
	| testObject table |
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new
		testInteger: 42;
		testString: 'test';
		testDate: Date today;
		testSomething: SqsTestObject new;
		testSubString: 'sub-string';
		testExtremelyDeepSubString: 'deep-sub-string'.
	(SqsStorage for: testObject) createClassDescription.
	table := (SqsClassInfo for: SqsTestObjectEvenDeeperChild) newClassTable.
	self assert: table children isEmpty.
	self assert: table tableName = SqsTestObject name asSqSaveTableName.
	self assert: table columns size = 9.
	self assert: table parent isNil! !

!SqsSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 12/13/2008 11:44'!
testTypeParameter
	| testObject1 testObject2 dbConnection resultDicts typeField |
	testObject1 := SqsTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	dbConnection := (SqsConnectionManager getInstance sessionForCategory: self standardCategory) sqsDbAdapter.
	resultDicts := dbConnection 
		executeQuery: 'SELECT * FROM ' , SqsTestObject name asSqSaveTableName , ' WHERE test_integer = 42'.

	typeField := (SqsClassInfo for: SqsTestObject) configuration tableConfiguration typeField.
	resultDicts do: [ :resultDict | self assert: (resultDict at: typeField) = SqsTestObject name asString ].
	testObject2 := SqsTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save! !

SqsTestCase subclass: #SqsProxyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsProxyTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/2/2008 18:46'!
setUp
	self setupTestConnection.! !

!SqsProxyTest methodsFor: 'as yet unclassified' stamp: 'test 3/5/2009 16:53'!
testProxiedObjectNotLoadedBeforeAccess
	| testObject testObject1 testResult |
	self clearDatabase.
	testObject := SqsTestObject new
		testInteger: 42;
		testString: 'foo';
		yourself.
	testObject1 := SqsTestObjectEvenDeeperChild new
		testSubString: 'foo-bar';
		testInteger: 42;
		testSomething: (OrderedCollection with: testObject);
		yourself.
	testObject1 save.
	testObject1 := nil.
	SqsStorage flushObjectCache.
	testResult := SqsTestObjectChild findByTestSubString: 'foo-bar'.
	self assert: testResult notNil.
	self assert: (testResult testSomething class includesBehavior: SqsProxy).
	self assert: testResult testSomething sqsProxiedObject isNil.
	testResult testSomething at: 1.
	self assert: testResult testSomething sqsProxiedObject notNil! !

SqsTestCase subclass: #SqsSearchQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsSearchQueryTest subclass: #SqsCTISearchQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsCTISearchQueryTest methodsFor: 'as yet unclassified' stamp: 'tkow 3/1/2009 17:18'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.! !

SqsSearchQueryTest subclass: #SqsSTISearchQueryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsSTISearchQueryTest methodsFor: 'as yet unclassified' stamp: 'tkow 3/1/2009 17:19'!
setUp
	super setUp.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.! !

!SqsSearchQueryTest class methodsFor: 'as yet unclassified' stamp: 'tkow 3/1/2009 17:24'!
shouldInheritSelectors
	^ true! !

!SqsSearchQueryTest methodsFor: 'running' stamp: 'tkow 3/1/2009 17:17'!
setUp
	self setupTestConnection.
	self removeDescriptions.
	self clearDatabase.
! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/27/2009 13:14'!
testComplexQueries
	| testObject query testObject2 compSql oidField |

	testObject2 := SqsTestObject new testInteger: 21.
	testObject := SqsTestObject new
		testString: 'test';
		testInteger: 42;
		testBool: true;
		testSomething: testObject2;
		testDate: Date today.
	testObject save.
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testSomething testInteger = 21 ].
	oidField := (SqsClassInfo for: SqsTestObject) configuration tableConfiguration idField.
	self assert: query whereBuffer = ('(sqs_test_objects.test_something_id = sqs_test_objects_1.' , oidField , ') AND sqs_test_objects_1.test_integer = 21').
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testSomething = testObject2 ].
	self assert: query whereBuffer = ('sqs_test_objects.test_something_id = ' , testObject2 oid asString).
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testSomething testSomething testSomething = testObject2 ].
	compSql := '((sqs_test_objects.test_something_id = sqs_test_objects_1.' , oidField , ') AND '.
	compSql := compSql , 'sqs_test_objects_1.test_something_id = sqs_test_objects_2.' , oidField , ') AND '.
	compSql := compSql , 'sqs_test_objects_2.test_something_id = ' , testObject2 oid asString.
	self assert: query whereBuffer = compSql! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/28/2009 15:27'!
testConcatenatedCollectionAnySatisfyQuery
	| testObject1 testObject2 results testObject3 |
	testObject3 := SqsTestObject new
		testInteger: 21;
		yourself.
	
	testObject1 := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: testObject3);
		yourself.
	
	"sorry for the testBool abuse, but you'll get the point, I guess'"	
	testObject2 := SqsTestObject new
		testInteger: 42;
		testBool: testObject1;
		yourself.
		
	testObject2 deepSave.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething anySatisfy: [:aTestObject | aTestObject testInteger = 21]].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 42.
	
	testObject1 testSomething: (OrderedCollection with: 12).
	testObject1 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething anySatisfy: [:aValue | aValue = 12]].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 42.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/28/2009 15:27'!
testConcatenatedCollectionIncludesQuery
	| testObject1 testObject2 results testObject3 |
	testObject3 := SqsTestObject new
		testInteger: 21;
		yourself.
	
	testObject1 := SqsTestObject new
		testInteger: 84;
		testSomething: (OrderedCollection with: testObject3);
		yourself.
	
	"sorry for the testBool abuse, but you'll get the point, I guess'"	
	testObject2 := SqsTestObject new
		testInteger: 42;
		testBool: testObject1;
		yourself.
		
	testObject2 deepSave.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething includes: testObject3].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 42.
	
	testObject1 testSomething: (OrderedCollection with: 12).
	testObject1 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething includes: 12].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 42.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 1/27/2009 13:28'!
testConcatenatedCollectionSizeQuery
	| testObject1 testObject2 results |
	testObject1 := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: 5 with: 6 with: 7 with: 8)
		yourself.
	
	"sorry for the testBool abuse, but you'll get the point, I guess'"	
	testObject2 := SqsTestObject new
		testInteger: 42;
		testBool: testObject1;
		yourself.
		
	testObject1 save.
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testBool testSomething size = 4].
	self assert: results size = 1.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/5/2009 13:10'!
testDateQueries
	| testObject1 testObject2 results |
	"this is a Thursday"
	testObject1 := SqsTestObjectEvenDeeperChild new
		testDate: (Date year: 2009 month: 2 day: 5);
		yourself.
		
	"and a sunday"
	testObject2 := SqsTestObjectEvenDeeperChild new
		testDate: (Date year: 2008 month: 2 day: 3);
		yourself.
		
	testObject1 save.
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate dayOfMonth > 3].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject1.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate dayOfYear < 35].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject2.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate dayOfWeek = 1].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject2.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate day = 36].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject1.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate monthIndex = 2].
	self assert: results size = 2.

	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate monthName = #February].
	self assert: results size = 2.

	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate year > 2008].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject1.		
	! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/5/2009 13:56'!
testDateTimeQueries
	| testObject1 testObject2 results |
	"this is a Thursday"
	testObject1 := SqsTestObjectEvenDeeperChild new
		testDate: (DateAndTime year: 2009 month: 2 day: 5 hour: 4 minute: 20 second: 29);
		yourself.
		
	"and a sunday"
	testObject2 := SqsTestObjectEvenDeeperChild new
		testDate: (DateAndTime year: 2009 month: 2 day: 5 hour: 16 minute: 40 second: 31);
		yourself.
		
	testObject1 save.
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate hour > 3].
	self assert: results size = 2.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testDate hour24 > 15].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject2.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | ((anObj testDate second - 30) abs) = 1].
	self assert: results size = 2.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | (anObj testDate minute \\ 20) = 0].
	self assert: results size = 2.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/20/2009 15:52'!
testFindAll
	| to1 to2 to3 to4 to5 results |
	to1 := SqsTestObject new
		testInteger: 42;
		save;
		yourself.
		
	to2 := SqsTestObject new
		testInteger: 21;
		save;
		yourself.
		
	to3 := SqsTestObjectChild new
		testString: 'foo';
		save;
		yourself.
		
	to4 := SqsTestObjectChild new
		testString: 'foo';
		save;
		yourself.
		
	to5 := SqsTestObjectEvenDeeperChild new
		testDate: Date today;
		save;
		yourself.
		
	results := (SqsSearch for: SqsTestObject) findAll.
	self assert: results size = 5.
	
	results := (SqsSearch for: SqsTestObjectChild) findAll.
	self assert: results size = 3.
	
	results := (SqsSearch for: SqsTestObjectEvenDeeperChild) findAll.
	self assert: results size = 1.
	
	
		
! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/16/2009 16:52'!
testFindCorrectColumn
	| queryObject classTable |
	queryObject := SqsQueryObject new.
	classTable := (SqsClassInfo for: SqsTestObject) newClassTable.
	self assert: (queryObject 
			sqsFindColumnFor: #testInteger
			inTable: classTable) isNil not.
	self assert: (queryObject 
			sqsFindColumnFor: #testSubString
			inTable: classTable) isNil not.
	self assert: (queryObject 
			sqsFindColumnFor: #testExtremelyDeepSubString
			inTable: classTable) isNil not.
	self assert: (queryObject 
			sqsFindColumnFor: #testNonExistentColumn
			inTable: classTable) isNil.
			! !

!SqsSearchQueryTest methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:07'!
testReferenceToSubclassElementWithinCollection
	| testObject testObject2 results |
	testObject := SqsTestObjectChild new
		testSubString: 'foo';
		testInteger: 21;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 42;
		testString: 'bar';
		testSomething: (OrderedCollection with: testObject);
		save;
		yourself.

	self shouldnt: [results := (SqsSearch for: SqsTestObject) select: [:obj | obj testSomething anySatisfy: [:el | el testSubString = 'foo' & (el testInteger < obj testInteger)]].] raise: Error.
	self assert: results notEmpty.
	self assert: (results at: 1) testInteger = 42.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 2/27/2009 21:04'!
testReferencingAnObjectTwiceInOneQuery
	| testObject testObject2 testResult testObject3 |
	testObject := SqsTestObject new
		testInteger: 42;
		testString: 'foo';
		save;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 84;
		testString: 'bar';
		testSomething: testObject;
		save;
		yourself.
		
	testResult := (SqsSearch for: SqsTestObject) detect: [:obj | (obj testSomething testString = 'foo') & (obj testInteger = 84)].
	self assert: testResult notNil.
	self assert: testResult = testObject2.
	
	testResult := (SqsSearch for: SqsTestObject) detect: [:obj | (obj testSomething testString = 'foo') & (obj testInteger = 42)] ifNone: [nil].
	self assert: testResult isNil.
	
	testObject3 := SqsTestObjectConnector new
		test1: 'test';
		save;
		yourself.
		
	testObject2 testSomething: testObject3.
	testObject2 save.
	testResult := (SqsSearch for: SqsTestObject) detect: [:obj | (obj testSomething test1 = 'test') & (obj testInteger = 84)].
	self assert: testResult notNil.
	self assert: testResult = testObject2.
! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 3/6/2009 13:28'!
testReferencingAnObjectTwiceInOneQueryInCollection
	| testObject testObject2 testResult testObject3 |
	testObject := SqsTestObject new
		testInteger: 42;
		testString: 'bar';
		save;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 84;
		testString: 'foo';
		testSomething: (OrderedCollection with: testObject);
		save;
		yourself.
		
	testResult := (SqsSearch for: SqsTestObject) detect: [:obj | obj testSomething anySatisfy: [:colObj | obj testInteger > colObj testInteger]].
	self assert: testResult notNil.
	self assert: testResult testInteger = 84.
	
	testResult := (SqsSearch for: SqsTestObject) detect: [:obj | obj testSomething anySatisfy: [:colObj | obj testInteger < colObj testInteger]] ifNone: [nil].
	self assert: testResult isNil.
	
	testObject3 := SqsTestObjectConnector new
		test1: 'foo';
		save;
		yourself.
		
	testObject2 testSomething: (OrderedCollection with: testObject3).
	testObject2 save.
	testResult := (SqsSearch for: SqsTestObject) detect: [:obj | obj testSomething anySatisfy: [:colObj | obj testString = colObj test1]].
	self assert: testResult notNil.
	self assert: testResult testInteger = 84.
! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 3/6/2009 13:26'!
testSimpleCollectionAnySatisfiesQuery
	| testObject1 testObject2 results |
	testObject1 := SqsTestObject new
		testInteger: 42;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject1);
		yourself.
		
	testObject2 save.

	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething anySatisfy: [:anObj | anObj = testObject1]].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 21.
	
	testObject2 testSomething: (OrderedCollection with: 1).
	testObject2 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething anySatisfy: [:anObj | anObj > 0]].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 21.
	! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 20:28'!
testSimpleCollectionIncludesQuery
	| testObject1 testObject2 results |
	testObject1 := SqsTestObject new
		testInteger: 42;
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject1);
		yourself.
		
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething includes: testObject1].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 21.
	
	testObject2 testSomething: (OrderedCollection with: 1).
	testObject2 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething includes: 1].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 21.
	! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/26/2009 20:54'!
testSimpleCollectionSizeQuery
	| testObject1 testObject2 results |
	testObject1 := SqsTestObject new
		testInteger: 84;
		testSomething: (OrderedCollection with: 1 with: 2 with: 3 with: 4);
		yourself.
		
	testObject2 := SqsTestObject new
		testInteger: 42;
		testSomething: (OrderedCollection with: 5 with: 6 with: 7 with: 8);
		yourself.
		
	testObject1 save.
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething size = 4].
	self assert: results size = 2.
	
	testObject2 testSomething add: 11.
	testObject2 save.
	results := (SqsSearch for: SqsTestObject) select: [:anObject | anObject testSomething size = 4].
	self assert: results size = 1.
	self assert: (results at: 1) testInteger = 84.! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 2/2/2009 14:38'!
testSimpleQueries
	| testObject query compSql oidField |

	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'test';
		testInteger: 42;
		testBool: true;
		testSomething: 4.123;
		testDate: Date today;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'subberString'.
	(SqsStorage for: testObject) createClassDescription.
	oidField := (SqsClassInfo for: SqsTestObject) configuration tableConfiguration idField.
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testInteger = 5 ].
	self assert: query whereBuffer = 'sqs_test_objects.test_integer = 5'.

	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj oid = 5 ].
	self assert: query whereBuffer = ('sqs_test_objects.' , oidField , ' = 5').
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testDate = Date today ].
	self assert: query whereBuffer = ('sqs_test_objects.test_date = ' , Date today asSqlValueString).
	query := (SqsQuery new on: SqsTestObject) analyze: [ :obj | obj testBool = true ].
	self assert: query whereBuffer = 'sqs_test_objects.test_bool = TRUE'.
	query := (SqsQuery new on: SqsTestObjectEvenDeeperChild) analyze: [ :obj | obj testExtremelyDeepSubString = 'test' ].
	self assert: query whereBuffer = 'sqs_test_object_even_deeper_childs.test_extremely_deep_sub_string = ''test'''.
	testObject testExtremelyDeepSubString: SqsTestObject new.
	(SqsStorage for: testObject) createClassDescription.

	"this should be the probably most complicated query to process - associated element in a sub-table"
	query := (SqsQuery new on: SqsTestObjectEvenDeeperChild) analyze: [ :obj | obj testExtremelyDeepSubString testSubString = 'test' ].
	compSql := '(sqs_test_object_even_deeper_childs.test_extremely_deep_sub_string_id = sqs_test_object_childs_1.' , oidField , ') AND '.
	compSql := compSql , 'sqs_test_object_childs_1.test_sub_string = ''test'''.
	self assert: query whereBuffer = compSql! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'test 2/2/2009 13:21'!
testSimplestQuery
	| testObject results |

	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	testObject := SqsTestObjectEvenDeeperChild new
		testString: 'test';
		testInteger: 42;
		testBool: true;
		testSomething: 4.123;
		testDate: Date today;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'subberString'.

	testObject save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj = testObject].
	self assert: (results size = 1).
	self assert: ((results at: 1) = testObject).! !

!SqsSearchQueryTest methodsFor: 'tests' stamp: 'tkow 2/5/2009 13:39'!
testStringQueries
	| testObject1 testObject2 results |
	testObject1 := SqsTestObjectEvenDeeperChild new
		testExtremelyDeepSubString: #HalloWelt;
		yourself.
		
	testObject2 := SqsTestObjectEvenDeeperChild new
		testExtremelyDeepSubString: #Hallo;
		yourself.
		
	testObject1 save.
	testObject2 save.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testExtremelyDeepSubString size > 5].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject1.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testExtremelyDeepSubString beginsWith: 'Hallo'].
	self assert: results size = 2.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testExtremelyDeepSubString endsWith: 'Welt'].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject1.
	
	results := (SqsSearch for: SqsTestObject) select: [:anObj | anObj testExtremelyDeepSubString includesSubString: 'lloWel'].
	self assert: results size = 1.
	self assert: (results at: 1) = testObject1.! !

SqsTestCase subclass: #SqsStaggeredCacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsStaggeredCacheTest methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 20:55'!
testCacheIndex
	| cache |
	cache := SqsStaggeredIdCache new.
	self assert: (cache cacheIndexFor: 1) = 1.
	self assert: (cache cacheIndexFor: 2) = 1.
	self assert: (cache cacheIndexFor: 1023) = 1.
	self assert: (cache cacheIndexFor: 1024) = 2.
	self assert: (cache cacheIndexFor: 1025) = 2.
	self assert: (cache cacheIndexFor: 2048) = 3.
	
! !

!SqsStaggeredCacheTest methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 20:57'!
testSubCacheIndex
	| cache |
	cache := SqsStaggeredIdCache new.
	self assert: (cache subCacheIndexFor: 1) = 1.
	self assert: (cache subCacheIndexFor: 2) = 2.
	self assert: (cache subCacheIndexFor: 1023) = 1023.
	self assert: (cache subCacheIndexFor: 1024) = 1024.
	self assert: (cache subCacheIndexFor: 1025) = 1.
	self assert: (cache subCacheIndexFor: 1026) = 2.
	self assert: (cache subCacheIndexFor: 2048) = 1024.	! !

SqsTestCase subclass: #SqsStringExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tkow 11/10/2008 16:42'!
testAsSqSaveDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #sqsDescrAInstanceVariable).
	! !

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tkow 12/12/2008 18:00'!
testAsSqSaveDescriptorClassName
	'SqSaveTestObject' asSqSaveDescriptorClassName = #SqsTestObjectPersistenceDescriptor.
	'sqSaveTestObjectEvenDeeperChild' asSqSaveDescriptorClassName = #SqsTestObjectEvenDeeperChildPersistenceDescriptor! !

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/24/2008 15:33'!
testAsSqSaveTableName
	| testString |
	testString := 'TKSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'tk_save_test_objects').
	testString := 'SqSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'sq_save_test_objects').
	testString := 'SqSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'sqsave_test_objects').
	testString := 'TKSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'tksave_test_objects').
	! !

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/14/2008 17:45'!
testCollectionJoin
	self assert: ((#('hallo' 'welt') join: '-') = 'hallo-welt').
	self assert: ((#('hallo' 'welt') join: '') = 'hallowelt').
	self assert: ((#('hallo' 'welt') join: nil) = 'hallowelt')! !

!SqsStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/7/2008 16:48'!
testDecamelized
	self assert: 'sq_save_type_field' decamelized = 'sq_save_type_field'.
	self assert: 'SqSaveTypeField' decamelized = 'sq_save_type_field'.! !

SqsTestCase subclass: #SqsTableCacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTableCacheTest methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
testCorrectCacheCreationCTI
	| testObject tableCache testObject2 |
	self setupTestConnection.
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	testObject := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject save.
	tableCache := (SqsClassInfo for: SqsTestObject) tableStructureHandler tableCache tableCache.
	self assert: (tableCache includesKey: SqsTestObject name).
	self assert: ((tableCache at: SqsTestObject name) includesKey: SqsTableCache existenceKey).
	
	testObject2 := SqsTestObjectChild new
		testInteger: 12;
		yourself.
	testObject2 save.
	
	self assert: (tableCache includesKey: SqsTestObjectChild name).
	self assert: ((tableCache at: SqsTestObjectChild name) includesKey: SqsTableCache existenceKey).! !

!SqsTableCacheTest methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
testCorrectCacheCreationSTI
	| testObject tableCache testObject2 |
	self setupTestConnection.
	self clearDatabase.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	testObject := SqsTestObject new
		testInteger: 42;
		yourself.
	testObject save.
	tableCache := (SqsClassInfo for: SqsTestObject) tableStructureHandler tableCache tableCache.
	self assert: (tableCache includesKey: SqsTestObject name).
	self assert: ((tableCache at: SqsTestObject name) includesKey: SqsTableCache existenceKey).
	testObject2 := SqsTestObjectChild new
		testInteger: 12;
		yourself.
	testObject2 save.
	self assert: (tableCache includesKey: SqsTestObjectChild name) not! !

SqsTestCase subclass: #SqsTableChangesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:54'!
testCorrectClassChoosing
	| sampleObject |
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	sampleObject := SqsStorage for: SqsTestObject new.
	self assert: (SqsTableStructureHandler forObject: sampleObject) class = SqsSingleTableInheritanceHandler.
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	sampleObject := SqsStorage for: SqsTestObject new.
	self assert: (SqsTableStructureHandler forObject: sampleObject) class = SqsClassTableInheritanceHandler! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testFindAlteredColumns
	| oldColumn newColumn oldTable newTable tableChanges |
	oldColumn := SqsColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqsColumn new
		linkedVariable: 'test_var';
		sqlType: #string;
		columnName: 'test_column_1'.
	oldTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
	tableChanges := (SqsTableChanges 
		oldTable: oldTable
		newTable: newTable) calculateChanges.
	self assert: tableChanges alteredColumns isEmpty not.
	self assert: tableChanges alteredColumns anyOne = newColumn! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 2/19/2009 19:51'!
testFindChangedConstraints
	| oldFk newFk tableChanges oldColumn newColumn |
	tableChanges := SqsTableChanges new.
	
	oldFk := SqsForeignKeyDescription new
		referencedTable: 'table';
		referencedColumns: #('test_col');
		referencingColumns: #('test_ref');
		yourself.
		
	newFk := SqsForeignKeyDescription new
		referencedTable: 'table';
		referencedColumns: #('test_col_2');
		referencingColumns: #('test_ref_2');
		yourself.
		
	oldColumn := SqsColumn new.
	newColumn := SqsColumn new.
	
	"no keys, no changes"
	tableChanges checkConstraintChangesFrom: oldColumn to: newColumn.
	self assert: tableChanges addedConstraints isEmpty.
	self assert: tableChanges removedConstraints isEmpty.
	
	"old key no longer present"
	oldColumn foreignKey: oldFk.
	tableChanges checkConstraintChangesFrom: oldColumn to: newColumn.
	self assert: tableChanges addedConstraints isEmpty.
	self assert: tableChanges removedConstraints size = 1.
	self assert: tableChanges removedConstraints includes: oldFk.
	
	"new constraint while no old one is there"
	tableChanges := SqsTableChanges new.
	tableChanges checkConstraintChangesFrom: newColumn to: oldColumn.
	self assert: tableChanges removedConstraints isEmpty.
	self assert: tableChanges addedConstraints size = 1.
	self assert: tableChanges addedConstraints includes: oldFk.
	
	"same constraint in both columns - no changes"
	tableChanges := SqsTableChanges new.
	tableChanges checkConstraintChangesFrom: oldColumn to: oldColumn.
	self assert: tableChanges removedConstraints isEmpty.
	self assert: tableChanges addedConstraints isEmpty.
	
	"differing constraints - remove old, add new"
	tableChanges := SqsTableChanges new.
	newColumn foreignKey: newFk.
	
	tableChanges checkConstraintChangesFrom: oldColumn to: newColumn.
	self assert: tableChanges removedConstraints size = 1.
	self assert: tableChanges removedConstraints includes: oldFk.
	self assert: tableChanges addedConstraints size = 1.
	self assert: tableChanges addedConstraints includes: newFk.
	
	
	 ! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testFindChangedTableName
	| oldTable newTable changes |
	oldTable := SqsTable new tableName: 'testTable1'.
	newTable := SqsTable new tableName: 'testTable2'.
	changes := SqsTableChanges 
		oldTable: oldTable
		newTable: newTable.
	self assert: changes newTableName isNil not.
	self assert: changes newTableName = 'testTable2'! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testFindRemovedAndAddedColumns
	| oldColumn newColumn oldTable newTable tableChanges |
	oldColumn := SqsColumn new
		linkedVariable: 'test_var_1';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqsColumn new
		linkedVariable: 'test_var_2';
		sqlType: #integer;
		columnName: 'test_column_1'.
	oldTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
	tableChanges := (SqsTableChanges 
		oldTable: oldTable
		newTable: newTable) calculateChanges.
	self assert: tableChanges removedColumns isEmpty not.
	self assert: tableChanges removedColumns anyOne = oldColumn.
	self assert: tableChanges addedColumns isEmpty not.
	self assert: tableChanges addedColumns anyOne = newColumn! !

!SqsTableChangesTest methodsFor: 'tests' stamp: 'tkow 12/12/2008 17:41'!
testFindRenamedColumns
	| oldColumn newColumn changed oldTable newTable tableChanges |
	oldColumn := SqsColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_1'.
	newColumn := SqsColumn new
		linkedVariable: 'test_var';
		sqlType: #integer;
		columnName: 'test_column_2'.
	oldTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: oldColumn).
	newTable := SqsTable new
		tableName: 'testTable1';
		columns: (OrderedCollection with: newColumn).
	tableChanges := (SqsTableChanges 
		oldTable: oldTable
		newTable: newTable) calculateChanges.
	self assert: tableChanges renamedColumns isEmpty not.
	changed := tableChanges renamedColumns anyOne.
	self assert: changed first = oldColumn.
	self assert: changed last = newColumn! !

SqsTestCase subclass: #SqsTableStructureHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTableStructureHandlerTest methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:20'!
setUp
	self setupTestConnection.
	self clearDatabase.! !

!SqsTableStructureHandlerTest methodsFor: 'tests' stamp: 'tkow 2/25/2009 15:49'!
testCacheFillingWithLazyCollections
	| testObject tableCache toCache tocCache toedcCache classIndex joinIndex joinTables testStorage testObject2 changes joinTable |
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler classTableInheritance.
	self clearDatabase.
	self removeDescriptions.
	
	classIndex := SqsTableCache classTableKey.
	joinIndex := SqsTableCache joinTableKey.
	testObject := SqsTestObjectEvenDeeperChild new
		testSubString: 'test';
		testExtremelyDeepSubString: 'test2';
		testInteger: 42;
		yourself.
	testObject2 := SqsTestObject new
		testInteger: 21;
		yourself.
	testStorage := SqsStorage for: testObject.
	testStorage save.
	tableCache := testStorage tableStructureHandler tableCache.
	toCache := tableCache tableCache 
		at: SqsTestObject name
		ifAbsent: [ nil ].
	tocCache := tableCache tableCache 
		at: SqsTestObjectChild name
		ifAbsent: [ nil ].
	toedcCache := tableCache tableCache 
		at: SqsTestObjectEvenDeeperChild name
		ifAbsent: [ nil ].
	self assert: ((toCache notNil and: [ tocCache notNil ]) and: [ toedcCache notNil ]).
	self 
		shouldnt: [ toCache at: classIndex ]
		raise: Error.
	self 
		shouldnt: [ tocCache at: classIndex ]
		raise: Error.
	self 
		shouldnt: [ toedcCache at: classIndex ]
		raise: Error.
	self 
		should: [ joinTables := toCache at: joinIndex ]
		raise: Error.
	testObject testSomething: (OrderedCollection with: testObject2).
	testStorage createClassDescription.
	changes := testStorage tableStructureHandler getTableChanges.
	"one empty changes object for all subclasses"
	self assert: changes size = 3.

	"more interesting now are the join tables. one should be inserted in the cache right now"
	joinTables := toCache 
		at: joinIndex
		ifAbsent: [ nil ].
	self assert: joinTables notNil.
	self assert: joinTables size = 1.
	joinTable := joinTables anyOne value.
	self assert: joinTable tableName = 'sqs_test_objects_test_something'! !

!SqsTableStructureHandlerTest methodsFor: 'tests' stamp: 'tkow 2/16/2009 16:54'!
testColumnValueDictionaryCreation
	| testObject storage columnValueDict |
	self setTestObjectInheritanceModeTo: SqsTableStructureHandler singleTableInheritance.
	self removeDescriptions.
	testObject := SqsTestObjectEvenDeeperChild new
		testBool: true;
		testInteger: 42;
		testSomething: 4.12;
		testDate: Date today;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'subberString';
		testString: 'string'.
	storage := SqsStorage for: testObject.
	storage createClassDescription.
	columnValueDict := storage tableStructureHandler columnValueDictionaryFor: storage classInfo newClassTable.
	self assert: (columnValueDict includesKey: storage classInfo configuration tableConfiguration idField) not.
	self assert: (columnValueDict includesKey: 'test_bool').
	self assert: (columnValueDict at: 'test_bool') = true asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_integer').
	self assert: (columnValueDict at: 'test_integer') = 42 asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_something').
	self assert: (columnValueDict at: 'test_something') = 4.12 asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_date').
	self assert: (columnValueDict at: 'test_date') = Date today asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_sub_string').
	self assert: (columnValueDict at: 'test_sub_string') = 'subString' asSqlValueString.
	self assert: (columnValueDict includesKey: 'test_extremely_deep_sub_string').
	self assert: (columnValueDict at: 'test_extremely_deep_sub_string') = 'subberString' asSqlValueString! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 2/25/2009 15:49'!
clearDatabase
	connection resetDatabase.
	SqsTableStructureHandler clearTableCacheFor: self standardConnectionSpecification connectionIdentityString.
! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 10/6/2008 17:56'!
descriptorMethodCategory
	^'persistence-description'! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 3/8/2009 23:53'!
mysqlConnectionSpecification
	^ SqsMySQLConnectionSpecification 
		user: self standardUser
		password: self standardPassword
		database: self standardDatabase! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 3/6/2009 14:42'!
postgresConnectionSpecification
	^ SqsPGConnectionSpecification 
		user: self standardUser
		password: self standardPassword
		database: self standardDatabase
! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 12/12/2008 17:54'!
removeDescriptions
	| classes targetClass |
	targetClass := (SqsClassInfo for: SqsTestObject) descriptionHandler targetClass.
	classes := Set with: targetClass.
	classes addAll: targetClass allSubclasses.
	classes do: 
		[ :curClass | 
		(curClass class selectors select: [ :selector | selector prefixMatchesRegex: '' asSqSaveDescriptionSelector ]) do: [ :selector | curClass class removeSelector: selector ] ]! !

!SqsTestCase methodsFor: 'running' stamp: 'tkow 2/23/2009 16:47'!
setTestObjectInheritanceModeTo: inheritanceMode 
	| config |
	config := SqsConfiguration conSpec: self standardConnectionSpecification.
	config tableConfiguration inheritanceMode: inheritanceMode.
	SqsConnectionManager getInstance setConfiguration: config for: self standardCategory.! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 2/23/2009 16:46'!
setupTestConnection
	SqsConnectionManager getInstance 
		setConfiguration: self standardConfiguration
		for: self standardCategory.
	connection := (SqsConnectionManager getInstance sessionForCategory: self standardCategory) sqsDbAdapter! !

!SqsTestCase methodsFor: 'test-assertions' stamp: 'tkow 10/29/2008 13:40'!
should: aBlock takeMoreThanMilliseconds: delayTime
    | evaluated evaluationProcess result delay testProcess aDuration |

	evaluated := false.
	aDuration := (Duration milliSeconds: delayTime).
	delay := Delay forDuration: aDuration.
	testProcess := Processor activeProcess.
	evaluationProcess := [
		result := aBlock value.
		evaluated := true.
		delay unschedule.
		testProcess resume ] forkNamed: 'Process to evaluate should: notTakeMoreThanMilliseconds:'.

	delay wait.
	evaluated ifTrue: [
		self assert: false description: ('Block evaluation took less than the expected <1p>' expandMacrosWith: aDuration)
	] ifFalse: [
	 	evaluationProcess terminate
	].
    ^result! !

!SqsTestCase methodsFor: 'running' stamp: 'tkow 2/23/2009 16:45'!
standardCategory
	^ #SqSave! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 2/23/2009 16:46'!
standardConfiguration
	^ SqsConfiguration conSpec: self standardConnectionSpecification! !

!SqsTestCase methodsFor: 'private' stamp: 'tkow 3/8/2009 23:52'!
standardConnectionSpecification
	^ self mysqlConnectionSpecification! !

!SqsTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:15'!
standardDatabase
	^'squeak_test'! !

!SqsTestCase methodsFor: 'standard values' stamp: 'tkow 11/3/2008 14:14'!
standardPassword
	^'test'! !

!SqsTestCase methodsFor: 'standard values' stamp: 'test 1/22/2009 14:34'!
standardUser
	^'test'! !

WAComponent subclass: #SqsBlogLoggedInComponent
	instanceVariableNames: 'menuComponent taskEditor report filterBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/14/2008 13:20'!
children

	^ Array with: self menuComponent with: self report! !

!SqsBlogLoggedInComponent methodsFor: 'actions' stamp: 'dt 4/14/2008 13:24'!
createNewTask

	| task |
	task := self call: StTask new asComponent addValidatedForm.
	task ifNotNil: [self session database
		addTask: task toUser: self session user.
		self refreshReport].! !

!SqsBlogLoggedInComponent methodsFor: 'actions' stamp: 'dt 4/14/2008 13:25'!
editTask: aTask

	| task |
	task := self call: (aTask descriptionEdit asComponentOn: aTask) addValidatedForm.
	task ifNotNil: [self session database save: aTask.
		self refreshReport].! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/14/2008 13:21'!
filterBlock
	^ filterBlock! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/14/2008 13:21'!
filterBlock: anObject
	filterBlock := anObject! !

!SqsBlogLoggedInComponent methodsFor: 'initialize-release' stamp: 'dt 4/14/2008 13:22'!
initialize

	super initialize.
	self
		initializeMenuComponent;
		initializeReport;
		filterBlock: [:item | true].! !

!SqsBlogLoggedInComponent methodsFor: 'initialize-release' stamp: 'tkow 3/1/2009 23:34'!
initializeMenuComponent

	self menuComponent:(SqsBlogMenuComponent new
		addEntry: 'All' withAction: [self showAllTasks];
		addEntry: 'Completed' withAction: [self showCompletedTasks];
		addEntry: 'Pending' withAction: [self showPendingTasks];
		addEntry: 'Missed' withAction: [self showMissedTasks];
		addEntry: 'New Task' withAction: [self createNewTask];
		addEntry: 'Logout' withAction: [self session logout. self answer: true];
		yourself).! !

!SqsBlogLoggedInComponent methodsFor: 'initialize-release' stamp: 'tkow 3/3/2009 13:36'!
initializeReport

"	self report: (MAReport
		rows: self session user blogs
		description: StTask new descriptionReport).
	self report
		addColumn: (MAToggleColumn new
			selector: #completed;
			title: 'Completed';
			setDescription: StTask descriptionCompleted;
			sorter: nil;
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editTask: text: 'edit';
			yourself)."! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
menuComponent

	^ menuComponent! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
menuComponent: anObject

	menuComponent := anObject.! !

!SqsBlogLoggedInComponent methodsFor: 'actions' stamp: 'dt 4/14/2008 13:22'!
refreshReport

	self report rows: (self session user tasks select: self filterBlock).! !

!SqsBlogLoggedInComponent methodsFor: 'rendering' stamp: 'tkow 3/3/2009 13:37'!
renderContentOn: html

	html div
		class: 'generic';
		with:[
			html heading: 'ToDo-List of ', self session user accountData username.
			html div
			class: 'menu';
			with: self menuComponent.
			html div
			class: 'list';
			id: 'list';
			with: self report].! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/14/2008 13:21'!
report
	^ report! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/14/2008 13:21'!
report: anObject
	report := anObject! !

!SqsBlogLoggedInComponent methodsFor: 'actions' stamp: 'dt 4/14/2008 13:23'!
showAllTasks

	self
		filterBlock: [:item | true];
		refreshReport.! !

!SqsBlogLoggedInComponent methodsFor: 'actions' stamp: 'dt 4/14/2008 13:23'!
showCompletedTasks

	self
		filterBlock: [:item | item completed];
		refreshReport.! !

!SqsBlogLoggedInComponent methodsFor: 'actions' stamp: 'dt 4/14/2008 13:23'!
showMissedTasks

	self
		filterBlock: [:item | item isMissed];
		refreshReport.! !

!SqsBlogLoggedInComponent methodsFor: 'actions' stamp: 'dt 4/14/2008 13:24'!
showPendingTasks

	self
		filterBlock: [:item | item isPending];
		refreshReport.! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:36'!
taskEditor
    
	^ taskEditor ifNil: [taskEditor := SqsBlogTaskEditor new]! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
taskEditor: anObject

	taskEditor := anObject.! !

!SqsBlogLoggedInComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:33'!
testTasks

	^ OrderedCollection
		with: (StTask new
			deadline: Date yesterday;
			completed: false;
			taskName: 'Missed task')
		with: (StTask new
			deadline: Date tomorrow;
			completed: false;
			taskName: 'Pending task')
		with: (StTask new
			deadline: Date tomorrow;
			completed: true;
			taskName: 'Already completed task')! !

WAComponent subclass: #SqsBlogLoginComponent
	instanceVariableNames: 'email password messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogLoginComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:51'!
applicationName

	^ StToDoLibrary applicationName ! !

!SqsBlogLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:34'!
email

	^ email! !

!SqsBlogLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
email: anObject

	email := anObject.! !

!SqsBlogLoginComponent methodsFor: 'actions' stamp: 'micper 4/10/2008 10:37'!
hashPassword: aString

	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].
	! !

!SqsBlogLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:31'!
loginFailed

	self messageComponent errorMessage: 'Login failed.'.! !

!SqsBlogLoginComponent methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:35'!
messageComponent

	^ messageComponent ifNil: [messageComponent := SqsBlogMessageComponent new]! !

!SqsBlogLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
messageComponent: anObject

	messageComponent := anObject.! !

!SqsBlogLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
password

	^ password! !

!SqsBlogLoginComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:35'!
password: anObject

	password := anObject.! !

!SqsBlogLoginComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 12:32'!
registerUser
	
	self answer: #registerUser.! !

!SqsBlogLoginComponent methodsFor: 'rendering' stamp: 'dt 4/11/2008 19:57'!
renderContentOn: html

	html div
	class: 'generic';
	with: [
		html
			heading: self applicationName;
			render: self messageComponent;
			text: 'Please login with e-mail and password:';
			form: [
				self
					renderTextInputOn: html;
					renderPasswordInputOn: html;
					renderLoginButtonOn: html;
					renderSignUpAnchorOn: html]].! !

!SqsBlogLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:15'!
renderLoginButtonOn: html

	html submitButton
		callback: [self validateLogin];
		text: 'Login'.! !

!SqsBlogLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:15'!
renderPasswordInputOn: html

	html passwordInput
		callback: [:value | self password: (self hashPassword: value)];
		value: ''.! !

!SqsBlogLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:16'!
renderSignUpAnchorOn: html

	html paragraph with: [html anchor
		callback: [self registerUser];
		with: [html text: 'Sign up for the ', self applicationName]].! !

!SqsBlogLoginComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:14'!
renderTextInputOn: html

	html textInput
		on: #email of: self;
		value: ''.
	html space.! !

!SqsBlogLoginComponent methodsFor: 'actions' stamp: 'tkow 3/3/2009 14:20'!
validateLogin

	| user |
	user := self session findUserByEmail: self email.
	(user notNil and: [user accountData password = self password])
		ifTrue: [self answer: user]
		ifFalse: [self loginFailed].! !

WAComponent subclass: #SqsBlogMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogMenuComponent methodsFor: 'accessing' stamp: 'micper 4/9/2008 10:21'!
addEntry: aString withAction: aBlock
	
	^ self entries add: aString -> aBlock! !

!SqsBlogMenuComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:36'!
entries

	^ entries! !

!SqsBlogMenuComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
entries: anObject

	entries := anObject.! !

!SqsBlogMenuComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:23'!
initialize

	super initialize.
	self entries: OrderedCollection new.! !

!SqsBlogMenuComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:22'!
renderContentOn: html

	self entries
		do: [:entry |
			html anchor
				callback: entry value;
				with: entry key]
		separatedBy: [html space].! !

WAComponent subclass: #SqsBlogMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogMessageComponent commentStamp: 'ab 7/17/2007 14:36' prior: 0!
I can display information messages like errors or confirmations!

!SqsBlogMessageComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:17'!
errorMessage: aString

	self
		messageString: aString;
		messageType: 'error';
		wasShown: false.! !

!SqsBlogMessageComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:18'!
infoMessage: aString

	self
		messageString: aString;
		messageType: 'info';
		wasShown: false.! !

!SqsBlogMessageComponent methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 13:15'!
initialize

	super initialize.
	self wasShown: true.! !

!SqsBlogMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageString

	^ messageString! !

!SqsBlogMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageString: anObject

	messageString := anObject.! !

!SqsBlogMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageType

	^ messageType! !

!SqsBlogMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
messageType: anObject

	messageType := anObject.! !

!SqsBlogMessageComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 13:18'!
renderContentOn: html

	self wasShown ifTrue: [^ self].
	html div
		class: self messageType, 'Message';
		with: self messageString.! !

!SqsBlogMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
wasShown

	^ wasShown! !

!SqsBlogMessageComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:37'!
wasShown: anObject

	wasShown := anObject.! !

WAComponent subclass: #SqsBlogRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogRegisterComponent methodsFor: 'actions' stamp: 'micper 4/9/2008 13:01'!
hashPassword: aString
	
	aString 
		ifEmpty: [^ 0] 
		ifNotEmpty: [^ SecureHashAlgorithm new hashMessage: aString].! !

!SqsBlogRegisterComponent methodsFor: 'initialize-release' stamp: 'tkow 3/1/2009 23:52'!
initialize

	super initialize.
	self user: SqsUser new.
	! !

!SqsBlogRegisterComponent methodsFor: 'accessing' stamp: 'tkow 3/2/2009 00:17'!
messageComponent

	^ messageComponent ifNil: [messageComponent := SqsBlogMessageComponent new]! !

!SqsBlogRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:38'!
messageComponent: anObject

	messageComponent := anObject.! !

!SqsBlogRegisterComponent methodsFor: 'actions' stamp: 'tkow 3/3/2009 14:19'!
registerUser
    
	self user accountData username isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a username!!'].
	self user accountData email isEmptyOrNil
		ifTrue: [^ self messageComponent infoMessage: 'Please enter your e-mail address!!'].
	(self session findUserByEmail: self user accountData email)
		ifNotNil: [^ self messageComponent errorMessage: 'The e-mail address is already registered!!'].
	self user accountData password = 0
		ifTrue: [^ self messageComponent infoMessage: 'Please choose a password!!'].
	self user accountData password = self repeatedPassword
		ifFalse: [^ self messageComponent infoMessage: 'Your repeated password does not match!!'].
	self session database addUser: self user.
	self answer: self user.! !

!SqsBlogRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:58'!
renderCancelButtonOn: html
	
	html submitButton
		callback: [self answer: nil];
		text: 'Cancel'.! !

!SqsBlogRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:54'!
renderContentOn: html

	html div
		class: 'generic';
		with: [
			html
				heading: 'Register';
				render: self messageComponent;
				form: [
					html table: [
						self
							renderUsernameTextInputOn: html;
							renderEmailTextInputOn: html;
							renderPasswordTextInputOn: html;
							renderRepeatedPasswordTextInputOn: html.
						html tableRow: [
							html
								tableData;
								tableData: [
									self renderSubmitButtonOn: html.
									html space.
									self renderCancelButtonOn: html]]]]].
	! !

!SqsBlogRegisterComponent methodsFor: 'rendering' stamp: 'tkow 3/2/2009 00:15'!
renderEmailTextInputOn: html

	html tableRow: [
		html
			tableData: 'E-mail';
			tableData: [
				html textInput
					callback: [:value | self user accountData email: value];
					value: self user accountData email]].! !

!SqsBlogRegisterComponent methodsFor: 'rendering' stamp: 'tkow 3/2/2009 00:16'!
renderPasswordTextInputOn: html
    
	html tableRow: [
		html
			tableData: 'Password';
			tableData: [
				html passwordInput
					callback: [:value | self user accountData password: (self hashPassword: value)]]].! !

!SqsBlogRegisterComponent methodsFor: 'rendering' stamp: 'dt 4/11/2008 19:48'!
renderRepeatedPasswordTextInputOn: html
  
	html tableRow: [
		html
			tableData: 'Repeat password';
			tableData: [
				html passwordInput
					callback: [:value | self repeatedPassword: (self hashPassword: value)]]].! !

!SqsBlogRegisterComponent methodsFor: 'rendering' stamp: 'micper 4/9/2008 12:57'!
renderSubmitButtonOn: html

	html submitButton
		callback: [self registerUser];
		text: 'Register'.! !

!SqsBlogRegisterComponent methodsFor: 'rendering' stamp: 'tkow 3/2/2009 00:16'!
renderUsernameTextInputOn: html

	html tableRow: [
		html
		tableData: 'Username';
		tableData: [
			html textInput
				callback: [:value | self user accountData username: value];
				value: self user accountData username]].! !

!SqsBlogRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:38'!
repeatedPassword

	^ repeatedPassword! !

!SqsBlogRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
repeatedPassword: anObject

	repeatedPassword := anObject.! !

!SqsBlogRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user

	^ user! !

!SqsBlogRegisterComponent methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user: anObject

	user := anObject.! !

WAComponent subclass: #SqsBlogTaskEditor
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogTaskEditor methodsFor: 'initialize-release' stamp: 'micper 4/9/2008 10:53'!
initialize

	super initialize.
	self task: StTask new.! !

!SqsBlogTaskEditor methodsFor: 'accessing' stamp: 'micper 4/9/2008 11:14'!
newTask

	self task: StTask new.! !

!SqsBlogTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:58'!
renderButtonsOn: html

	html
		tableData;
		tableData: [
			html submitButton
				callback: [self answer: true];
				value: 'Save'.
			html submitButton
				callback: [self answer: false];
				value: 'Cancel'].! !

!SqsBlogTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:57'!
renderCompletedSelectionOn: html

	html
		tableData: [html text: 'Completed: '];
		tableData: [
			html select
				add: true;
				add: false;
				on: #completed of: self task;
				labels: [:value |
					value
						ifTrue: ['yes']
						ifFalse: ['no']]].! !

!SqsBlogTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:55'!
renderContentOn: html

	html div
		class: 'generic lightbox';
		with: [
			html heading: 'Editing task'.
			html form: [
				html table: [
					html
						tableRow: [self renderNameInputOn: html];
						tableRow: [self renderDescriptionInputOn: html];
						tableRow: [self renderDateInputOn: html];
						tableRow: [self renderCompletedSelectionOn: html];
						tableRow: [self renderButtonsOn: html]]]].! !

!SqsBlogTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderDateInputOn: html

	html
		tableData: [html text: 'Deadline: '];
		tableData: [html dateInput on: #deadline of: self task].! !

!SqsBlogTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderDescriptionInputOn: html

	html
		tableData: [html text: 'Description: '];
		tableData: [html textArea on: #taskDescription of: self task].! !

!SqsBlogTaskEditor methodsFor: 'rendering' stamp: 'micper 4/9/2008 10:56'!
renderNameInputOn: html

	html
		tableData: [html text: 'Name: '];
		tableData: [html textInput on: #taskName of: self task].! !

!SqsBlogTaskEditor methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
task

	^ task! !

!SqsBlogTaskEditor methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:41'!
task: anObject

	task := anObject.! !

Object subclass: #OO7Benchmark
	uses: TSqsLogger
	instanceVariableNames: 'scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

OO7Benchmark class
	uses: TSqsLogger classTrait
	instanceVariableNames: ''!

!OO7Benchmark class methodsFor: 'as yet unclassified' stamp: 'test 2/3/2009 14:47'!
scale: anInteger
	^ self new
		scale: anInteger;
		yourself ! !

!OO7Benchmark methodsFor: 'running' stamp: 'test 2/3/2009 15:03'!
chooseAtomicParts: anInteger
	self subclassResponsibility! !

!OO7Benchmark methodsFor: 'running' stamp: 'tkow 2/17/2009 17:42'!
getRangeFrom: min to: max percentage: percentage
	^ ((max - min) * percentage) asInteger + min! !

!OO7Benchmark methodsFor: 'running' stamp: 'test 2/3/2009 15:04'!
query1: atomicPartIds
	self subclassResponsibility! !

!OO7Benchmark methodsFor: 'running' stamp: 'tkow 2/17/2009 17:29'!
query2
	self subclassResponsibility! !

!OO7Benchmark methodsFor: 'running' stamp: 'tkow 2/25/2009 21:12'!
query3
	self subclassResponsibility! !

!OO7Benchmark methodsFor: 'running' stamp: 'tkow 2/25/2009 21:12'!
query4: ids
	self subclassResponsibility! !

!OO7Benchmark methodsFor: 'running' stamp: 'tkow 2/25/2009 21:12'!
query5
	self subclassResponsibility! !

!OO7Benchmark methodsFor: 'running' stamp: 'tkow 2/25/2009 21:13'!
query7
	self subclassResponsibility! !

!OO7Benchmark methodsFor: 'running' stamp: 'tkow 2/25/2009 21:13'!
query8
	self subclassResponsibility! !

!OO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 21:14'!
run
	self runQueries! !

!OO7Benchmark methodsFor: 'running' stamp: 'tkow 2/28/2009 21:23'!
runQueries
	| ids runtime docIds |
	ids := self chooseAtomicParts: 10.
	self log: 'Query: 1'.
	runtime := [self query1: ids] timeToRun.
	self log: 'Query 1 time: ', runtime asString, 'ms'.
	
	self log: 'Query: 2'.
	runtime := [self query2] timeToRun.
	self log: 'Query 2 time: ', runtime asString, 'ms'.
	
	self log: 'Query: 3'.
	runtime := [self query3] timeToRun.
	self log: 'Query 3 time: ', runtime asString, 'ms'.
	
	(scale = 1) ifFalse: [
		docIds := self getRandomDocIds: 100.
		self log: 'Query 4'.
		runtime := [self query4: docIds] timeToRun.
		self log: 'Query 4 time: ', runtime asString, 'ms'.		
	].
	
	self log: 'Query: 5'.
	runtime := [self query5] timeToRun.
	self log: 'Query 5 time: ', runtime asString, 'ms'.
	
	self log: 'Query: 7'.
	runtime := [self query7] timeToRun.
	self log: 'Query 7 time: ', runtime asString, 'ms'.
	
	self log: 'Query: 8'.
	runtime := [self query8] timeToRun.
	self log: 'Query 8 time: ', runtime asString, 'ms'.
	! !

!OO7Benchmark methodsFor: 'accessing' stamp: 'test 2/3/2009 14:48'!
scale
	^ scale! !

!OO7Benchmark methodsFor: 'accessing' stamp: 'test 2/3/2009 14:48'!
scale: anObject
	scale := anObject! !

OO7Benchmark subclass: #SqsOO7Benchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsOO7Benchmark class methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 14:39'!
run: iterations scale: scale
	| benchmark |
	benchmark := self new
		scale: scale;
		yourself.
	benchmark createDatabase.
	iterations timesRepeat: [benchmark run].! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 18:52'!
chooseAtomicParts: noOfParts
	| ids parts |
	ids := Set new.
	parts := (SqsSearch for: SqsAtomicPart) findAll: 100.
	(parts size < noOfParts) ifTrue: [
		self error: 'Less than ', noOfParts asString,' atomic parts in the database'.	
	] ifFalse: [
		1 to: noOfParts do: [:index |
			ids add: (parts at: index) oid
		]
	].
	^ parts
	! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 00:48'!
createDatabase
	| conf database |
	conf := self dbConfiguration.
	"conf environment: SqsConfiguration developmentMode."
	conf environment: SqsConfiguration productionMode.
	self setConfiguration: conf.

	database := SqsOO7Database scale: self scale.
	database truncateDatabase.
	database createOO7Database.
	
	conf environment: SqsConfiguration productionMode.
	self setConfiguration: conf.
! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 02:18'!
dbConfiguration
	| conf |
	conf := SqsConfiguration new.
	conf connectionSpec: (SqsPGConnectionSpecification user: 'test' password: 'test' database: 'oo7_benchmark').
	conf tableConfiguration typeField: 'sqsType'.
	conf tableConfiguration inheritanceMode: SqsTableStructureHandler classTableInheritance.
	conf useInstVarAccessors: false.
	^ conf! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/1/2009 00:10'!
getRandomDocIds: count
	| documents documentIds |
	documents := (SqsSearch for: SqsDocument) findAll: count.
	documentIds := documents collect: [:doc | doc oid].

	documentIds size < count ifTrue: [
		self error: 'too few documents in the database for query 4'
	].

	^ documentIds! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 2/27/2009 20:33'!
initialize
	super initialize.
	self setupProductionConfiguration ! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 20:54'!
query1: ids
	| part |
	ids do: [:id |
		part := (SqsSearch for: SqsAtomicPart) findByOid: id.
		part x.
	]! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 2/17/2009 17:54'!
query2
	| db dateThreshold aBlock |
	db := OO7Database new.
	dateThreshold := self getRangeFrom: db minAtomicDate to: db maxAtomicDate percentage: 0.99.
	aBlock := [(SqsSearch for: SqsAtomicPart) select: [:part | part buildDate > dateThreshold]].
	self queryAtomicParts: aBlock.
	! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 2/17/2009 17:54'!
query3
	| db dateThreshold aBlock |
	db := OO7Database new.
	dateThreshold := self getRangeFrom: db minAtomicDate to: db maxAtomicDate percentage: 0.9.
	aBlock := [(SqsSearch for: SqsAtomicPart) select: [:part | part buildDate > dateThreshold]].
	self queryAtomicParts: aBlock.
	! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 21:00'!
query4: docIds
	| numAssemblies results |
	numAssemblies := 0.
	docIds do: [:id |
		results := (SqsSearch for: SqsBaseAssembly) select: [:ba | ba unsharedParts anySatisfy: [:part | part document = id]].
		results do: [:ba |
			ba buildDate.
			numAssemblies := numAssemblies + 1.
		]		
	].
	^ nil! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 2/20/2009 16:17'!
query5
	| numBaseAssemblies results |
	numBaseAssemblies := 0.
	results := (SqsSearch for: SqsBaseAssembly) select: [:ba | ba unsharedParts anySatisfy: [:up | up buildDate > ba buildDate]].
	results do: [:ba | 
		ba buildDate.
		numBaseAssemblies := numBaseAssemblies + 1.	
	]! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 23:42'!
query7
	| aBlock |
	MessageTally spyOn: [aBlock := [(SqsSearch for: SqsAtomicPart) findAll].
	self queryAtomicParts: aBlock.].
	! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 23:41'!
query8
	| numPairs docs |
	numPairs := 0.
	MessageTally spyOn: [docs := ((SqsSearch for: SqsDocument) findAll).
	docs do: [:doc |
		| part |
		part := (SqsSearch for: SqsAtomicPart) detect: [:p | p docId = doc oid] ifNone: [nil].
		part ifNotNil: [numPairs := numPairs + 1]	
	]].
	^ nil
	
	! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 18:51'!
queryAtomicParts: aBlock
	| parts numParts |
	parts := aBlock value.
	numParts := 0.
	parts do: [:part |
		part x.
		numParts := numParts + 1.
	].
	^ numParts! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 17:18'!
run
	| |
	self setupProductionConfiguration.
	super run.! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 2/27/2009 20:32'!
setConfiguration: conf
	SqsConnectionManager getInstance setConfiguration: conf for: 'SqSave-Apps-OO7'.! !

!SqsOO7Benchmark methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 17:20'!
setupProductionConfiguration
	| conf |
	conf := self dbConfiguration.
	conf tableConfiguration inheritanceMode: SqsTableStructureHandler classTableInheritance.
	conf environment: SqsConfiguration productionMode.
	self setConfiguration: conf.
	! !

Object subclass: #OO7Database
	uses: TSqsLogger
	instanceVariableNames: 'scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

OO7Database class
	uses: TSqsLogger classTrait
	instanceVariableNames: ''!

!OO7Database class methodsFor: 'as yet unclassified' stamp: 'test 2/3/2009 15:55'!
scale: anInteger
	^self new
		scale: anInteger;
		yourself! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 16:01'!
chooseAssmDate
	^ (Interval from: self minAssemDate to: self maxAssmDate) atRandom! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 16:00'!
chooseAtomicDate
	^ (Interval from: self minAtomicDate to: self maxAtomicDate) atRandom! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 16:02'!
chooseRandomOldCompDate
	^ (Interval from: self minOldCompDate to: self maxOldCompDate) atRandom! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 16:02'!
chooseRandomYoungCompDate
	^ (Interval from: self minYoungCompDate to: self maxYoungCompDate) atRandom! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 16:03'!
createOO7Database
	^ self subclassResponsiblity! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:56'!
documentSize
	^ self documentSizes at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:48'!
documentSizes
	^ #(2000 2000 20000 20000)! !

!OO7Database methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 17:23'!
dropDatabase
	self subclassResponsibility! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:56'!
manualSize
	^ self manualSizes at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:49'!
manualSizes
	^ #(10000 10000 1000000 1000000)! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:53'!
maxAssmDate
	^1999! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:54'!
maxAtomicDate
	^ 1999! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:54'!
maxOldCompDate
	^ 999! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:54'!
maxYoungCompDate
	^ 2999! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:53'!
minAssemDate
	^ 1000! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:54'!
minAtomicDate
	^ 1000! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:54'!
minOldCompDate
	^ 0! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:53'!
minYoungCompDate
	^2000! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:58'!
numAssembliesPerAssembly
	^ self numsAssmPerAssembly at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:59'!
numAssemblyLevels
	^ self numsAssmLevels at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:57'!
numAtomicPartsPerAssembly
	^ self numsCompPerAssembly at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:58'!
numAtomicPartsPerComponent
	^ self numsAtomicPerComp at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:56'!
numComponentsPerAssembly
	^ self numsCompPerAssembly at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:56'!
numComponentsPerModule
	^ self numsCompPerModule at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:59'!
numConnectionsPerAtomicPart
	^ self numsConnPerAtomic at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:59'!
numModules
	^ self numsModules at: scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:52'!
numsAssmLevels
	^ #(4 7 7 7)! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:52'!
numsAssmPerAssembly
	^ #(3 3 3 3)! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:51'!
numsAtomicPerComp
	^ #(4 20 200 200)! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:50'!
numsCompPerAssembly
	^ #(2 3 3 3)! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:49'!
numsCompPerModule
	^ #(50 500 500 500)! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:51'!
numsConnPerAtomic
	^ #(3 3 6 9)! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:52'!
numsModules
	^ #(1 1 1 10)! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:47'!
scale
	^ scale! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:47'!
scale: anObject
	scale := anObject! !

!OO7Database methodsFor: 'accessing' stamp: 'test 2/3/2009 15:55'!
youngCompFrac
	^ 0.1! !

OO7Database subclass: #SqsOO7Database
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsOO7Database methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 02:22'!
createAssemblyParts: compositeParts for: bAssm
	| |
	self numComponentsPerAssembly timesRepeat: [
		bAssm addUnsharedPart: compositeParts atRandom.
	].
	bAssm save.! !

!SqsOO7Database methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 14:18'!
createAtomicPartsFor: compositePart
	| atomicParts atomicPart |
	atomicParts := Array new: self numAtomicPartsPerComponent.
	atomicParts doWithIndex: [:el :i |
		atomicPart := SqsAtomicPart buildDate: self chooseAtomicDate.
		compositePart addAtomicPart: atomicPart.
		atomicPart save.
		compositePart flatSave.
		atomicParts at: i put: atomicPart.
		(i > 1) ifTrue: [
			(atomicParts at: i - 1) addConnection: atomicPart.
			(atomicParts at: i - 1) save
		].
	].

	(atomicParts size > 1) ifTrue: [
		atomicParts last addConnection: atomicParts first.
		atomicParts last save.
	].

	atomicParts doWithIndex: [:part :i |
		self numConnectionsPerAtomicPart timesRepeat: [
			| randomPartIndex |
			[randomPartIndex := atomicParts size atRandom] doWhileTrue: [randomPartIndex = i].
			part addConnection: (atomicParts at: randomPartIndex)
		].
		part save.
	].
	^ atomicParts first! !

!SqsOO7Database methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 13:44'!
createCompositeParts
	| compositeParts compositePart |
	compositeParts := Array new: self numComponentsPerModule.
	compositeParts doWithIndex: [ :el :i |
		self log: ('Creating composite part ', i asString, ' of ', self numComponentsPerModule asString, '...').
		compositePart := SqsCompositePart documentLength: self documentSize.
		compositePart rootPart: (self createAtomicPartsFor: compositePart).
		((SmallInteger maxVal atRandom / SmallInteger maxVal) asFloat < self youngCompFrac) ifTrue: [
			compositePart buildDate: self chooseRandomYoungCompDate.			
		] ifFalse: [
			compositePart buildDate: self chooseRandomOldCompDate.			
		].
		
		compositePart save.
		self log: 'Created a composite part'.
		compositeParts at: i put: compositePart.
	].
	^ compositeParts! !

!SqsOO7Database methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 15:22'!
createModule
	| module allAssemblies baseAssemblies rootAssembly compositeParts |
	
	allAssemblies := Set new.
	baseAssemblies := Set new.
	
	module := SqsModule new.
	module changeManual: (SqsManual documentLength: self manualSize).
	module save.
	
	self log: 'Creating Assemblies...'.
	rootAssembly := SqsComplexAssembly new.
	allAssemblies add: rootAssembly.
	module changeDesignRoot: rootAssembly.
	self log: 'Creating sub assemblies for root assembly...'.
	self createSubAssembliesFor: rootAssembly level: 1 baseAssemblies: baseAssemblies allAssemblies: allAssemblies.
	self log: 'Created sub assemblies for root assembly'.
	module assemblies addAll: allAssemblies.
	self log: ('saving the entire module, assemblies: ', allAssemblies size asString).
	module save.
			
	self log: 'Creating composite parts...'.
	compositeParts := self createCompositeParts.
	self log: 'Created composite parts'.
	
	self log: ('Number of assemblies created: ', allAssemblies size asString).
	self log: ('Number of base assemblies created: ', baseAssemblies size asString).
	self log: ('Number of composite parts created: ', compositeParts size asString).
	
	self log: 'Associating composite parts with assemblies.'.
	baseAssemblies doWithIndex: [:bAssm :i |
		self log: 'Creating assembly parts for base assembly ', i asString, '...'.
		self createAssemblyParts: compositeParts for: bAssm.
		self log: 'Created assembly parts for base assembly'.
	].
	! !

!SqsOO7Database methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 22:03'!
createOO7Database
	self log: 'Creating Database...'.
	MessageTally spyOn: [self numModules timesRepeat: [
		self createModule	
	].].
	self log: 'Done Creating Database'! !

!SqsOO7Database methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 15:18'!
createSubAssembliesFor: rootAssembly level: level baseAssemblies: baseAssemblies allAssemblies: allAssemblies
	| subAssembly |
	(level < (self numAssemblyLevels - 1)) ifTrue: [
		self numAssembliesPerAssembly timesRepeat: [
			self log: 'Creating interior assembly node at level: ', level asString.
			subAssembly := SqsComplexAssembly new.
			subAssembly module: rootAssembly module.
			subAssembly buildDate: self chooseAssmDate.
			rootAssembly addSubAssembly: subAssembly.
			subAssembly save.
			rootAssembly save.
			allAssemblies add: subAssembly.
			self createSubAssembliesFor: subAssembly level: level + 1  baseAssemblies: baseAssemblies  allAssemblies: allAssemblies.
		]
	] ifFalse: [
		self numAssembliesPerAssembly timesRepeat: [
			self log: 'Creating leaf assembly node'.
			subAssembly := SqsBaseAssembly new.
			subAssembly module: rootAssembly module.
			subAssembly buildDate: self chooseAssmDate.
			rootAssembly addSubAssembly: subAssembly.
			subAssembly save.
			rootAssembly save.
			baseAssemblies add: subAssembly.
			allAssemblies add: subAssembly.	
		]
	]! !

!SqsOO7Database methodsFor: 'accessing' stamp: 'tkow 2/25/2009 17:23'!
dropDatabase
	| session |
	session := SqsConnectionManager getInstance sessionForClass: self class.
	session resetDatabase.! !

!SqsOO7Database methodsFor: 'accessing' stamp: 'tkow 2/28/2009 22:47'!
truncateDatabase
	| session |
	session := SqsConnectionManager getInstance sessionForClass: self class.
	session truncateDatabase.! !

!Object class methodsFor: '*sqsave' stamp: 'tkow 1/19/2009 17:47'!
fromSqlValue: anObject
	^ anObject! !

!Object methodsFor: '*sqsave' stamp: 'tkow 2/28/2009 13:44'!
deepSave
	(SqsStorage for: self) saveToLevel: 100! !

!Object methodsFor: '*sqsave' stamp: 'tkow 12/12/2008 17:45'!
destroy
	(SqsStorage for: self) destroy! !

!Object methodsFor: '*sqsave' stamp: 'tkow 2/28/2009 13:06'!
flatSave
	(SqsStorage for: self) flatSave! !

!Object methodsFor: '*sqsave' stamp: 'tkow 1/6/2009 17:02'!
instVarDict
	"returns a dictionary where each inst var name points to the current value"
	| ivnDict |
	ivnDict := Dictionary new.
	self class allInstVarNames do: [:ivn |
		| ivarValue |
		ivarValue := self instVarNamed: ivn.
		ivnDict at: ivn put: ivarValue.
	].
	^ ivnDict! !

!Object methodsFor: '*sqsave' stamp: 'tkow 12/12/2008 17:45'!
oid
	^ SqsStorage oidFor: self! !

!Object methodsFor: '*sqsave' stamp: 'tkow 12/12/2008 17:45'!
save
	(SqsStorage for: self) save! !

!Object methodsFor: '*sqsave' stamp: 'tkow 3/5/2009 20:56'!
save: anSqsSession 
	| storage |
	storage := SqsStorage for: self.
	storage sqsSession: anSqsSession.
	storage save! !

!Object methodsFor: '*sqsave' stamp: 'tkow 2/28/2009 13:44'!
save: anSqsDbAdapter toLevel: aLevel
	| storage |
	storage := SqsStorage for: self.
	storage sqsSession: anSqsDbAdapter.
	storage saveToLevel: aLevel! !

!Object methodsFor: '*sqsave' stamp: 'tkow 2/28/2009 14:17'!
saveToLevel: aLevel
	(SqsStorage for: self) saveToLevel: aLevel! !

!Object methodsFor: '*sqsave' stamp: 'tkow 2/16/2009 17:24'!
sqsClass
	^ self class! !

Object subclass: #SqsAccountData
	instanceVariableNames: 'username password email homepage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

!SqsAccountData methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:45'!
email
	^ email! !

!SqsAccountData methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:45'!
email: anObject
	email := anObject! !

!SqsAccountData methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:45'!
homepage
	^ homepage! !

!SqsAccountData methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:45'!
homepage: anObject
	homepage := anObject! !

!SqsAccountData methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:45'!
password
	^ password! !

!SqsAccountData methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:45'!
password: anObject
	password := anObject! !

!SqsAccountData methodsFor: 'accessing' stamp: 'tkow 3/2/2009 00:09'!
username
	^ username! !

!SqsAccountData methodsFor: 'accessing' stamp: 'tkow 3/2/2009 00:09'!
username: anObject
	username := anObject! !

Object subclass: #SqsAccountDataPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

!SqsAccountDataPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrEmail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'email';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_account_datas';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'email';
		 yourself! !

!SqsAccountDataPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrPassword
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'password';
		 sqlType: #largeInteger;
		 objectClass: #LargePositiveInteger;
		 tableName: 'sqs_account_datas';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'password';
		 yourself! !

!SqsAccountDataPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUsername
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'username';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_account_datas';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'username';
		 yourself! !

Object subclass: #SqsBlog
	instanceVariableNames: 'title entries lastUpdate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

!SqsBlog methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
entries
	^ entries! !

!SqsBlog methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
entries: anObject
	entries := anObject! !

!SqsBlog methodsFor: 'as yet unclassified' stamp: 'tkow 3/1/2009 23:48'!
initialize
	super initialize.
	entries := OrderedCollection new.! !

!SqsBlog methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:47'!
lastUpdate
	^ lastUpdate! !

!SqsBlog methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:47'!
lastUpdate: anObject
	lastUpdate := anObject! !

!SqsBlog methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
title
	^ title! !

!SqsBlog methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
title: anObject
	title := anObject! !

Object subclass: #SqsBlogEntry
	instanceVariableNames: 'title text comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

!SqsBlogEntry methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
comments
	^ comments! !

!SqsBlogEntry methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
comments: anObject
	comments := anObject! !

!SqsBlogEntry methodsFor: 'as yet unclassified' stamp: 'tkow 3/1/2009 23:46'!
initialize
	super initialize.
	comments := OrderedCollection new.! !

!SqsBlogEntry methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
text
	^ text! !

!SqsBlogEntry methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
text: anObject
	text := anObject! !

!SqsBlogEntry methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
title
	^ title! !

!SqsBlogEntry methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:46'!
title: anObject
	title := anObject! !

Object subclass: #SqsClassInfo
	instanceVariableNames: 'currentClass tableStructureHandler descriptionHandler tableName classTable configuration'
	classVariableNames: 'InfoCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsClassInfo class methodsFor: 'access to cache' stamp: 'tkow 3/10/2009 00:04'!
cachedFor: aClass
	| newInstance configuration |
	InfoCache ifNil: [InfoCache := Dictionary new].
	newInstance := InfoCache at: aClass name ifAbsentPut: [
		configuration := SqsConnectionManager getInstance configurationForClass: aClass.
		(self new) 
			currentClass: aClass; 
			configuration: configuration;
			yourself
	].
	^ newInstance
! !

!SqsClassInfo class methodsFor: 'standard-values' stamp: 'tkow 10/6/2008 18:30'!
clearInfoCache
	InfoCache := nil.! !

!SqsClassInfo class methodsFor: 'access to cache' stamp: 'test 3/9/2009 00:06'!
for: aClass
	| newInstance configuration |
	newInstance := self cachedFor: aClass.
	configuration := SqsConnectionManager getInstance configurationForClass: aClass.
	self prepareNewInstance: newInstance forConfiguration: configuration.	
	^ newInstance
! !

!SqsClassInfo class methodsFor: 'access to cache' stamp: 'tkow 3/9/2009 16:01'!
prepareNewInstance: newInstance forConfiguration: aConfiguration
	"this could be easily done much more fine-grained, but it should suffice for now to reset everything
	 that depends in some way on the configuration specified for the current class"
	| resetInfo |
	resetInfo := aConfiguration environment = SqsConfiguration developmentMode.
	resetInfo := resetInfo or: [aConfiguration environment ~= newInstance configuration environment].
	resetInfo := resetInfo or: [aConfiguration connectionIdentityString ~= newInstance configuration connectionIdentityString].
	
	resetInfo ifTrue: [
		newInstance tableName: nil.
		newInstance tableStructureHandler: nil.
		newInstance descriptionHandler: nil.
		newInstance configuration: aConfiguration.
		newInstance cachedClassTable: nil.	
	].
	^ newInstance! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 2/23/2009 17:06'!
baseClass
	| |
	^ currentClass sqsBaseClass! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 2/16/2009 17:12'!
cachedClassTable
	^ classTable ifNil: [
		classTable := self newClassTable	
	]! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 2/16/2009 16:44'!
cachedClassTable: anSqSTable 
	classTable := anSqSTable! !

!SqsClassInfo methodsFor: 'table-information' stamp: 'tkow 10/6/2008 18:09'!
classTableColumns
	^self descriptionHandler classTableColumns! !

!SqsClassInfo methodsFor: 'variable-information' stamp: 'tkow 11/7/2008 16:16'!
columnNameForInstVar: ivn
	^ ivn decamelized! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 2/28/2009 14:48'!
configuration
	configuration ifNil: [ 
		configuration := SqsConnectionManager getInstance configurationForClass: currentClass.
	].
	^ configuration! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:41'!
configuration: anObject
	configuration := anObject! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 15:19'!
currentClass
	^ currentClass! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 15:19'!
currentClass: anObject
	currentClass := anObject! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:48'!
descriptionHandler
	descriptionHandler ifNil: [
		descriptionHandler := self descriptionHandlerClass forClassInfo: self.	
	].
	^descriptionHandler! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/30/2008 11:51'!
descriptionHandler: anObject
	descriptionHandler := anObject! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:49'!
descriptionHandlerClass
	^ self configuration descriptionHandlerClass! !

!SqsClassInfo methodsFor: 'iterating' stamp: 'tkow 9/30/2008 15:13'!
doForAllSuperclasses: aBlock
	| curClass baseClass |
	"this is a convenience method to perform some block
	for all of the current class' superclasses up until the base class"
	curClass := self currentClass.
	baseClass := self baseClass.
	[curClass = baseClass superclass] whileFalse: [
		aBlock value: curClass.
		curClass := curClass superclass.
	].! !

!SqsClassInfo methodsFor: 'persistence-information' stamp: 'tkow 11/7/2008 16:27'!
inheritanceMode
	^self configuration tableConfiguration inheritanceMode! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 2/16/2009 16:44'!
newClassTable
	^ self tableStructureHandler classTable
! !

!SqsClassInfo methodsFor: 'variable-information' stamp: 'tkow 9/30/2008 14:17'!
persistedInstVars
	| |
	^self descriptionHandler persistedInstanceVariables
	! !

!SqsClassInfo methodsFor: 'object-persistence' stamp: 'tkow 1/18/2009 16:06'!
tableForClassExists
	| |
	^ self tableStructureHandler tableForClassExists! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 2/22/2009 13:58'!
tableName
	| |
	tableName ifNil: [
		tableName := self descriptionHandler tableName
	].
	^ tableName! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/30/2008 15:05'!
tableName: aString
	| |
	tableName := aString! !

!SqsClassInfo methodsFor: 'table-information' stamp: 'tkow 9/29/2008 15:14'!
tableNameForClass: aClass
	"only use me for classes you are sure of using the same description handler 
	 than the one the current sqsObject is using"
	^self descriptionHandler tableNameForClass: aClass
	! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:44'!
tableStructureHandler
	tableStructureHandler ifNil: [ tableStructureHandler := SqsTableStructureHandler forClassInfo: self ].
	^ tableStructureHandler! !

!SqsClassInfo methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:15'!
tableStructureHandler: anObject
	tableStructureHandler := anObject! !

!SqsClassInfo methodsFor: 'variable-information' stamp: 'tkow 9/29/2008 15:15'!
unpersistedInstVars
	| |
	^self descriptionHandler unpersistedInstVars
	! !

Object subclass: #SqsCollectionChanges
	instanceVariableNames: 'addedObjects deletedObjects movedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
addedObjects
	^ addedObjects! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
addedObjects: anObject
	addedObjects := anObject! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
deletedObjects
	^ deletedObjects! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
deletedObjects: anObject
	deletedObjects := anObject! !

!SqsCollectionChanges methodsFor: 'initialization' stamp: 'tkow 11/7/2008 15:23'!
initialize
	super initialize.
	addedObjects := OrderedCollection new.
	deletedObjects := OrderedCollection new.
	movedObjects := OrderedCollection new.! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
movedObjects
	^ movedObjects! !

!SqsCollectionChanges methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:20'!
movedObjects: anObject
	movedObjects := anObject! !

Object subclass: #SqsCollectionConfiguration
	uses: TSqsSelfPrinting
	instanceVariableNames: 'valueField orderField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

SqsCollectionConfiguration class
	uses: TSqsSelfPrinting classTrait
	instanceVariableNames: ''!

!SqsCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:22'!
standardForOrderedCollections
	^ true! !

!SqsCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 2/19/2009 13:37'!
standardNilValue
	^ nil! !

!SqsCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:22'!
standardOrderField
	^'sqs_order_number'! !

!SqsCollectionConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:21'!
standardValueField
	^'value'! !

!SqsCollectionConfiguration methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!SqsCollectionConfiguration methodsFor: 'initialize-release' stamp: 'test 2/16/2009 15:42'!
initialize
	orderField := self class standardOrderField.
	valueField := self class standardValueField.
	nilValue := self class standardNilValue.! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderField
	^ orderField! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
orderField: anObject
	orderField := anObject! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
valueField
	^ valueField! !

!SqsCollectionConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:18'!
valueField: anObject
	valueField := anObject! !

Object subclass: #SqsCollectionInformation
	instanceVariableNames: 'collection collectionDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collection
	^ collection! !

!SqsCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collection: anObject
	collection := anObject! !

!SqsCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collectionDescription
	^ collectionDescription! !

!SqsCollectionInformation methodsFor: 'accessing' stamp: 'tkow 10/10/2008 11:11'!
collectionDescription: anObject
	collectionDescription := anObject! !

Object subclass: #SqsComment
	instanceVariableNames: 'author title text email homepage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
author
	^ author! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
author: anObject
	author := anObject! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
email
	^ email! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
email: anObject
	email := anObject! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
homepage
	^ homepage! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
homepage: anObject
	homepage := anObject! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
text
	^ text! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
text: anObject
	text := anObject! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
title
	^ title! !

!SqsComment methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:48'!
title: anObject
	title := anObject! !

Object subclass: #SqsCon
	instanceVariableNames: 'length type to from'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsCon class methodsFor: 'as yet unclassified' stamp: 'test 2/3/2009 14:26'!
from: aPart to: anotherPart
	^self new
		from: aPart;
		to: anotherPart;
		length: ((Interval from: 0 to: 9) atRandom);
		type: ('Type',((Interval from: 0 to: 9) atRandom) asString);
		yourself! !

!SqsCon class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFrom
	^ SqsColumn new associatedClass: #SqsAtomicPart;
		 manuallyMaintained: false;
		 columnName: 'from_id';
		 sqlType: #integer;
		 objectClass: #SqsAtomicPart;
		 tableName: 'sqs_cons';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'from';
		 yourself! !

!SqsCon class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLength
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'length';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_cons';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'length';
		 yourself! !

!SqsCon class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTo
	^ SqsColumn new associatedClass: #SqsAtomicPart;
		 manuallyMaintained: false;
		 columnName: 'to_id';
		 sqlType: #integer;
		 objectClass: #SqsAtomicPart;
		 tableName: 'sqs_cons';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'to';
		 yourself! !

!SqsCon class methodsFor: 'persistence-description' stamp: ''!
sqsDescrType
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'type';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_cons';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'type';
		 yourself! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
from
	^ from! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
from: anObject
	from := anObject! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
length
	^ length! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
length: anObject
	length := anObject! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
to
	^ to! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
to: anObject
	to := anObject! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
type
	^ type! !

!SqsCon methodsFor: 'accessing' stamp: 'test 2/2/2009 16:56'!
type: anObject
	type := anObject! !

Object subclass: #SqsConfiguration
	uses: TSqsSelfPrinting
	instanceVariableNames: 'connectionSpec descriptionHandlerClass collectionConfiguration tableConfiguration environment useInstVarAccessors warnOnAlteration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsConfiguration commentStamp: 'tkow 12/4/2008 16:02' prior: 0!
A SqSConfiguration is the main class for the configuration of SqueakSave. It defines some fundamental options by itself and links to the other configuration classes for detailed configuration of merely all aspects of the mapper. Instances of this class should be created on the class side of the class they are valid for, and will be used for all subclasses, also.

Instance Variables
	collectionConfiguration:		SqSCollectionconfiguration
	connectionSpec:		SqSConnectionSpecification
	descriptionHandlerClass:		Symbol
	mode:		Symbol
	objectCaching:		Symbol
	tableConfiguration:		SqSTableConfiguration
	useInstVarAccessors:		Boolean

collectionConfiguration
	- xxxxx

connectionSpec
	- xxxxx

descriptionHandlerClass
	- xxxxx

mode
	- xxxxx

objectCaching
	- xxxxx

tableConfiguration
	- xxxxx

useInstVarAccessors
	- xxxxx
!

SqsConfiguration class
	uses: TSqsSelfPrinting classTrait
	instanceVariableNames: ''!

!SqsConfiguration class methodsFor: 'instance-creation' stamp: 'tkow 2/23/2009 16:42'!
conSpec: aSqsConnectionSpec
	^ self new
		connectionSpec: aSqsConnectionSpec;
		yourself! !

!SqsConfiguration class methodsFor: 'modes' stamp: 'tkow 11/7/2008 16:04'!
developmentMode
	^#development! !

!SqsConfiguration class methodsFor: 'modes' stamp: 'tkow 11/7/2008 15:31'!
productionMode
	^#production! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/12/2008 17:39'!
standardCollectionConfiguration
	^ SqsCollectionConfiguration new! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 16:20'!
standardForInstVarAccess
	^ true! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'tkow 3/9/2009 00:14'!
standardHandlerClass
	^ SqsStandardInternDescriptionHandler! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/12/2008 17:40'!
standardTableConfiguration
	^ SqsTableConfiguration activeRecordStyle	"SqSTableConfiguration new"! !

!SqsConfiguration class methodsFor: 'standard values' stamp: 'test 1/27/2009 17:38'!
standardWarning
	^ false! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 3/5/2009 20:54'!
adapterClass
	^ Smalltalk at: (connectionSpec driverClass)! !

!SqsConfiguration methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
collectionConfiguration
	^ collectionConfiguration! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
collectionConfiguration: anObject
	collectionConfiguration := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 2/23/2009 16:59'!
connectionIdentityString
	^ connectionSpec connectionIdentityString! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
connectionSpec
	^ connectionSpec! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
connectionSpec: anObject
	connectionSpec := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
descriptionHandlerClass
	^ descriptionHandlerClass! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 13:36'!
descriptionHandlerClass: anObject
	descriptionHandlerClass := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 12/15/2008 19:54'!
environment
	^ environment! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 12/15/2008 19:54'!
environment: anObject
	environment := anObject! !

!SqsConfiguration methodsFor: 'initialization' stamp: 'test 1/27/2009 17:36'!
initialize
	super initialize.
	descriptionHandlerClass := self class standardHandlerClass.
	collectionConfiguration := self class standardCollectionConfiguration.
	environment := self class developmentMode.
	tableConfiguration := self class standardTableConfiguration.
	useInstVarAccessors := self class standardForInstVarAccess.
	warnOnAlteration := self class standardWarning.
	
	! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 14:10'!
tableConfiguration
	^ tableConfiguration! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 14:10'!
tableConfiguration: anObject
	tableConfiguration := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:19'!
useInstVarAccessors
	^ useInstVarAccessors! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 16:19'!
useInstVarAccessors: anObject
	useInstVarAccessors := anObject! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'test 1/27/2009 17:34'!
warnOnAlteration
	^ warnOnAlteration! !

!SqsConfiguration methodsFor: 'accessing' stamp: 'test 1/27/2009 17:34'!
warnOnAlteration: anObject
	warnOnAlteration := anObject! !

Object subclass: #SqsConnection
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsConnection commentStamp: 'tkow 10/27/2008 14:41' prior: 0!
A SqSConnection is merely an interface for all the different connection classes used by
the different database server clients. In contrast to the database adapters they are only ment to control
the connections via a common interface even from without the controllers, so that mixed up postgresql,
mysql or other connections can be handled by the same connection manager 

Instance Variables
	connection:		anObject, instance of i.e. JdmConnection

connection
	- xxxxx
!

!SqsConnection class methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 21:16'!
withConnection: aConnection
	^self new
		connection: aConnection;
		init;
		yourself
	! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:36'!
close
	self subclassResponsibility! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:41'!
connection
	^ connection! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 14:41'!
connection: anObject
	connection := anObject! !

!SqsConnection methodsFor: 'connection-control' stamp: 'tkow 10/29/2008 13:25'!
executeQuery: anSqlQuery
	self subclassResponsibility! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 17:04'!
init
	self subclassResponsibility! !

!SqsConnection methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 14:37'!
isAlive
	self subclassResponsibility.! !

!SqsConnection methodsFor: 'connection-control' stamp: 'tkow 10/29/2008 13:49'!
nextRowFromResult: result
	self subclassResponsibility! !

!SqsConnection methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 17:05'!
reconnect
	self isAlive ifTrue: [
		self close.	
	].
	self init.! !

!SqsConnection methodsFor: 'accessing' stamp: 'tkow 10/27/2008 15:29'!
rowDictionariesForResultSet: result
	^self subclassResponsibility! !

SqsConnection subclass: #SqsMySqlConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 3/3/2009 13:31'!
close
	self isAlive ifTrue: [
		connection close	
	]
	! !

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 21:05'!
executeQuery: anSqlQuery
	| subQueries |
	subQueries := anSqlQuery subStrings: ';'.
	subQueries allButLastDo: [ :query |
		(connection createStatement) executeQuery: (query)		
	].
	^ (connection createStatement) executeQuery: (subQueries last)
	
	
	! !

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 21:17'!
init
	connection initialize2.
	(self executeQuery: 'SET autocommit = 0').
! !

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 17:14'!
isAlive
	^(connection socket notNil) and: [connection socket isConnected]! !

!SqsMySqlConnection methodsFor: 'as yet unclassified' stamp: 'tkow 10/29/2008 14:04'!
nextRowFromResult: result
	^ result next ifTrue: [
		result currentRowAsDictionary 
	] ifFalse: [
		nil
	]! !

!SqsMySqlConnection methodsFor: 'converting' stamp: 'tkow 12/13/2008 12:21'!
rowDictionariesForResultSet: result 
	| resultDicts |
	resultDicts := OrderedCollection new.
	"damn...I really need a proper mysql driver, this one returns JdmResult or JdmResultSets"
	(result class includesBehavior: JdmResult) ifTrue: [
		^ resultDicts	
	].
	
	"store all data rows in our own structure - this way we can issue new commands upon object creation"
	[ result next ] whileTrue: [ 
		resultDicts add: result currentRowAsDictionary 
	].
	^resultDicts! !

SqsConnection subclass: #SqsPostgresConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 12/9/2008 14:56'!
close
	connection terminate! !

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 13:19'!
executeQuery: anSqlQuery
	| result subQueries |
	subQueries := anSqlQuery subStrings: ';'.
	subQueries allButLastDo: [ :query |
		result := connection execute: query.
		result errorResponse ifNotNil: [self error: result errorResponse value].
	].
	result := connection execute: subQueries last.
	result errorResponse ifNil: [
		^ result		
	] ifNotNil: [
		self error: result errorResponse value
	].! !

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 11:08'!
init
	self isAlive ifFalse: [
		connection startup		
	].
! !

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 12/9/2008 15:02'!
isAlive
	^ connection isConnected! !

!SqsPostgresConnection methodsFor: 'as yet unclassified' stamp: 'tkow 12/9/2008 15:15'!
rowDictionariesForResultSet: resultSet
	| resultSets |
	
	resultSets := resultSet resultSets at: 1 ifAbsent: [nil].
	^ resultSets ifNil: [
		OrderedCollection new.
	] ifNotNil: [
		resultSets rows collect: [:row |
			row dataKeyedByFieldName
		]
	]
	
	! !

Object subclass: #SqsConnectionManager
	instanceVariableNames: 'connectionPool monitor connectionCount sessionPool configurationDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

SqsConnectionManager class
	instanceVariableNames: 'ConnectionManager ManagerPool'!

SqsConnectionManager class
	instanceVariableNames: 'ConnectionManager ManagerPool'!

!SqsConnectionManager class methodsFor: 'connection-access' stamp: 'tkow 2/23/2009 16:21'!
adapterForConSpec: cSpec
	| adapterClass |
	"returns a new adapter for the given connection specification"
	adapterClass := Smalltalk 
		at: cSpec driverClass 
		ifAbsent: [self unknownClassError: cSpec driverClass].
	^ adapterClass withConnectionSpecification: cSpec.
! !

!SqsConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 17:39'!
getInstance
	ConnectionManager ifNil: [
		ConnectionManager := self new.	
	].
	^ConnectionManager! !

!SqsConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 11:50'!
getInstanceFor: aSymbol
	^(ManagerPool ifNil: [
		Dictionary new	
	]) at: aSymbol ifAbsentPut: [self new]! !

!SqsConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 11:50'!
reset
	ManagerPool := Dictionary new.
	ConnectionManager := nil.! !

!SqsConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:43'!
testCategory
	^'SqSave'! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 2/25/2009 18:04'!
closeAllConnections
	"this will close all connections lying around somewhere in the pool
	and additionally clear the pool and the connection count"
	| con |
	self connectionPool valuesDo: [:conQueue |
		con := conQueue	nextOrNil.
		[con notNil] whileTrue: [
			con close.
			con := conQueue nextOrNil.
		]
	].
	connectionCount := Dictionary new.
	connectionPool := Dictionary new.! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tkow 2/23/2009 16:13'!
configurationDict
	^ configurationDict! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tkow 2/23/2009 16:14'!
configurationDict: anObject 
	configurationDict := anObject! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 3/10/2009 16:26'!
configurationForClass: aClass 
	| stringsToTry configuration currentString categoryParts i |
	
	stringsToTry := OrderedCollection with: aClass name.
	stringsToTry add: aClass basicCategory asString.
	categoryParts := aClass basicCategory asString subStrings: '-'.
	i := categoryParts size - 1.
	[i > 0] whileTrue: [
		stringsToTry add: ((categoryParts first: i) join: '-').
		i := i - 1.	
	].

	configuration := nil.
	[ stringsToTry notEmpty and: [ configuration isNil ] ] whileTrue: 
		[ currentString := stringsToTry removeFirst.
		configuration := self configurationDict 
			at: currentString
			ifAbsent: [ nil ] ].
	configuration 
		ifNil: [ self noConfigurationErrorFor: aClass name ]
		ifNotNil: [ ^ configuration ]! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool
	^ connectionPool! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool: anObject
	connectionPool := anObject! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 3/3/2009 18:05'!
getConnectionFor: anSqsConSpec	
	| queue conCount connection cidStr connectionError |
	cidStr := anSqsConSpec connectionIdentityString.
	connectionError := false.
	
	monitor critical: [
		conCount := connectionCount at: cidStr ifAbsentPut: 0.
		queue := connectionPool at: cidStr ifAbsentPut: [SharedQueue2 new]	
	].
	connection := queue nextOrNil.
	monitor critical: [
		[(connection isNil and: [conCount < anSqsConSpec maxConnections]) ifTrue: [
			connection := ((Smalltalk at: anSqsConSpec driverClass) newConnectionFor: anSqsConSpec).
			connectionCount at: cidStr put: (conCount + 1).
		]] ifError: [:err | 
			err inspect. 
			connectionCount at: cidStr put: conCount.
			connectionError :=  true.
		]
	].

	connectionError ifTrue: [
		self error: 'could not establish new connection'	
	].

	connection ifNil: [
		connection := queue next	
	].
	^connection
	
	! !

!SqsConnectionManager methodsFor: 'initialization' stamp: 'tkow 2/23/2009 16:13'!
initialize
	configurationDict := Dictionary new.
	connectionPool := Dictionary new.
	monitor := Monitor new.
	connectionCount := Dictionary new.
	sessionPool := WeakIdentityKeyDictionary new! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 2/23/2009 16:18'!
noConfigurationErrorFor: aString 
	self error: 'No connection Specification found for ' , aString! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 10/29/2008 13:10'!
releaseConnection: aConnection for: anSqsConSpec	
	| queue |
	queue := connectionPool
				at: anSqsConSpec connectionIdentityString 
				ifAbsent: [self error: 'How did you get that connection anyway?'].	
	queue nextPut: aConnection
	! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/12/2008 17:35'!
resetConnections
	SqsConnection allInstances do: [ :sqsCon | sqsCon reconnect ]! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 2/23/2009 16:56'!
sessionForCategory: aCategoryName 
	| configuration |
	configuration := self configurationDict 
		at: aCategoryName
		ifAbsent: [ self noConfigurationErrorFor: aCategoryName ].
	^ self sessionForConfiguration: configuration! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 2/28/2009 14:49'!
sessionForClass: aClass 
	|  |
	^ self sessionForConfiguration: (self configurationForClass: aClass)! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 3/9/2009 15:56'!
sessionForConfiguration: configuration
	"simply return the session of the current thread and set the new adapter
	 accordingly. Since the adapter doesn't really have state, that shouldn't be a problem"
	| session |
"	session := self sessionPool 
		at: Processor activeProcess
		ifAbsentPut: [ SqsSession new 
			configuration: configuration;
			yourself
		].
"		
	"when we have a different connection, we also need a new session to not endanger transaction state"
	"session configuration: configuration.
	(session connectionIdentityString ~= configuration connectionIdentityString) ifTrue: ["
		session := SqsSession new
			configuration: configuration;
			yourself.
"	]."
	^ session! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:38'!
sessionPool
	^ sessionPool! !

!SqsConnectionManager methodsFor: 'accessing' stamp: 'tkow 12/13/2008 10:38'!
sessionPool: anObject 
	sessionPool := anObject! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 2/23/2009 16:13'!
setConfiguration: aConnectionSpecification for: aString 
	"setUp the connection specification for a class or category. so basically without setting up a 
	connection specification for a class or category, the nice and easy #save will not work"
	self configurationDict 
		at: aString asString
		put: aConnectionSpecification! !

!SqsConnectionManager methodsFor: 'connection-access' stamp: 'tkow 12/9/2008 16:41'!
unknownClassError: className
	self error: 'The driver class: ', className asString, ' is unknown in this image'.! !

Object subclass: #SqsConnectionSpecification
	instanceVariableNames: 'username password database port hostname driverClass maxConnections connectionIdentityString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 10/27/2008 09:54'!
standardQueueSize
	^20! !

!SqsConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:41'!
user: aUsername password: aPassword database: aDatabaseName port: aPortNumber driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: 'localhost'.! !

!SqsConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:42'!
user: aUsername password: aPassword database: aDatabaseName port: aPortNumber driver: aDriverClassName hostname: aHostname
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!SqsConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName hostname: aHostname driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:45'!
connectionIdentityString
	connectionIdentityString ifNil: [
		connectionIdentityString := (self driverClass asString),'#',(self username),'@',(self hostname),':',(self port asString),'/',(self database)
	].
	^connectionIdentityString
	! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database
	^ database! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database: anObject
	database := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass
	^ driverClass! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass: anObject
	driverClass := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname
	^ hostname! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname: anObject
	hostname := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 09:55'!
maxConnections
	^maxConnections ifNil: [self class standardQueueSize]! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tkow 10/27/2008 09:53'!
maxConnections: anObject
	maxConnections := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password
	^ password! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password: anObject
	password := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port
	^ port! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port: anObject
	port := anObject! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username
	^ username! !

!SqsConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username: anObject
	username := anObject! !

SqsConnectionSpecification subclass: #SqsMySQLConnectionSpecification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsMySQLConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:39'!
user: aUsername password: aPassword database: aDatabaseName 
	"just for the lazy people like me - creates a mysql connection..."
	^ self new
		username: aUsername;
		password: aPassword;
		port: 3306;
		database: aDatabaseName;
		driverClass: #SqsMysqlAdapter;
		hostname: 'localhost'! !

!SqsMySQLConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:40'!
user: aUsername password: aPassword database: aDatabaseName port: aPort
	"just for the lazy people like me - creates a mysql connection..."
	^ self new
		username: aUsername;
		password: aPassword;
		port: aPort;
		database: aDatabaseName;
		driverClass: #SqsMysqlAdapter;
		hostname: 'localhost'! !

!SqsMySQLConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:41'!
user: aUsername password: aPassword database: aDatabaseName port: aPort host: aHostName
	"just for the lazy people like me - creates a mysql connection..."
	^ self new
		username: aUsername;
		password: aPassword;
		port: aPort;
		database: aDatabaseName;
		driverClass: #SqsMysqlAdapter;
		hostname: aHostName! !

SqsConnectionSpecification subclass: #SqsPGConnectionSpecification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsPGConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:40'!
user: aUsername password: aPassword database: aDatabaseName 
	"just for the lazy people like me - creates a mysql connection..."
	^ self new
		username: aUsername;
		password: aPassword;
		port: 5432;
		database: aDatabaseName;
		driverClass: #SqsPostgresAdapter;
		hostname: 'localhost'! !

!SqsPGConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:40'!
user: aUsername password: aPassword database: aDatabaseName port: aPort
	"just for the lazy people like me - creates a mysql connection..."
	^ self new
		username: aUsername;
		password: aPassword;
		port: aPort;
		database: aDatabaseName;
		driverClass: #SqsPostgresAdapter;
		hostname: 'localhost'! !

!SqsPGConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:40'!
user: aUsername password: aPassword database: aDatabaseName port: aPort host: aHostName
	"just for the lazy people like me - creates a mysql connection..."
	^ self new
		username: aUsername;
		password: aPassword;
		port: aPort;
		database: aDatabaseName;
		driverClass: #SqsPostgresAdapter;
		hostname: aHostName! !

Object subclass: #SqsDatabaseAdapter
	instanceVariableNames: 'connection connectionSpecification isInTransaction usesConnectionPool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'test 1/25/2009 15:09'!
cascadeAction
	^ #CASCADE! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 12/11/2008 17:40'!
columnTableSeperator
	^ '.'! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'test 1/27/2009 10:42'!
completeCount
	^ 'COUNT(*)'! !

!SqsDatabaseAdapter class methodsFor: 'standard-values' stamp: 'tkow 2/16/2009 11:34'!
coveringTypes
	^ Dictionary new
		at: #string put: #(#text);
		at: #integer put: #(#largeInteger);
		yourself! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:24'!
dayOfMonth
	^ 'DAY'! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:23'!
dayOfWeek
	^ 'DAYOFWEEK'! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:23'!
dayOfYear
	^ 'DAYOFYEAR'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:55'!
defaultColumn
	^'Default'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:55'!
extraColumn
	^'Extra'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
fieldNameColumn
	^'Field'! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:31'!
hour
	^ 'HOUR'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:54'!
keyColumn
	^'Key'! !

!SqsDatabaseAdapter class methodsFor: 'standard-values' stamp: 'tkow 3/6/2009 13:59'!
maxFieldLength
	self subclassResponsiblity! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:31'!
minute
	^ 'MINUTE'! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:29'!
month
	^ 'MONTH'! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:30'!
monthName
	^ 'MONTHNAME'! !

!SqsDatabaseAdapter class methodsFor: 'instance creation' stamp: 'tkow 10/27/2008 15:08'!
newConnectionFor: anSqsConSpec
	"this method is meant to create new instances of the designated connection class
	for the database client of the corresponding flavour - so for a Mysql adapter this should return
	an SqSMySqlConnection holding a JdmConnection. For PostgreSql an SqSPostgreSqlConnection holding
	the postgreSql connection delivered with the postgre client"
	self subclassResponsibility! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
nullColumn
	^'Null'! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:32'!
second
	^ 'SECOND'! !

!SqsDatabaseAdapter class methodsFor: 'special-columns' stamp: 'tkow 11/18/2008 17:53'!
typeColumn
	^'Type'! !

!SqsDatabaseAdapter class methodsFor: 'instance creation' stamp: 'tkow 10/27/2008 10:34'!
withConnectionSpecification: anSqsConSpec
	^self new
		connectionSpecification: anSqsConSpec;
		yourself! !

!SqsDatabaseAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:30'!
year
	^ 'YEAR'! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:42'!
addColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAddColumn: column).	
		]
	"]"
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 2/25/2009 16:54'!
addConstraints: constraintCollection to: tableName 
	| sql |
	constraintCollection do: 
		[ :constraint | 
		sql := self 
			queryToAddFkConstraint: constraint
			to: tableName.
		self executeQuery: sql ]! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/9/2009 14:48'!
addEntries: addedIds inJoinTable: aDescription forOwnerId: oid
	| sql |
	addedIds ifNotEmpty: [
		sql	:= self queryToAddBulkOfEntries: addedIds toJoinTable: aDescription forOwnerId: oid.
		self inTransactionDo: [self executeQuery: (sql)].
	]	! !

!SqsDatabaseAdapter methodsFor: 'data-preparation' stamp: 'tkow 2/27/2009 16:14'!
aliasColumn: column ofTable: aTable with: aliasSuffix
	| columnAlias aliasName |
	aliasName := aTable tableName, aliasSuffix.
	^ (column = aTable oidColumn and: [ aTable parent notNil ]) ifFalse: [ 
		columnAlias := self columnName: column columnName aliasedWith: aliasName.
		aTable tableName , '.' , column columnName , ' AS ' , columnAlias
	] ifTrue: [
		nil
	]! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/13/2008 11:48'!
allTableNames
	| resultDicts tableNames |
	resultDicts := self executeQuery: self queryForAllUserTables.

	tableNames := OrderedCollection new.
	resultDicts do: [:dict | 
		dict valuesDo: [:tableName | 
			tableNames add: tableName
		]
	].
	^ tableNames! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 13:34'!
alterColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	| sql |
	columnsCollection do: [:column |
		[self executeQuery: (self queryToAlterColumn: column)] ifError: [:err |
			sql := (self queryToRemoveColumn: column).
			sql := sql, ';',(self queryToAddColumn: column).
			self executeQuery: sql.
		].	
	]
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/5/2009 20:02'!
beginTransaction
	isInTransaction := true.
	self executeQuery: self queryToStartTransaction! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:32'!
boolean
	^'BOOLEAN'.! !

!SqsDatabaseAdapter methodsFor: 'data-preparation' stamp: 'tkow 2/24/2009 14:54'!
buildQueryTableFor: anObject joinOn: refIdField
	| classTable queryTable childLink childQueryTable |
	classTable := anObject classInfo cachedClassTable baseTable.
	queryTable := SqsQueryTable 
		table: classTable
		alias: ''
		field: ''
		class: anObject classInfo baseClass.
	classTable allChildTables do: 
		[ :childTable | 
		childQueryTable := SqsQueryTable 
			table: childTable
			alias: ''
			field: nil.
		childLink := SqsTableLink 
			table: childQueryTable
			fromField: refIdField
			toField: refIdField
			direction: 'LEFT OUTER'.
		queryTable tableLinks add: childLink ].
	^ queryTable! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/11/2008 14:22'!
checkTableExistance: aTableName 
	| |
	^ self allTableNames anySatisfy: [:name | name = aTableName].
! !

!SqsDatabaseAdapter methodsFor: 'data-preparation' stamp: 'tkow 12/11/2008 18:24'!
columnName: columnName aliasedWith: aliasName
	^ aliasName, self class columnTableSeperator, columnName! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/5/2009 20:02'!
commitTransaction
	isInTransaction := false.
	self executeQuery: self queryToCommit.
! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/26/2009 09:10'!
completeWhereStatementFor: anSqsQuery
	| sql aliasedTable typeColumn baseTable |
	sql := ' WHERE '.
	anSqsQuery whereBuffer ifNotEmpty: [
		sql := sql, '(',anSqsQuery whereBuffer,')'
	].
	aliasedTable := anSqsQuery valueTables first.
	
	anSqsQuery ignoreTypeField ifFalse: [
		anSqsQuery whereBuffer ifNotEmpty: [sql := sql, ' AND '].
		sql := sql, '('.
		baseTable := aliasedTable originalTable baseTable.
		typeColumn := baseTable typeColumn columnName.
		sql := sql, ((aliasedTable queryClass withAllSubclasses collect: [:aClass |
			(baseTable tableName), '.', (typeColumn),	' = ', aClass name asSqlValueString
		]) join: ' OR ').	
		sql := sql, ')'.
	].
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'connection-control' stamp: 'tkow 10/30/2008 15:05'!
connection
	^connection! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connection: anObject
	connection := anObject! !

!SqsDatabaseAdapter methodsFor: 'connection-control' stamp: 'tkow 10/27/2008 10:37'!
connectionIdentityString
	^self connectionSpecification connectionIdentityString! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connectionSpecification
	^ connectionSpecification! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/27/2008 10:37'!
connectionSpecification: anObject
	connectionSpecification := anObject! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 2/24/2009 15:34'!
createJoinQueryTableFrom: queryTable to: joinTable joinOn: refIdField from: refColumn
	| joinQueryTable |
	
	joinQueryTable := SqsQueryTable 
		table: joinTable
		alias: ''
		field: ''
		class: nil.
	
	joinQueryTable tableLinks add: (SqsTableLink 
			table: queryTable
			fromField: refColumn
			toField: refIdField
			direction: 'LEFT OUTER').
			
	^ joinQueryTable! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 2/25/2009 16:59'!
createTable: anSqSTable 
	| query |
	query := self queryToCreateCompleteTable: anSqSTable.
	self executeQuery: query.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
date
	^'DATE'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
dateAndTime
	^'DATETIME'.
	! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'tkow 1/20/2009 14:29'!
decimal
	^ 'DECIMAL'! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
decimalIntegerSize: m scale: d
	^'DECIMAL('m asString,',',d asString,')'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 15:58'!
deleteEntriesFromJoinTable: collectionDescription forObjectId: oid 
	| sql |
	sql := self 
		queryToRemoveEntriesFromJoinTable: collectionDescription
		forObjectId: oid.
	self inTransactionDo: [self executeQuery: (sql)].! !

!SqsDatabaseAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 2/16/2009 11:45'!
does: aType cover: anotherType
	| matchingTypes |
	matchingTypes := self class coveringTypes at: anotherType ifAbsent: [^ false].
	^ matchingTypes includes: aType! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
double
	^'DOUBLE'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/5/2009 20:02'!
executeQuery: anSqlQuery
	| result rowDicts |
	self log: anSqlQuery.
	self getConnectionIfNecessary.

	result := [connection executeQuery: (anSqlQuery)] ifError: [ :err |
		self freeConnection.
		self error: err
	].
	
	rowDicts := connection rowDictionariesForResultSet: result.
	self freeConnection.
	^ rowDicts
	! !

!SqsDatabaseAdapter methodsFor: 'data-preparation' stamp: 'tkow 2/27/2009 16:26'!
explicitColumnsOfTable: anSqSQueryTable 
	| aliasSuffix aliasedColumns columnAlias |
	aliasSuffix := anSqSQueryTable aliasSuffix.
	aliasedColumns := OrderedCollection new.
	anSqSQueryTable originalTable allValueTables do: [ :table |
		table columns do: [:column | 
			columnAlias := self aliasColumn: column ofTable: table with: aliasSuffix.
			columnAlias ifNotNil: [aliasedColumns add: columnAlias]
		]
	].
	^ aliasedColumns join: ', '.
! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
float
	^'FLOAT'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/12/2008 17:38'!
freeConnection
	(isInTransaction not and: [ usesConnectionPool ]) ifTrue: 
		[ connection ifNotNil: 
			[ SqsConnectionManager getInstance 
				releaseConnection: connection
				for: connectionSpecification.
			connection := nil ] ]! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/5/2009 21:11'!
getConnectionIfNecessary
	(connection isNil and: [ usesConnectionPool ]) ifTrue: 
		[ connection := SqsConnectionManager getInstance getConnectionFor: connectionSpecification.
		connection isAlive ifFalse: [ 
			connection reconnect ] 
		].
! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 16:13'!
inTransactionDo: aBlock
	^ self inTransactionDo: aBlock ifError: [:err | self error: err]
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 16:07'!
inTransactionDo: aBlock ifError: anErrorBlock
	| result |
	"we need a stable connection for transactions, so why not get it here"
	self getConnectionIfNecessary.
	"nested transaction are tbd"
	^ isInTransaction ifTrue: [
		[aBlock value] ifError: [:err | anErrorBlock value: err]
	] ifFalse: [
	 	[ self beginTransaction.
			result := aBlock value.
			self commitTransaction.
			result 
		] ifError: [:err |
			self rollbackTransaction.
			anErrorBlock value: err
		]
	]
	
	! !

!SqsDatabaseAdapter methodsFor: 'initialization' stamp: 'tkow 2/24/2009 19:57'!
initialize
	super initialize.
	isInTransaction := false.
	usesConnectionPool := true.
! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
integer
	^'INTEGER'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'tkow 9/24/2008 16:18'!
largeInteger
	^'TEXT'.! !

!SqsDatabaseAdapter methodsFor: 'logging' stamp: 'tkow 3/9/2009 13:45'!
log: aString
	"[self logClient debug: aString] fork."! !

!SqsDatabaseAdapter methodsFor: 'logging' stamp: 'tkow 2/25/2009 18:03'!
logClient
	^ LogClient for: 'Squeak Save SQL Log'! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
mediumInteger
	^'MEDIUMINT'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 15:58'!
moveEntries: movedIds inJoinTable: aDescription forOwnerId: oid
	| sql |
	movedIds do: [:ids |
		sql := self queryToUpdateEntries: ids inJoinTable: aDescription forOwnerId: oid.
		self inTransactionDo: [self executeQuery: (sql)].
	]
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/13/2008 11:46'!
performSearch: anSqsQuery withLimit: limit
	| sql |
	sql := self queryForSearch: anSqsQuery withLimit: limit.
	^ self executeQuery: sql.
	! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 3/6/2009 13:43'!
queryAliasedTableInFromClause: aliasedTable

	| sql joinTables joinConditions |
	sql := aliasedTable originalTable tableName, ' AS ', aliasedTable aliasedName.
	
	joinTables := OrderedCollection new.
	joinConditions := OrderedCollection new.
	
	"join them consequitvely - when performance issues arise, change the join order"
	aliasedTable tableLinks do: [:tableLink |
		
		sql := sql, ' ', tableLink joinDirection, ' JOIN '.
		sql := sql, '',(self queryAliasedTableInFromClause: tableLink toTable), ' ON ('.
		
		sql := sql, ((tableLink fromFields collectWithIndex: [:field :index |
			aliasedTable aliasedName,'.', field ,' = ', tableLink toTable aliasedName, '.', (tableLink toFields at: index).
		]) join: ' AND ').
		sql := sql, ')'
	].
	^ sql ! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/11/2008 14:15'!
queryForAllUserTables
	^ self subclassResponsibility! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 3/3/2009 13:50'!
queryForLastOidOfTable: aTable
	self subclassResponsiblity! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'wh 8/11/2006 09:23'!
queryForRollback
	^'ROLLBACK'.! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/24/2009 15:30'!
queryForSearch: anSqsQuery withLimit: limit
	| sql |
	sql := 'SELECT '.
	anSqsQuery distinct ifTrue: [sql := sql, ' DISTINCT '].
	
	sql :=  sql, ((anSqsQuery valueTables collect: [:aliasedTable |
		(self explicitColumnsOfTable: aliasedTable)
	]) join: ', ').

	sql := sql,' FROM '.

	sql := sql, ((anSqsQuery queryTables collect: [:aliasedTable |
		(self queryAliasedTableInFromClause: aliasedTable)
	]) join: ', ').

	sql := sql, (self completeWhereStatementFor: anSqsQuery).
	
	anSqsQuery orderBy ifNotNil: [
		sql := sql, ' ORDER BY ', anSqsQuery orderBy
	].
	
	limit ifNotNil: [
		sql := sql, ' LIMIT ', limit asString
	].
	^sql
	! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/16/2009 16:26'!
queryForSimpleValuesOfCollection: descr ofObjectId: oid 
	| sql |
	sql := 'SELECT * FROM ' , descr tableName.
	sql := sql , ' WHERE ' , descr ownerColumn columnName , ' = ' , oid asSqlValueString.
	descr maintainOrder ifTrue: [ sql := sql , ' ORDER BY ' , descr orderField ].
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 3/9/2009 14:54'!
queryToAddBulkOfEntries: ids toJoinTable: aDescription forOwnerId: oid 
	| sql str |
	sql := 'INSERT INTO ' , aDescription tableName , '('.
	sql := sql , aDescription ownerColumn columnName , ', ' , aDescription referenceColumn columnName.
	aDescription maintainOrder ifTrue: [ sql := sql , ', ' , aDescription orderField ].
	sql := sql , ') VALUES '.
	sql := sql, ((ids collect: [:idArr | 
		str := '(' , oid asSqlValueString , ','.
		str := str , (idArr at: 1) asSqlValueString.
		aDescription maintainOrder ifTrue: [str := str , ', ', (idArr at: 2) asSqlValueString].
		str := str , ')'.	
	]) join: ', ').
	
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:54'!
queryToAddColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' ADD COLUMN '.
	sql := sql, aColumn columnName, ' ', (self perform: aColumn sqlType).
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/25/2009 22:21'!
queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid 
	"orderNumber := movedIds at: 2.
	newObjectId := movedIds at: 1."
	| sql |
	sql := 'INSERT INTO ' , aDescription tableName , '('.
	sql := sql , aDescription ownerColumn columnName , ', ' , aDescription referenceColumn columnName.
	aDescription maintainOrder ifTrue: [ sql := sql , ', ' , aDescription orderField ].
	sql := sql , ') VALUES (' , oid asString , ','.
	sql := sql , (ids at: 1) asSqlValueString.
	aDescription maintainOrder ifTrue: [sql := sql , ', ', (ids at: 2) asSqlValueString].
	sql := sql , ')'.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/25/2009 16:54'!
queryToAddFkConstraint: fkConstraint to: tableName 
	^ 'ALTER TABLE ' , tableName , ' ADD ' , (self 
			queryToCreateFkConstraint: fkConstraint
			in: tableName)! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:54'!
queryToAlterColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' MODIFY '.
	sql := sql, aColumn columnName, ' ', (self perform: aColumn sqlType).
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/15/2008 10:25'!
queryToCommit
	^ 'COMMIT'! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/25/2009 16:51'!
queryToCreateColumn: column 
	| sql |
	sql := column columnName , ' ' , (self perform: column sqlType).
	column canBeNull ifFalse: [ sql := sql , ' NOT NULL' ].
	column autoIncrement ifTrue: [ sql := sql , ' AUTO_INCREMENT ' ].
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/25/2009 17:02'!
queryToCreateCompleteTable: anSqSTable
	| sql |
	sql := (self queryToCreateTable: anSqSTable), ';'.	
	anSqSTable columns do: [:column |
		column foreignKey ifNotNil: [ 
			column isPrimaryKey ifFalse: [
				sql := sql, (self queryToCreateIndexOn: (OrderedCollection with: column columnName) in: anSqSTable tableName), ';'
			].
			sql := sql , (
				self queryToAddFkConstraint: column foreignKey to: column tableName
			) , ';'
	]].	
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/19/2009 20:22'!
queryToCreateFkConstraint: fkConstraint in: tableName
	| sql |
	sql := 'CONSTRAINT ' , (fkConstraint foreignKeyName: tableName) , ' FOREIGN KEY ('.
	sql := sql , (fkConstraint referencingColumns join: ',') , ') REFERENCES '.
	sql := sql , fkConstraint referencedTable , '(' , (fkConstraint referencedColumns join: ',') , ')'.
	fkConstraint deleteActions ifNotEmpty: [ sql := sql , ' ON DELETE ' ].
	sql := sql , (fkConstraint deleteActions join: ' ').
	fkConstraint updateActions ifNotEmpty: [ sql := sql , ' ON UPDATE ' ].
	sql := sql , (fkConstraint updateActions join: ' ').
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/19/2009 15:20'!
queryToCreateForeignKeyConstraint: fkConstraint ofColumn: aColumnName 
	| sql |
	sql := 'FOREIGN KEY ',(fkConstraint foreignKeyName) ,' ('. 
	sql := sql, (fkConstraint referencingColumns join: ','), ') REFERENCES '.
	sql := sql , fkConstraint referencedTable , '(' , (fkConstraint referencedColumns join: ',') , ')'.
	fkConstraint deleteActions ifNotEmpty: [ sql := sql , ' ON DELETE ' ].
	sql := sql, (fkConstraint deleteActions join: ' ').
	fkConstraint updateActions ifNotEmpty: [ sql := sql , ' ON UPDATE ' ].
	sql := sql, (fkConstraint updateActions join: ' ').
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/25/2009 17:13'!
queryToCreateIndexOn: columnNames in: tableName
	^ 'CREATE INDEX', (' idx_', (columnNames join: '_'), '_', tableName)  ,' ON ', tableName,' (', (columnNames join: ', '), ')'! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/11/2008 15:07'!
queryToCreateOidColumn: anSqsColumn
	^ self queryToCreateColumn: anSqsColumn! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/25/2009 17:00'!
queryToCreateTable: anSqSTable
	| sql primaryKeyColumns |
	sql := 'CREATE TABLE ' , anSqSTable tableName , ' ('.

	sql := sql, ((anSqSTable columns collect: [:column |
		column = anSqSTable oidColumn ifTrue: [
			self queryToCreateOidColumn: column
		] ifFalse: [
			self queryToCreateColumn: column
		]	
	]) join: ', ').

	primaryKeyColumns := (anSqSTable columns select: [ :column | column isPrimaryKey ]) collect: [ :column | column columnName ].
	sql := sql , ', PRIMARY KEY (' , (primaryKeyColumns join: ', ') , ')'.
	sql := sql , ')'.

	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 3/9/2009 13:37'!
queryToInsertColumnBulk: columnDicts inTable: aTableName
	| sql keys values |
	sql := 'INSERT INTO ', aTableName,' ('.
	keys := ''.
	values := Array new: columnDicts size.
	columnDicts withIndexDo: [:columnDict :index |
		| value |
		value := ''.
		keys := ''.
		columnDict associationsDo: [:assoc |
			keys := keys, assoc key, ', '.
			value := value, assoc value asString, ', '. 	
		].
		values at: index put: (value allButLast: 2).
	].
	sql := sql, (keys allButLast: 2), ') VALUES ', ((values collect: [:val | '(' ,val ,')']) join: ', ').
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 9/29/2008 14:46'!
queryToInsertColumns: columnDict inTable: aTableName
	| sql keys values |
	sql := 'INSERT INTO ', aTableName,' ('.
	keys := ''.
	values := ''.
	columnDict associationsDo: [:assoc |
		keys := keys, assoc key, ', '.
		values := values, assoc value asString, ', '.	
	].
	sql := sql, (keys allButLast: 2), ') VALUES (', (values allButLast: 2), ')'.
	^sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:46'!
queryToRemoveColumn: aColumn
	^'ALTER TABLE ',aColumn tableName,' DROP COLUMN ', aColumn columnName.! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/19/2009 20:28'!
queryToRemoveConstraint: fkConstraint from: tableName
	| |
	^ 'ALTER TABLE ', tableName, ' DROP FOREIGN KEY ', (fkConstraint foreignKeyName: tableName).! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'test 1/26/2009 14:45'!
queryToRemoveEntriesFromJoinTable: collectionDescr forObjectId: oid 
	| sql |
	sql := 'DELETE FROM ' , collectionDescr tableName , ' WHERE '.
	sql := sql , collectionDescr ownerColumn columnName , ' = ' , oid asSqlValueString.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'test 1/26/2009 14:45'!
queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid 
	| sql |
	sql := 'DELETE FROM ' , aDescription tableName , ' WHERE '.
	sql := sql , columnName , ' IN (' , (ids join: ',') , ') AND '.
	sql := sql , aDescription ownerColumn columnName , ' = ' , oid asString.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 15:28'!
queryToRemoveObjectWithId: oid fromTable: aTable
	
	^'DELETE FROM ', aTable tableName,' WHERE ',aTable oidColumn columnName,' = ',oid asString.! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 9/18/2008 16:55'!
queryToRenameColumns: columnsCollection
	| oldColumn sql newColumn |
	oldColumn := columnsCollection first.
	newColumn := columnsCollection at: 2.
	sql := 'ALTER TABLE ', oldColumn tableName, ' CHANGE '.
	sql := sql, oldColumn columnName, ' ', newColumn columnName, ' ', (self perform: newColumn sqlType).
	^sql 
	! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/5/2008 14:05'!
queryToRenameTable: oldName to: newName
	^ 'ALTER TABLE ',oldName, ' RENAME TO ', newName
! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 3/5/2009 17:59'!
queryToRollbackTransaction
	^ 'ROLLBACK'! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 12/15/2008 10:24'!
queryToStartTransaction
	^ 'START TRANSACTION'! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 3/6/2009 15:53'!
queryToTruncateTable: tableName
	^ 'TRUNCATE TABLE ', tableName! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 2/19/2009 13:46'!
queryToUpdateEntries: movedIds inJoinTable: aDescription forOwnerId: oid 
	"orderNumber := movedIds at: 2.
	newObjectId := movedIds at: 1."
	| sql |
	sql := 'UPDATE ' , aDescription tableName , '	SET '.
	sql := sql , aDescription referenceColumn columnName , ' = ' , ((movedIds at: 1) asSqlValueString).
	sql := sql , ' WHERE ' , aDescription ownerColumn columnName , ' = ' , oid asString.
	sql := sql , ' AND ' , aDescription orderField , ' = ' , (movedIds at: 2) asString.
	^ sql! !

!SqsDatabaseAdapter methodsFor: 'sql statements' stamp: 'tkow 11/10/2008 14:34'!
queryToUpdateFields: columnDict ofObjectWithId: oid inTable: aTable
	| sql |
	sql := 'UPDATE ' , aTable tableName , ' SET '.
	columnDict associationsDo: [:assoc | sql := sql , assoc key , ' = ' , assoc value asString , ', '].
	sql := (sql allButLast: 2) 	, ' WHERE ', aTable oidColumn columnName ,' = ' , oid asString.
	^sql! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/5/2009 19:50'!
removeColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	columnsCollection do: [:column |
		self executeQuery: (self queryToRemoveColumn: column).	
	]
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 2/19/2009 19:51'!
removeConstraints: constraintCollection from: tableName 
	| sql |
	constraintCollection do: 
		[ :constraint | 
		sql := self queryToRemoveConstraint: constraint from: tableName.
		self executeQuery: sql ]! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 15:58'!
removeEntries: deletedIds fromJoinTable: aDescription forOwnerId: oid
	| sql ids columnName |
	aDescription maintainOrder ifTrue: [
		ids := deletedIds collect: [: dids | dids last].
		columnName := aDescription orderField.
	] ifFalse: [
		ids := deletedIds collect: [: dids | dids first].
		columnName := aDescription referenceColumn columnName
	].
	sql := self queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid.
	self inTransactionDo: [self executeQuery: (sql)].! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 15:58'!
removeObjectWithId: oid fromTable: aSqSTable
	| sql |
	" this method has to be overwritten if the database can not guarantee that the entries
	in all available class table are removed when one object is being removed"
	sql := self queryToRemoveObjectWithId: oid fromTable: aSqSTable baseTable.
	self inTransactionDo: [self executeQuery: (sql)].! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/5/2009 19:50'!
renameColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	columnsCollection do: [:columnPair |
		self executeQuery: (self queryToRenameColumns: columnPair).	
	]
	! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/5/2008 14:04'!
renameTable: oldName to: newName
	| sql |
	sql := self queryToRenameTable: oldName to: newName.
	self executeQuery: sql.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 13:41'!
resetDatabase
	| tables retries curErrors |
	tables := self allTableNames.
	retries := tables copy.
	[ retries isEmpty ] whileFalse: 
		[ curErrors := OrderedCollection new.
		retries do: 
			[ :table | 
			[self executeQuery: 'DROP TABLE IF EXISTS ' , table]
				on: Error
				do: [:err | curErrors add: table ] ].
		retries := curErrors reversed ].! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/5/2009 20:03'!
rollbackTransaction
	isInTransaction := false.
	self executeQuery: self queryToRollbackTransaction.
! !

!SqsDatabaseAdapter methodsFor: 'data-preparation' stamp: 'tkow 2/26/2009 20:23'!
searchForCollectionDescribedBy: descr ofObject: anObject 
	| collectionConf referenceClassInfo referenceConf query queryTable joinTable joinQueryTable refIdField |
	collectionConf := anObject configuration collectionConfiguration.
	referenceClassInfo := SqsClassInfo for: (Smalltalk at: descr referencedClass).
	referenceConf := referenceClassInfo configuration tableConfiguration.
	
	query := SqsQuery on: referenceClassInfo currentClass.
	query whereBuffer: descr tableName , '.' , descr ownerColumn columnName , ' = ' , anObject oid asSqlValueString.

	joinTable := SqsTable new.
	joinTable tableName: descr tableName.

	refIdField := referenceConf idField.
	queryTable := self buildQueryTableFor: anObject joinOn: refIdField.

	joinQueryTable := self 
		createJoinQueryTableFrom: queryTable 
		to: joinTable 
		joinOn: refIdField 
		from: descr referenceColumn columnName.
	
	query valueTables add: queryTable.
	
	descr maintainOrder ifTrue: [
		query orderBy: collectionConf orderField.
		joinTable columns add: (SqsColumn new
			columnName: collectionConf orderField;
			sqlType: descr indexType;
			tableName: descr tableName;
			yourself).
		query valueTables add: joinQueryTable.
	].

	query queryTables add: joinQueryTable.
	query ignoreTypeField: true.
	^ query! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/13/2008 11:46'!
showFieldsOfTable: aTableName
	| |
	^ self executeQuery: ('SHOW FIELDS FROM ', aTableName).
! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
smallInteger
	^'SMALLINT'! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/9/2009 13:34'!
storeBulkColumns: columnDicts inTable: aTable
	| sql |
	sql := self queryToInsertColumnBulk: columnDicts inTable: aTable tableName.
	self executeQuery: sql.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 12/9/2008 16:45'!
storeColumns: columnDict inTable: aTable
	self storeColumns: columnDict inTable: aTable andReturnOId: false.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 16:13'!
storeColumns: columnDict inTable: aTable andReturnOId: aBool
	"columnDict is a Dictionary where a SqSaveColumnDescription points to the stored value"
	| sql results |
	sql := self queryToInsertColumns: columnDict inTable: aTable tableName.
	aBool ifTrue: [
		sql := sql, ';', (self queryForLastOidOfTable: aTable).
		results := self inTransactionDo: [self executeQuery: (sql)].
		^self lastOidOf: aTable fromResults: results
	].
	^ self inTransactionDo: [self executeQuery: (sql)].! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
string
	^self stringWithLength: 254.
	! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 23:21'!
stringWithLength: m
	^'VARCHAR(',m asString,')'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
text
	^'TEXT'.! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
time
	^'TIME'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 16:30'!
truncateDatabase
	| |
	self allTableNames do: [:tableName |
		self executeQuery: (self queryToTruncateTable: tableName)	
	].! !

!SqsDatabaseAdapter methodsFor: 'column types' stamp: 'tkow 2/16/2009 11:33'!
unsignedInteger
	"The SQL standard does not support unsigned Integer 
		imagine my suprise "
	^'INTEGER'.! !

!SqsDatabaseAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 15:59'!
updateFields: columnDict ofObjectWithId: oid inTable: aTable
	| sql |
	columnDict ifNotEmpty: [
		sql := self queryToUpdateFields: columnDict ofObjectWithId: oid inTable: aTable. 
		self inTransactionDo: [self executeQuery: (sql)].	
	].
	! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/30/2008 15:10'!
usesConnectionPool
	^ usesConnectionPool! !

!SqsDatabaseAdapter methodsFor: 'accessing' stamp: 'tkow 10/30/2008 15:10'!
usesConnectionPool: anObject
	usesConnectionPool := anObject! !

SqsDatabaseAdapter subclass: #SqsMysqlAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsMysqlAdapter class methodsFor: 'standard-values' stamp: 'tkow 3/6/2009 14:06'!
maxFieldLength
	^ 60! !

!SqsMysqlAdapter class methodsFor: 'instance creation' stamp: 'tkow 12/12/2008 17:36'!
newConnectionFor: anSqsConSpec 
	| spec connection |
	Socket initializeNetwork.
	spec := JdmConnectionSpec new initialize
		user: anSqsConSpec username;
		password: anSqsConSpec password;
		host: (NetNameResolver addressForName: anSqsConSpec hostname);
		database: anSqsConSpec database;
		port: anSqsConSpec port.
	connection := JdmConnection on: spec.
	^ SqsMySqlConnection withConnection: connection! !

!SqsMysqlAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 17:42'!
columnName: columnName aliasedWith: aliasName
	^ (super columnName: columnName aliasedWith: aliasName) asSqlValueString! !

!SqsMysqlAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 17:39'!
getConnectionIfNecessary
	super getConnectionIfNecessary.
! !

!SqsMysqlAdapter methodsFor: 'database operations' stamp: 'tkow 3/3/2009 14:08'!
lastOidOf: aTable fromResults: results
	 | oid |
	"MySQL will only retrun the last ID. Postgres needs the table part"  
	results collect: [:table |
		oid := (table at: self oidFieldAlias) asString asInteger. 	
	].
	^oid.
	! !

!SqsMysqlAdapter methodsFor: 'sql statements' stamp: 'tkow 3/3/2009 14:11'!
oidFieldAlias
	^'OID'! !

!SqsMysqlAdapter methodsFor: 'as yet unclassified' stamp: 'tkow 12/11/2008 14:16'!
queryForAllUserTables
	^ 'SHOW TABLES'! !

!SqsMysqlAdapter methodsFor: 'sql statements' stamp: 'tkow 3/3/2009 14:10'!
queryForLastOidOfTable: aTable 
	^ 'SELECT LAST_INSERT_ID() AS ', self oidFieldAlias! !

!SqsMysqlAdapter methodsFor: 'sql statements' stamp: 'tkow 9/19/2008 13:47'!
queryToCreateJoinTable: tableDescription
	^ (super queryToCreateJoinTable: tableDescription) , ' ENGINE=INNODB'.! !

!SqsMysqlAdapter methodsFor: 'sql statements' stamp: 'tkow 10/7/2008 16:25'!
queryToCreateTable: anSqSTable
	^ (super queryToCreateTable: anSqSTable) , ' ENGINE=INNODB'.! !

SqsDatabaseAdapter subclass: #SqsPostgresAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Connection'!

!SqsPostgresAdapter class methodsFor: 'special-columns' stamp: 'tkow 12/11/2008 17:41'!
columnTableSeperator
	^ '__'! !

!SqsPostgresAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:26'!
dayOfMonth
	^ 'Dy'! !

!SqsPostgresAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:34'!
dayOfWeek
	^ 'DOW'! !

!SqsPostgresAdapter class methodsFor: 'special-operations' stamp: 'tkow 3/6/2009 14:34'!
dayOfYear
	^ 'DOY'! !

!SqsPostgresAdapter class methodsFor: 'standard-values' stamp: 'tkow 3/6/2009 14:06'!
maxFieldLength
	^ 27! !

!SqsPostgresAdapter class methodsFor: 'instance creation' stamp: 'tkow 3/6/2009 03:05'!
newConnectionFor: anSqsConSpec 
	| spec connection |
	spec := PGConnectionArgs 
		hostname: anSqsConSpec hostname
		portno: anSqsConSpec port
		databaseName: anSqsConSpec database
		userName: anSqsConSpec username
		password: anSqsConSpec password.
	connection := PGConnection new.
	connection connectionArgs: spec.
	^ SqsPostgresConnection withConnection: connection! !

!SqsPostgresAdapter methodsFor: 'column types' stamp: 'tkow 12/12/2008 16:37'!
date
	^'DATE'! !

!SqsPostgresAdapter methodsFor: 'column types' stamp: 'tkow 3/6/2009 14:27'!
dateAndTime
	^'TIMESTAMP'! !

!SqsPostgresAdapter methodsFor: 'database operations' stamp: 'tkow 3/3/2009 14:04'!
lastOidOf: aTable fromResults: results
	| oidField |
	oidField := (SqsClassInfo for: (Smalltalk at: aTable associatedClass)) configuration tableConfiguration idField.
	^ results
		ifEmpty: [ nil ]
		ifNotEmpty: 
			[ (results at: 1) 
				at: oidField
				ifAbsent: [ nil ] ]! !

!SqsPostgresAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 13:09'!
queryForAllUserTables
	| sql |
	sql := 'SELECT table_name FROM information_schema.tables WHERE table_schema = ''public'' AND table_type = ''BASE TABLE'''.
	^ sql! !

!SqsPostgresAdapter methodsFor: 'sql statements' stamp: 'tkow 3/3/2009 14:05'!
queryForLastOidOfTable: aTable 
	| oidField oidSequence |
	oidField := (SqsClassInfo for: (Smalltalk at: aTable associatedClass)) configuration tableConfiguration idField.
	oidSequence := '"' , aTable tableName asLowercase , '_' , aTable oidColumn columnName , '_seq"'.
	^ 'SELECT currval(''' , oidSequence , ''') AS ' , oidField.! !

!SqsPostgresAdapter methodsFor: 'sql statements' stamp: 'tkow 3/6/2009 13:24'!
queryToAlterColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' ALTER COLUMN '.
	sql := sql, aColumn columnName, ' TYPE ', (self perform: aColumn sqlType).
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqsPostgresAdapter methodsFor: 'sql statements' stamp: 'tkow 12/11/2008 15:11'!
queryToCreateOidColumn: anSqsColumn
	^ anSqsColumn columnName, ' SERIAL'! !

!SqsPostgresAdapter methodsFor: 'sql statements' stamp: 'tkow 3/6/2009 13:31'!
queryToRenameColumns: columnsCollection
	| oldColumn sql newColumn |
	oldColumn := columnsCollection first.
	newColumn := columnsCollection at: 2.
	sql := 'ALTER TABLE ', oldColumn tableName, ' RENAME '.
	sql := sql, oldColumn columnName, ' TO ', newColumn columnName.
	^sql 
	! !

!SqsPostgresAdapter methodsFor: 'sql statements' stamp: 'tkow 3/6/2009 15:54'!
queryToTruncateTable: tableName
	^  'DELETE FROM TABLE ', tableName! !

!SqsPostgresAdapter methodsFor: 'column types' stamp: 'tkow 12/12/2008 16:37'!
time
	^'TIME'! !

!SqsPostgresAdapter methodsFor: 'database operations' stamp: 'tkow 3/6/2009 16:30'!
truncateDatabase
	| sql |
	sql := 'TRUNCATE TABLE ', (self allTableNames join: ', ').
	self executeQuery: sql
	! !

Object subclass: #SqsDescriptionHandler
	instanceVariableNames: 'currentObject classInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsDescriptionHandler commentStamp: 'tk 5/22/2008 10:47' prior: 0!
A TKSaveDescriptionHandler is an abstract base class for the description handlers of the TKSave framework.
It defines methods that subclasses have to implement in order to be able to create, update, delete and read the descriptions of TKSaveBase subclasses.
It is therefore ment to provide a clean abstraction for the problem of describing the way objects are being stored within the database.

Instance Variables
	sampleObject:		anObject that determines how the descriptors will loke like
			
sampleObject
	- xxxxx!

!SqsDescriptionHandler class methodsFor: 'cached-creation' stamp: 'test 10/6/2008 18:30'!
forClassInfo: aClassInfo
	^ (self new)
		classInfo: aClassInfo;
		yourself! !

!SqsDescriptionHandler class methodsFor: 'cached-creation' stamp: 'tkow 9/30/2008 11:33'!
forObject: aSampleObject 
	^ (self new) 
		currentObject: aSampleObject;
		classInfo: (aSampleObject classInfo);
		yourself! !

!SqsDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 2/22/2009 14:02'!
sqlTypeSelector
	^ #sqsType! !

!SqsDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 2/22/2009 14:02'!
sqlValueStringSelector
	^ #asSqlValueString! !

!SqsDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/18/2008 16:12'!
standardSqlType
	^#integer! !

!SqsDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 2/22/2009 14:01'!
tableNameSelector
	^ #sqsTableName! !

!SqsDescriptionHandler methodsFor: 'object-transformation' stamp: 'test 1/24/2009 15:35'!
adaptObject: anObject toSpecificationOfInstVar: ivarName 
	| description |
	description := self sqsDescriptionForInstVar: ivarName.
	^ description 
		ifNil: [ nil ]
		ifNotNil: 
			[ description associatedClass 
				ifNil: 
					[ description describesCollection 
						ifTrue: 
							[ SqsStorage 
								createCollectionProxyFor: ivarName
								with: anObject
								in: self currentObject storedObject
								description: description ]
						ifFalse: 
							[ self 
								transformObject: anObject
								toMatchDescription: description ] ]
				ifNotNil: 
					[ SqsStorage 
						createProxyFor: ivarName
						with: anObject
						in: self currentObject storedObject ] ]! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 18:01'!
classInfo
	^ classInfo! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 18:01'!
classInfo: anObject
	classInfo := anObject! !

!SqsDescriptionHandler methodsFor: 'table-information' stamp: 'tkow 3/8/2009 23:39'!
classTableColumns
	| variables columnDescription columns |
	variables := self persistedVariablesOfCurrentClass.
	columns := OrderedCollection new.
	variables do: 
		[ :var | 
		columnDescription := self sqsDescriptionForInstVar: var.
		columnDescription 
			ifNil: 
				[ columns add: (SqsColumn new
						columnName: var decamelized;
						tableName: self classInfo tableName;
						sqlType: self class standardSqlType;
						linkedVariable: var;
						yourself) ]
			ifNotNil: 
				[ columnDescription describesCollection ifFalse: [ columns add: columnDescription ] ] ].
	^ columns! !

!SqsDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 14:05'!
columnNameFor: aString
	| maxLength |
	maxLength := classInfo configuration adapterClass maxFieldLength.
	^ (aString size > maxLength) ifTrue: [
		aString first: maxLength
	] ifFalse: [
		aString
	]! !

!SqsDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 2/28/2009 12:25'!
compileMethodCode: code intoClass: aClass
	(aClass organization categories includes: self descriptorMethodCategory)
		ifTrue: [aClass organization addCategory: self descriptorMethodCategory].
	aClass class compile: code classified: self descriptorMethodCategory withStamp: nil notifying: nil logSource: false.! !

!SqsDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 10/10/2008 11:07'!
createDescriptions
	"overwrite me to enable automatic creation of descriptions"
	! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 3/6/2009 19:02'!
currentObject
	^ currentObject at: 1 ifAbsent: [nil]! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 3/6/2009 19:02'!
currentObject: anObject 
	currentObject := WeakArray with: anObject! !

!SqsDescriptionHandler methodsFor: 'private' stamp: 'tk 5/22/2008 10:52'!
descriptorMethodCategory
	^'auto-generated-description'! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'test 1/24/2009 15:35'!
directlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self persistedInstanceVariables do: 
		[ :ivn | 
		descr := self sqsDescriptionForInstVar: ivn.
		descr ifNotNil: 
			[ descr associatedClass ifNotNil: 
				[ ivarValue := self getIvarValue: ivn.
				ivarValue ifNotNil: [ referencedObjects add: ivarValue ] ] ] ].
	^ referencedObjects! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/30/2008 14:11'!
getIvarValue: ivn 
	| |
	^ self useInstVarAccessors 
		ifTrue: [ self currentObject storedObject perform: ivn asSymbol ]
		ifFalse: [ self currentObject storedObject instVarNamed: ivn asSymbol ] 
! !

!SqsDescriptionHandler methodsFor: 'printing' stamp: 'tk 6/19/2008 14:17'!
indent: noOfTabs
	| indent |
	indent := String cr.
	0 to: noOfTabs do: [ :i |
		indent := indent, String tab.
	].
	^indent! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 2/23/2009 17:37'!
indexClassOfDictionary: aDictionary 
	| indexBaseType |
	indexBaseType := nil.
	aDictionary keysDo: 
		[ :key | 
		key class sqsIsComplexClass ifTrue: 
			[ self error: 'only simple types allowed as dictionary keys (use id or something...)' ].
		indexBaseType 
			ifNil: [ indexBaseType := key class perform: self class sqlTypeSelector ]
			ifNotNil: 
				[ (key class perform: self class sqlTypeSelector) = indexBaseType ifFalse: 
					[ self error: 'mixed keys? not so good for storing this in a database' ] ] ].
	^ aDictionary keys anyOne class! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 2/19/2009 22:13'!
indirectlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self persistedInstanceVariables do: 
		[ :ivn | 
		descr := self sqsDescriptionForInstVar: ivn.
		descr ifNotNil: [ 
			descr describesCollection ifTrue: [ 
				ivarValue := self getIvarValue: ivn.
				ivarValue isNil ifFalse: [
					referencedObjects add: (SqsCollectionInformation new
						collection: ivarValue;
						collectionDescription: descr;
						yourself) ] ] ] ].
	^ referencedObjects! !

!SqsDescriptionHandler methodsFor: 'testing' stamp: 'tkow 2/23/2009 17:36'!
isComplexCollection: aCollection 
	"this check tries to find out whether a collection includes 'simple' objects. This is necessary, because collections with simple value don't point to another table but 	instead contain the values themselves. Addtionally there is a check to find out whether all values of a collection are somehow related to one-another,
	because only such values can be stored in a reasonable manner. Return value is true or false and tells us whether this collection holds complex objects or not"
	| sampleValue complexCollection isDict baseClass |
	sampleValue := nil.
	complexCollection := true.
	isDict := aCollection isDictionary.
	aCollection do: 
		[ :element | 
		| currentValue |
		currentValue := isDict 
			ifTrue: [ element value ]
			ifFalse: [ element ].
		currentValue ifNotNil: 
			[ sampleValue ifNil: [ sampleValue := currentValue ].
			complexCollection := currentValue class sqsIsComplexClass.
			baseClass := sampleValue class sqsBaseClass.
			((currentValue class includesBehavior: baseClass) or: [ sampleValue class inheritsFrom: currentValue class ]) ifFalse: 
				[ self error: 'SqueakSave currently only supports collections with values that belong to the same base class (other than object...)' ] ] ].
	^ complexCollection! !

!SqsDescriptionHandler methodsFor: 'testing' stamp: 'tkow 2/23/2009 17:38'!
isComplexObject: anObject 
	"determines whether an object is of a primitive type that can be stored
	directly in a database column, or if an additional table is required"
	^ anObject class sqsIsComplexClass! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 2/19/2009 22:18'!
ownedCollections
	| ownedCollections descr |
	ownedCollections := OrderedCollection new.
	self persistedInstanceVariables do: 
		[ :ivn | 
		descr := self sqsDescriptionForInstVar: ivn.
		descr ifNotNil: [ 
			descr describesCollection ifTrue: [ 
				ownedCollections add: descr
			] 
		] 
	].
	^ ownedCollections! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 3/9/2009 00:21'!
persistedInstanceVariables
	| persistedVars klass |
	persistedVars := Set new.
	klass := classInfo currentClass.
	[klass = Object] whileFalse: [ 
		persistedVars addAll: klass instVarNames.
		persistedVars := persistedVars difference: (self unpersistedInstVarsOf: klass).
		klass := klass superclass
	].
	^ persistedVars! !

!SqsDescriptionHandler methodsFor: 'table-information' stamp: 'tkow 3/8/2009 23:42'!
persistedVariablesOfCurrentClass
	| ivars |
	ivars := (classInfo currentClass = classInfo currentClass sqsBaseClass) ifTrue: [
		classInfo currentClass allInstVarNames 
	] ifFalse: [
		classInfo currentClass instVarNames
	].
	^ ivars difference: (self unpersistedInstVarsOf: classInfo currentClass)! !

!SqsDescriptionHandler methodsFor: 'testing' stamp: 'tkow 2/23/2009 17:44'!
sqlTypeForObject: anObject 
	"determines the sql type for an object - this will always return at least 
	INTEGER since every object should be storeable somehow"
	^ (anObject respondsTo: self class sqlTypeSelector) 
		ifTrue: [ anObject perform: self class sqlTypeSelector ]
		ifFalse: 
			[ (anObject class sqsIsComplexClass) 
				ifFalse: [ anObject class perform: self class sqlTypeSelector ]
				ifTrue: [ self class standardSqlType ] ]! !

!SqsDescriptionHandler methodsFor: 'accessing' stamp: 'test 1/24/2009 15:35'!
sqsDescriptionForInstVar: ivarName 
	^ self subclassResponsibility! !

!SqsDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 3/8/2009 23:48'!
tableName
	^ (classInfo currentClass class selectors includes: self class tableNameSelector) ifTrue: [ 
		classInfo currentClass perform: self class tableNameSelector 
	] ifFalse: [ 
		(classInfo currentClass = classInfo currentClass sqsBaseClass) ifTrue: [
			(classInfo currentClass respondsTo: self class tableNameSelector) ifTrue: [
				classInfo currentClass perform: self class tableNameSelector	
			] ifFalse: [
				self classInfo tableStructureHandler tableName
			]
		] ifFalse: [
			self classInfo tableStructureHandler tableName 	
		]
	]! !

!SqsDescriptionHandler methodsFor: 'table-information' stamp: 'test 1/25/2009 15:37'!
tableNameForClass: aClass 
	^ (SqsClassInfo for: aClass) tableName! !

!SqsDescriptionHandler methodsFor: 'table-information' stamp: 'tkow 3/9/2009 00:33'!
tableNameForInstVar: ivn
	self currentObject doForAllSuperclasses: [ :aClass |
		(aClass instVarNames includes: ivn) ifTrue: [
			^ self tableNameForClass: aClass
		]
	].
	^ self tableNameForClass: classInfo currentClass sqsBaseClass! !

!SqsDescriptionHandler methodsFor: 'object-transformation' stamp: 'tkow 1/19/2009 17:59'!
transformObject: anObject toMatchDescription: description 
	"this is merely a hack to avoid some driver problems. Since some drivers deliver wrong 
	 classes (i.e. strings 0 or 1 insteda of true and false) we call the fromSqlValue function on
	 the classes where everything breaks. This also helps to create symbols instead of strings."
	| desiredClass |
	desiredClass := Smalltalk at: description objectClass.
	^ desiredClass fromSqlValue: anObject! !

!SqsDescriptionHandler methodsFor: 'variable-information' stamp: 'tkow 9/30/2008 14:25'!
unpersistedInstVars
	| unpersistedVars |
	"gather the unpersisted instance variables of all classes within the inheritance chain"
	unpersistedVars := Set new.
	self classInfo doForAllSuperclasses: [ :currentClass |
		unpersistedVars addAll: (self unpersistedInstVarsOf: currentClass).
	].
	^unpersistedVars
	! !

!SqsDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/3/2008 18:23'!
unpersistedInstVarsOf: klass
	self subclassResponsibility! !

!SqsDescriptionHandler methodsFor: 'configuration' stamp: 'tkow 11/7/2008 16:22'!
useInstVarAccessors
	^ self classInfo configuration useInstVarAccessors! !

SqsDescriptionHandler subclass: #SqsStandardDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsStandardDescriptionHandler commentStamp: 'tk 6/19/2008 15:22' prior: 0!
A TKSaveMagritteDescriptionHandler is  .

Instance Variables
!

!SqsStandardDescriptionHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 16:13'!
unpersistedInstVarsFunction
	^#sqSaveUnpersistedInstVars! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 2/28/2009 14:26'!
changeCollectionDescriptionFor: ivn from: oldDescription becauseOf: aCollection
	| collectionSample nilValue complexValues refClass changeNotNecessary classesMatch collectionOrderTheSame collectionClassMatches necessaryChanges |

	"first check - object instead of collection"
	aCollection isCollection ifFalse: [
		^ self questionToChangeAssoc: ivn classFrom: (Smalltalk at: oldDescription collectionClass) to: aCollection sqsClass
	].

	"let's check if we have a proxy - if so and it has not been loaded, we're fine here''"
	(aCollection class includesBehavior: SqsProxy) ifTrue: [
		aCollection sqsProxiedObject ifNil: [^ false]	
	].

	collectionSample := self sampleOfCollection: aCollection.
	complexValues := self isComplexCollection: aCollection.
	refClass := self collectionElementClassOf: collectionSample complexValues: complexValues.
	nilValue := self nilValueForCollection: aCollection.

	classesMatch := (refClass = oldDescription referencedClass).
	collectionOrderTheSame := aCollection sqsClass sqsRequiresOrderField = ((Smalltalk at: oldDescription collectionClass) sqsRequiresOrderField).
	collectionClassMatches := aCollection sqsClass = (Smalltalk at: oldDescription collectionClass).

	changeNotNecessary := classesMatch & collectionOrderTheSame & collectionClassMatches.

	^ changeNotNecessary ifTrue: [
		false	
	] ifFalse: [
		necessaryChanges := Dictionary new
			at: 'classes do not match' put: classesMatch;
			at: 'collection order changed' put: collectionOrderTheSame;
			at: 'collection class changed' put: collectionClassMatches.
		self questionToChangeCollectionFor: ivn becauseOf: necessaryChanges.
	].	

	
! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 3/8/2009 23:50'!
changeDescriptionOf: ivn from: oldDescription becauseOf: anObject
	| typesMatch newType userApproved associationClassMatches |

	"first check - collection instead of object"
	(anObject isCollection and: [anObject isString not]) ifTrue: [
		((anObject class includesBehavior: SqsProxy) and: [anObject sqsProxiedObject isNil]) ifTrue: [
			self error: 'can not create description based on unloaded proxy'
		] ifFalse: [
			^ (self questionToChangeAssoc: ivn classFrom: oldDescription associatedClass to: Collection)
		]	
	].

	"check whether our types directly match, or if we have a larger type that covers the lower one"
	newType := self sqlTypeForObject: anObject.
	typesMatch := newType = oldDescription sqlType.
	typesMatch ifFalse: [
		typesMatch := self currentObject sqsSession sqsDbAdapter does: oldDescription sqlType cover: newType
	].
	associationClassMatches := (oldDescription associatedClass notNil and: [anObject class sqsIsComplexClass])  ifTrue: [
		anObject class name = oldDescription associatedClass
	] ifFalse: [
		true
	].


	"and ask our user for approval, if there is something to change"
	userApproved := (typesMatch and: [associationClassMatches]) ifTrue: [
		false
	] ifFalse: [
		(self questionToChangeAssoc: ivn classFrom: oldDescription associatedClass to: anObject sqsClass).	
	].

	^ userApproved
	
	! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 10/9/2008 10:27'!
collectionDescriptionFor: ivn inClass: aClass basedOn: aCollection 
	"only create descriptors for non-empty collections"
	^ aCollection isEmpty 
		ifTrue: [ nil ]
		ifFalse: 
			[ self 
				persistenceDescriptionForCollection: aCollection
				withLabel: ivn
				complexValues: (self isComplexCollection: aCollection) ]! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 2/23/2009 17:30'!
collectionElementClassOf: collectionSample complexValues: complexValues
	^ complexValues 
		ifTrue: [ collectionSample class sqsBaseClass name ]
		ifFalse: [ collectionSample class name ].! !

!SqsStandardDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 3/6/2009 14:01'!
columnDescriptionForObject: anObject ofInstVar: instVarName linkedTo: aClass 
	| column sqlType objectClass |
	column := SqsColumn new.
	sqlType := self sqlTypeForObject: anObject.
		
	objectClass := (self isComplexObject: anObject) ifTrue: [
		(SqsClassInfo for: anObject class) baseClass name
	] ifFalse: [
		anObject class name
	].
	
	column
		columnName: (self columnNameFor: instVarName decamelized);
		objectClass: objectClass;
		linkedVariable: instVarName;
		tableName: (self tableNameForInstVar: instVarName);
		sqlType: sqlType.
		
	aClass ifNotNil: 
		[ column associatedClass: aClass.
		column columnName: (self columnNameFor: (instVarName decamelized , '_id')) ].
	^ column! !

!SqsStandardDescriptionHandler methodsFor: 'code-compilation' stamp: 'tkow 10/10/2008 11:07'!
createDescriptions
	| anObject targetClass |
	self persistedInstanceVariables do: 
		[ :ivn | 
		anObject := self getIvarValue: ivn.
		targetClass := self targetClassForDescriptorOfInstVar: ivn.
		anObject ifNotNil: 
			[ (targetClass respondsTo: ivn asSqSaveDescriptionSelector) 
				ifTrue: 
					[ self 
						updatePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ]
				ifFalse: 
					[ self 
						writePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ] ] ]! !

!SqsStandardDescriptionHandler methodsFor: 'private' stamp: 'tk 8/31/2008 15:17'!
descriptorMethodCategory
	^'persistence-description'! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 3/8/2009 23:49'!
joinTableNameFor: ivn
	| ivnClass |
	
	ivnClass := self currentObject storedObject class.
	"this ensures that we name the join table correctly. If we would just take the
	base class, we would have major trouble with abstract base classes for objects.
	Also two subclasses defining the same variable would lead to a table name clash"
	[ivnClass instVarNames includes: ivn] whileFalse: [ivnClass := ivnClass superclass].
	^ ivnClass name asSqSaveTableName , '_' , ivn decamelized! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 2/19/2009 13:44'!
nilValueForCollection: aCollection
	^ (aCollection anySatisfy: [:el | el isNil])! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 3/6/2009 14:02'!
ownerColumnForCurrentObject
	| columnName |
	columnName := self classInfo baseClass name decamelized , '_id'.
	columnName := self columnNameFor: columnName.
	
	^ SqsColumn new
		sqlType: (Integer perform: self class sqlTypeSelector);
		columnName: columnName;
		foreignKey: (SqsForeignKeyDescription new
				referencedColumns: (Set with: self classInfo configuration tableConfiguration idField);
				referencingColumns: (Set with: columnName);
				referencedTable: self classInfo tableName;
				deleteActions: (OrderedCollection with: classInfo configuration adapterClass cascadeAction));
		linkedVariable: #SQSOWNER;
		canBeNull: false! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 2/23/2009 17:30'!
persistenceDescriptionForCollection: aCollection withLabel: ivn complexValues: complexValues 
	| ownerColumn collectionSample referenceColumn referenceTableName indexType refClass |
	ownerColumn := self ownerColumnForCurrentObject.
	collectionSample := self sampleOfCollection: aCollection.
	refClass := self 
		collectionElementClassOf: collectionSample
		complexValues: complexValues.
	referenceColumn := self 
		referenceColumnDescriptionNamed: ivn
		for: collectionSample
		simpleValues: complexValues not.
	referenceTableName := complexValues 
		ifTrue: [ self tableNameForClass: collectionSample class sqsBaseClass ]
		ifFalse: [ nil ].
	indexType := (aCollection isDictionary 
		ifTrue: [ self indexClassOfDictionary: aCollection ]
		ifFalse: [ Integer ]) perform: self class sqlTypeSelector.
	^ SqsCollectionDescription new
		referenceColumn: referenceColumn;
		collectionClass: aCollection sqsClass name;
		maintainOrder: aCollection sqsClass sqsRequiresOrderField;
		indexType: indexType;
		referencedClass: refClass;
		simpleValues: complexValues not;
		ownerColumn: ownerColumn;
		linkedVariable: ivn;
		orderField: classInfo configuration collectionConfiguration orderField;
		tableName: (self joinTableNameFor: ivn)! !

!SqsStandardDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 2/16/2009 17:51'!
persistenceDescriptionForObject: anObject withLabel: aLabel
	| linkedClass |
	linkedClass := (self isComplexObject: anObject) 
		ifTrue: [ (SqsClassInfo for: anObject class) baseClass name ]
		ifFalse: [ nil ].
	^ self 
		columnDescriptionForObject: anObject
		ofInstVar: aLabel
		linkedTo: linkedClass! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'test 1/25/2009 15:19'!
persistenceDescriptorFor: ivn inClass: aClass basedOn: anObject 
	"ensure that for all collections (except for strings) we create different descriptors"
	^ (anObject isCollection and: [ anObject isString not ]) 
		ifTrue: 
			[ self 
				collectionDescriptionFor: ivn
				inClass: aClass
				basedOn: anObject ]
		ifFalse: 
			[ self 
				persistenceDescriptionForObject: anObject
				withLabel: ivn 
			]! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'test 1/27/2009 17:40'!
questionToChangeAssoc: ivn classFrom: previousClass to: newClass 
	| dialogText |
	^ self classInfo configuration warnOnAlteration ifTrue: [
		dialogText := 'Change class of ' , ivn , ' from ' , previousClass name , ' to ' , newClass name , '?'.
		self confirm: dialogText.
	] ifFalse: [
		true
	]
	! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 2/16/2009 20:51'!
questionToChangeCollectionFor: ivn becauseOf: necessaryChanges
	| msg |
	classInfo configuration warnOnAlteration ifTrue: [
		msg := 'Collection for ', ivn, ' has to be changed because: ', String cr.
		necessaryChanges associationsDo: [:assoc |
			assoc value ifFalse: [
				msg := msg, assoc key, String cr.	
			]	
		].
		^ self confirm: msg
	] ifFalse: [
		^ true
	]	! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 3/6/2009 14:01'!
referenceColumnDescriptionNamed: ivn for: collectionSample simpleValues: aBool 
	| referenceColumn sqlType columnName colSampleInfo |
	sqlType := self sqlTypeForObject: collectionSample.
	columnName := aBool ifTrue: [
		self classInfo configuration collectionConfiguration valueField
	] ifFalse: [
		ivn decamelized, '_id'
	].
	columnName := (self columnNameFor: columnName).
		
	referenceColumn := SqsColumn new
		sqlType: sqlType;
		columnName: columnName;
		canBeNull: false;
		linkedVariable: #SQSREF.
		
	"create the foreign key relationship only if our collection elements are no simple values but complex ones"
	"and of course only if the table for the element has already been created"
	aBool ifFalse: [
		colSampleInfo := SqsClassInfo for: collectionSample class.
		colSampleInfo tableForClassExists ifTrue: [
			referenceColumn 
				foreignKey: (SqsForeignKeyDescription new
					referencedColumns: (Set with: colSampleInfo configuration tableConfiguration idField);
					referencingColumns: (Set with: columnName);
					referencedTable: (self tableNameForClass: collectionSample class sqsBaseClass);
					deleteActions: #(#CASCADE )
				)
		]			 
	].
	^ referenceColumn! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 2/23/2009 17:27'!
sampleOfCollection: aCollection
	| collectionSample |
	collectionSample := nil.
	aCollection do: [ :element | collectionSample ifNil: [ collectionSample := element ] ].
	^ collectionSample.
	! !

!SqsStandardDescriptionHandler methodsFor: 'accessing' stamp: 'test 1/25/2009 16:08'!
sqsDescriptionForInstVar: ivarName 
	| curClass |
	curClass := self targetClass.
	(curClass respondsTo: ivarName asSqSaveDescriptionSelector) ifTrue: [ 
		^ curClass perform: ivarName asSqSaveDescriptionSelector 
	] ifFalse: [
		curClass allSubclassesDo: [:aClass |
			(aClass respondsTo: ivarName asSqSaveDescriptionSelector) ifTrue: [ 
				^ aClass perform: ivarName asSqSaveDescriptionSelector 
			]			
		]
	].
	^ nil
! !

!SqsStandardDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 13:06'!
targetClass
	^self subclassResponsibility
	! !

!SqsStandardDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 3/9/2009 00:37'!
targetClassForDescriptorOfInstVar: ivn
	| |
	self currentObject doForAllSuperclasses: [ :aClass |
		(aClass instVarNames includes: ivn) ifTrue: [^ aClass]
	].
	^ classInfo currentClass sqsBaseClass! !

!SqsStandardDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 9/10/2008 16:13'!
unpersistedInstVarsOf: aClass
	^(aClass respondsTo: self class unpersistedInstVarsFunction) ifTrue: [
		(aClass perform: self class unpersistedInstVarsFunction)
	] ifFalse: [
		#()
	].! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 2/19/2009 22:06'!
updatePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| oldDescription |
	oldDescription := aClass perform: ivn asSqSaveDescriptionSelector.
	"for the brave ones, we leave everything as is"
	oldDescription manuallyMaintained ifFalse: [
		oldDescription describesCollection ifTrue: [
			(self changeCollectionDescriptionFor: ivn from: oldDescription becauseOf: anObject) ifTrue: [
				self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.	
			]		
		] ifFalse: [
			(self changeDescriptionOf: ivn from: oldDescription becauseOf: anObject) ifTrue:[
				self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.	
			]
		]
	].	
	! !

!SqsStandardDescriptionHandler methodsFor: 'descriptor-creation' stamp: 'tkow 2/16/2009 19:56'!
writePersistenceDescriptorFor: ivn basedOn: anObject inClass: targetClass 
	| description code |
	description := self 
		persistenceDescriptorFor: ivn
		inClass: targetClass
		basedOn: anObject.
	description ifNotNil: [ 
		code := ivn asSqSaveDescriptionSelector , String cr.
		code := code , '^' , description codeForObjectCreation.
		self compileMethodCode: code intoClass: targetClass 
	]! !

SqsStandardDescriptionHandler subclass: #SqsStandardExternDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsStandardExternDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 3/10/2009 16:28'!
createExternalDescriptorClassNamed: targetName
	"this function creates all required descriptor classes up to the base class"
	| classes targetCategory currentSuperclass |
	
	classes := OrderedCollection new.
	self classInfo doForAllSuperclasses: [:aClass |
		classes add: aClass.	
	].
	targetCategory := self classInfo currentClass basicCategory asString.
	currentSuperclass := Object.
	classes reverseDo: [:aClass |
		| descrClassName |
		descrClassName := aClass name asSqSaveDescriptorClassName.
		currentSuperclass := Smalltalk at: (descrClassName) ifAbsent: [
			currentSuperclass subclass: descrClassName
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: targetCategory
		]
	].
	^Smalltalk at: targetName! !

!SqsStandardExternDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 14:02'!
targetClass
	| targetName |
	targetName := self classInfo currentClass name asSqSaveDescriptorClassName.
	^self createExternalDescriptorClassNamed: targetName.
	! !

!SqsStandardExternDescriptionHandler methodsFor: 'object-information' stamp: 'tkow 10/10/2008 14:03'!
targetClassForDescriptorOfInstVar: ivn
	| targetName |
	targetName := (super targetClassForDescriptorOfInstVar: ivn) name asSqSaveDescriptorClassName.
	^self createExternalDescriptorClassNamed: targetName.! !

SqsStandardDescriptionHandler subclass: #SqsStandardInternDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsStandardInternDescriptionHandler methodsFor: 'printing' stamp: 'tkow 10/10/2008 13:07'!
targetClass
	^self classInfo currentClass! !

Object subclass: #SqsDesignObject
	instanceVariableNames: 'type buildDate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

SqsDesignObject subclass: #SqsAssembly
	instanceVariableNames: 'superAssembly module'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsAssembly class methodsFor: 'persistence-description' stamp: ''!
sqsDescrBuildDate
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'build_date';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_assemblys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'buildDate';
		 yourself! !

!SqsAssembly class methodsFor: 'persistence-description' stamp: ''!
sqsDescrModule
	^ SqsColumn new associatedClass: #SqsModule;
		 manuallyMaintained: false;
		 columnName: 'module_id';
		 sqlType: #integer;
		 objectClass: #SqsModule;
		 tableName: 'sqs_assemblys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'module';
		 yourself! !

!SqsAssembly class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSuperAssembly
	^ SqsColumn new associatedClass: #SqsAssembly;
		 manuallyMaintained: false;
		 columnName: 'super_assembly_id';
		 sqlType: #integer;
		 objectClass: #SqsAssembly;
		 tableName: 'sqs_assemblys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'superAssembly';
		 yourself! !

!SqsAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:49'!
module
	^ module! !

!SqsAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:49'!
module: anObject
	module := anObject! !

!SqsAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:49'!
superAssembly
	^ superAssembly! !

!SqsAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:49'!
superAssembly: anObject
	superAssembly := anObject! !

SqsAssembly subclass: #SqsBaseAssembly
	instanceVariableNames: 'sharedParts unsharedParts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsBaseAssembly class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUnsharedParts
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #Set;
		 tableName: 'sqs_base_assemblys_unshared_parts';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sqs_assembly_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_base_assemblys';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'sqs_assembly_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'unshared_parts_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_composite_parts';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'unshared_parts_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: false;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #SqsCompositePart;
		 linkedVariable: 'unsharedParts';
		 orderField: 'sqs_order_number';
		 yourself! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'tkow 2/28/2009 13:20'!
addUnsharedPart: aPart
	aPart addBaseAssembly: self.
	unsharedParts add: aPart.! !

!SqsBaseAssembly methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 13:21'!
initialize
	super initialize.
	unsharedParts := Set new.	
! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:59'!
sharedParts
	^ sharedParts! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:59'!
sharedParts: anObject
	sharedParts := anObject! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:59'!
unsharedParts
	^ unsharedParts! !

!SqsBaseAssembly methodsFor: 'accessing' stamp: 'test 2/2/2009 16:59'!
unsharedParts: anObject
	unsharedParts := anObject! !

SqsAssembly subclass: #SqsComplexAssembly
	instanceVariableNames: 'subAssemblies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsComplexAssembly class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSubAssemblies
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #Set;
		 tableName: 'sqs_complex_assemblys_sub_assemblies';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sqs_assembly_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_complex_assemblys';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'sqs_assembly_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sub_assemblies_id';
			 sqlType: #integer;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: false;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #SqsAssembly;
		 linkedVariable: 'subAssemblies';
		 orderField: 'sqs_order_number';
		 yourself! !

!SqsComplexAssembly methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 13:21'!
addSubAssembly: anAssembly
	anAssembly superAssembly: self.
	subAssemblies add: anAssembly.! !

!SqsComplexAssembly methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 13:22'!
initialize
	super initialize.
	subAssemblies := Set new.	
! !

!SqsComplexAssembly methodsFor: 'accessing' stamp: 'tkow 2/25/2009 20:43'!
subAssemblies
	^ subAssemblies! !

!SqsComplexAssembly methodsFor: 'accessing' stamp: 'tkow 2/25/2009 20:43'!
subAssemblies: anObject
	^ subAssemblies := anObject! !

SqsDesignObject subclass: #SqsAtomicPart
	instanceVariableNames: 'x y docId connections compositePart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsAtomicPart class methodsFor: 'as yet unclassified' stamp: 'test 2/3/2009 14:25'!
buildDate: aDate
	| inst |
	inst := super buildDate: aDate.
	inst x: (Interval from: 0 to: 9) atRandom. 
	inst y: (Interval from: 0 to: 9) atRandom.
	inst docId: (Interval from: 0 to: 9) atRandom.
	^ inst! !

!SqsAtomicPart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrBuildDate
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'build_date';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_atomic_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'buildDate';
		 yourself! !

!SqsAtomicPart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrCompositePart
	^ SqsColumn new associatedClass: #SqsCompositePart;
		 manuallyMaintained: false;
		 columnName: 'composite_part_id';
		 sqlType: #integer;
		 objectClass: #SqsCompositePart;
		 tableName: 'sqs_atomic_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'compositePart';
		 yourself! !

!SqsAtomicPart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrConnections
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #Set;
		 tableName: 'sqs_atomic_parts_connections';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sqs_atomic_part_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_atomic_parts';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'sqs_atomic_part_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'connections_id';
			 sqlType: #integer;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: false;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #SqsCon;
		 linkedVariable: 'connections';
		 orderField: 'sqs_order_number';
		 yourself! !

!SqsAtomicPart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDocId
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'doc_id';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_atomic_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'docId';
		 yourself! !

!SqsAtomicPart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrType
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'type';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_atomic_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'type';
		 yourself! !

!SqsAtomicPart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrX
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'x';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_atomic_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'x';
		 yourself! !

!SqsAtomicPart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrY
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'y';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_atomic_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'y';
		 yourself! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'tkow 2/28/2009 13:22'!
addConnection: aPart
	| connection |
	connection := SqsCon from: self to: aPart.
	connections add: connection.
! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
compositePart
	^ compositePart! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
compositePart: anObject
	compositePart := anObject! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
connections
	^ connections! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
connections: anObject
	connections := anObject! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
docId
	^ docId! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
docId: anObject
	docId := anObject! !

!SqsAtomicPart methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 13:22'!
initialize
	super initialize.
	connections := Set new.	
! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
x
	^ x! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
x: anObject
	x := anObject! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
y
	^ y! !

!SqsAtomicPart methodsFor: 'accessing' stamp: 'test 2/2/2009 16:50'!
y: anObject
	y := anObject! !

SqsDesignObject subclass: #SqsCompositePart
	instanceVariableNames: 'document atomicParts rootPart baseAssemblies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsCompositePart class methodsFor: 'as yet unclassified' stamp: 'test 2/2/2009 17:04'!
documentLength: anInteger
	^ self new
		changeDocument: (SqsDocument documentLength: anInteger);
		yourself! !

!SqsCompositePart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAtomicParts
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #Set;
		 tableName: 'sqs_composite_parts_atomic_parts';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sqs_composite_part_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_composite_parts';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'sqs_composite_part_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'atomic_parts_id';
			 sqlType: #integer;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: false;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #SqsAtomicPart;
		 linkedVariable: 'atomicParts';
		 orderField: 'sqs_order_number';
		 yourself! !

!SqsCompositePart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrBaseAssemblies
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #Set;
		 tableName: 'sqs_composite_parts_base_assemblies';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sqs_composite_part_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_composite_parts';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'sqs_composite_part_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'base_assemblies_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_assemblys';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'base_assemblies_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: false;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #SqsAssembly;
		 linkedVariable: 'baseAssemblies';
		 orderField: 'sqs_order_number';
		 yourself! !

!SqsCompositePart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrBuildDate
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'build_date';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_composite_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'buildDate';
		 yourself! !

!SqsCompositePart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDocument
	^ SqsColumn new associatedClass: #SqsDocument;
		 manuallyMaintained: false;
		 columnName: 'document_id';
		 sqlType: #integer;
		 objectClass: #SqsDocument;
		 tableName: 'sqs_composite_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'document';
		 yourself! !

!SqsCompositePart class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRootPart
	^ SqsColumn new associatedClass: #SqsAtomicPart;
		 manuallyMaintained: false;
		 columnName: 'root_part_id';
		 sqlType: #integer;
		 objectClass: #SqsAtomicPart;
		 tableName: 'sqs_composite_parts';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'rootPart';
		 yourself! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'tkow 2/28/2009 13:23'!
addAtomicPart: aPart
	aPart compositePart: self.
	atomicParts add: aPart.! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'tkow 2/28/2009 13:23'!
addBaseAssembly: anAssembly
	baseAssemblies add: anAssembly.
	! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
atomicParts
	^ atomicParts! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
atomicParts: anObject
	atomicParts := anObject! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
baseAssemblies
	^ baseAssemblies! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
baseAssemblies: anObject
	baseAssemblies := anObject! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:07'!
changeDocument: aDocument
	self document: aDocument! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
document
	^ document! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
document: anObject
	document := anObject! !

!SqsCompositePart methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 13:23'!
initialize
	super initialize.
	atomicParts := Set new.
	baseAssemblies := Set new.	
! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
rootPart
	^ rootPart! !

!SqsCompositePart methodsFor: 'accessing' stamp: 'test 2/2/2009 17:05'!
rootPart: anObject
	rootPart := anObject! !

!SqsDesignObject class methodsFor: 'as yet unclassified' stamp: 'tkow 2/15/2009 16:47'!
buildDate: anInteger
	^self new
		buildDate: anInteger;
		type: ('Type', (9 atRandom) asString);
		yourself
		! !

!SqsDesignObject class methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 00:10'!
sqsAbstractBaseClass
	^ true! !

!SqsDesignObject methodsFor: 'accessing' stamp: 'test 2/2/2009 16:23'!
buildDate
	^ buildDate! !

!SqsDesignObject methodsFor: 'accessing' stamp: 'test 2/2/2009 16:23'!
buildDate: anObject
	buildDate := anObject! !

!SqsDesignObject methodsFor: 'accessing' stamp: 'test 2/2/2009 16:23'!
type
	^ type! !

!SqsDesignObject methodsFor: 'accessing' stamp: 'test 2/2/2009 16:23'!
type: anObject
	type := anObject! !

SqsDesignObject subclass: #SqsModule
	instanceVariableNames: 'manual assemblies designRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsModule class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAssemblies
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #Set;
		 tableName: 'sqs_modules_assemblies';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sqs_module_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_modules';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'sqs_module_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'assemblies_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_assemblys';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'assemblies_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: false;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #SqsAssembly;
		 linkedVariable: 'assemblies';
		 orderField: 'sqs_order_number';
		 yourself! !

!SqsModule class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDesignRoot
	^ SqsColumn new associatedClass: #SqsAssembly;
		 manuallyMaintained: false;
		 columnName: 'design_root_id';
		 sqlType: #integer;
		 objectClass: #SqsAssembly;
		 tableName: 'sqs_modules';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'designRoot';
		 yourself! !

!SqsModule class methodsFor: 'persistence-description' stamp: ''!
sqsDescrManual
	^ SqsColumn new associatedClass: #SqsManual;
		 manuallyMaintained: false;
		 columnName: 'manual_id';
		 sqlType: #integer;
		 objectClass: #SqsManual;
		 tableName: 'sqs_modules';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'manual';
		 yourself! !

!SqsModule methodsFor: 'accessing' stamp: 'tkow 2/28/2009 13:24'!
addAssembly: anAssembly
	anAssembly module: self.
	assemblies add: anAssembly.! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
assemblies
	^ assemblies! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
assemblies: anObject
	assemblies := anObject! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:48'!
changeDesignRoot: aDesignRoot
	aDesignRoot module: self.
	self designRoot: aDesignRoot.! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/3/2009 16:08'!
changeManual: aManual
	self manual: aManual! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
designRoot
	^ designRoot! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
designRoot: anObject
	designRoot := anObject! !

!SqsModule methodsFor: 'as yet unclassified' stamp: 'tkow 2/28/2009 13:24'!
initialize
	super initialize.
	assemblies := Set new.	
! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
manual
	^ manual! !

!SqsModule methodsFor: 'accessing' stamp: 'test 2/2/2009 16:46'!
manual: anObject
	manual := anObject! !

Object subclass: #SqsDocument
	instanceVariableNames: 'title text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsDocument class methodsFor: 'as yet unclassified' stamp: 'test 2/3/2009 14:28'!
documentLength: anInteger
	| tStream |
	tStream := TextStream on: (String new: anInteger).
	anInteger timesRepeat: [tStream nextPutAll: 'd'].
	^ self new
		title: 'Title';
		text: tStream contents;
		yourself! !

!SqsDocument class methodsFor: 'persistence-description' stamp: ''!
sqsDescrText
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'text';
		 sqlType: #text;
		 objectClass: #ByteString;
		 tableName: 'sqs_documents';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'text';
		 yourself! !

!SqsDocument class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTitle
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'title';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_documents';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'title';
		 yourself! !

!SqsDocument methodsFor: 'accessing' stamp: 'test 2/2/2009 16:32'!
text
	^ text! !

!SqsDocument methodsFor: 'accessing' stamp: 'test 2/2/2009 16:32'!
text: anObject
	text := anObject! !

!SqsDocument methodsFor: 'accessing' stamp: 'test 2/2/2009 16:32'!
title
	^ title! !

!SqsDocument methodsFor: 'accessing' stamp: 'test 2/2/2009 16:32'!
title: anObject
	title := anObject! !

Object subclass: #SqsLoadStrategy
	instanceVariableNames: 'eagerLoaded loadDepth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

!SqsLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
depth: anInteger
	^self new
		loadDepth: anInteger! !

!SqsLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
eager
	^self new
		loadDepth: 1! !

!SqsLoadStrategy class methodsFor: 'as yet unclassified' stamp: 'tkow 11/5/2008 17:02'!
eagerVariables: aDictionary
	^self new
		eagerLoaded: aDictionary! !

!SqsLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
eagerLoaded
	^ eagerLoaded! !

!SqsLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
eagerLoaded: anObject
	eagerLoaded := anObject! !

!SqsLoadStrategy methodsFor: 'initialization' stamp: 'tkow 11/5/2008 17:01'!
initialize
	eagerLoaded := Dictionary new.
! !

!SqsLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
loadDepth
	^ loadDepth! !

!SqsLoadStrategy methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:01'!
loadDepth: anObject
	loadDepth := anObject! !

Object subclass: #SqsManual
	instanceVariableNames: 'title text textLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-OO7'!

!SqsManual class methodsFor: 'as yet unclassified' stamp: 'test 2/3/2009 14:28'!
documentLength: anInteger
	| tStream |
	tStream := TextStream on: (String new: anInteger).
	anInteger timesRepeat: [tStream nextPutAll: 'm'].
	^ self new
		title: 'Title';
		text: tStream contents;
		textLength: anInteger;
		yourself! !

!SqsManual class methodsFor: 'persistence-description' stamp: ''!
sqsDescrText
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'text';
		 sqlType: #text;
		 objectClass: #ByteString;
		 tableName: 'sqs_manuals';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'text';
		 yourself! !

!SqsManual class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTextLength
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'text_length';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_manuals';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'textLength';
		 yourself! !

!SqsManual class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTitle
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'title';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_manuals';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'title';
		 yourself! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
text
	^ text! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
text: anObject
	text := anObject! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
textLength
	^ textLength! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
textLength: anObject
	textLength := anObject! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
title
	^ title! !

!SqsManual methodsFor: 'accessing' stamp: 'test 2/2/2009 16:44'!
title: anObject
	title := anObject! !

Object subclass: #SqsMigration
	uses: TSqsLogger
	instanceVariableNames: 'version session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsMigration commentStamp: 'tkow 1/19/2009 18:04' prior: 0!
A SqsMigration is the base class for custom migrations. It allows for easy data synchronization between multiple developers. 
Simply create a new method...

Instance Variables
!

SqsMigration class
	uses: TSqsLogger classTrait
	instanceVariableNames: ''!

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/7/2009 14:00'!
checkConfiguration
	| conf |
	conf := SqsConnectionManager getInstance configurationForClass: self.
	SqsConnectionManager getInstance setConfiguration: conf for: self superclass name. 
	! !

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 21:47'!
down
	^ 'downwards-migrations'! !

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 22:43'!
findMissingMigrations: version
	| methodPragmaDict pragma orderedMethods |
	methodPragmaDict := Dictionary new.
	self selectorsAndMethodsDo: [ :selector :method | 
		(selector last: 2) = 'Up' ifTrue: [
			method pragmas ifNotEmpty: [
				pragma := method pragmas detect: [:p | 
					p keyword = #version:
				] ifNone: [nil].
				pragma ifNotNil: [
					(version isNil or: [pragma arguments first > version]) ifTrue: [
						methodPragmaDict at: pragma arguments first put: selector		
					]
				]
			]
		]
	].
	orderedMethods := OrderedCollection new.
	methodPragmaDict keys asSortedArray do: [ :schemaVersion |
		orderedMethods add: (OrderedCollection with: (methodPragmaDict at: schemaVersion) with: schemaVersion)
	].
	^ orderedMethods! !

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 21:52'!
generate: migrationSelector
	| codeUp codeDown pragmaCode |
	codeUp := migrationSelector asLegalSelector, 'Up'.
	(self allSelectors includes: codeUp asSymbol) ifTrue: [
		self error: 'Migration name already defined'
	].
	codeDown := migrationSelector asLegalSelector, 'Down'.
	pragmaCode := String tab, '<version: ''', DateAndTime now asUTC asString, '''>'.
	self compile: (codeUp, String cr,pragmaCode) classified: self up.
	self compile: (codeDown, String cr, pragmaCode) classified: self down.! !

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/7/2009 13:56'!
run
	| migrations migration methodsToRun |
	self checkConfiguration.
	migrations := (SqsSearch for: self) findAll.
	(migrations size > 1) ifTrue: [
		self error: 'ambiguous migrations found - could not determine current version'	
	].

	migration := migrations ifEmpty: [
		self new.
	] ifNotEmpty: [
		migrations first
	].

	methodsToRun := self findMissingMigrations: migration version.
	methodsToRun do: [:methodInfo |
		migration runMigration: methodInfo first version: methodInfo last
	]! !

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 22:36'!
sqSaveUnpersistedInstVars
	^ #('session' )! !

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/8/2009 23:29'!
sqsAbstractBaseClass
	^ true! !

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 21:57'!
sqsTableName
	^ 'schema_migrations'! !

!SqsMigration class methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 21:47'!
up
	^ 'upwards-migrations'! !

!SqsMigration methodsFor: 'as yet unclassified' stamp: 'tkow 3/10/2009 16:28'!
log: aString
	self log: aString loggerName: self class basicCategory! !

!SqsMigration methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 22:39'!
runMigration: aSelector version: aVersion
	self session inTransactionDo: [
		self log: '=== running migration ', aSelector, ' (', aVersion asString, ') ==='.
		self perform: aSelector.
		version := aVersion.
		self save.
		self log: '=== successfully performed migration ', aSelector, ' (', aVersion asString, ') ==='.
	] ifError: [ :err |
		self log: '=== error during migration ', aSelector, ' (', aVersion asString, ') ==='.
		self error: err
	]! !

!SqsMigration methodsFor: 'as yet unclassified' stamp: 'tkow 3/5/2009 22:52'!
session
	| configuration |
	session ifNil: [
		configuration := SqsConnectionManager getInstance configurationForClass: self class.
		configuration tableConfiguration inheritanceMode: SqsTableStructureHandler singleTableInheritance.
		session := SqsConnectionManager getInstance sessionForConfiguration: configuration.
	].
	^ session! !

!SqsMigration methodsFor: 'accessing' stamp: 'tkow 3/5/2009 22:34'!
version
	^ version! !

!SqsMigration methodsFor: 'accessing' stamp: 'tkow 3/5/2009 22:34'!
version: anObject
	version := anObject! !

SqsMigration subclass: #SqsTestMigration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestMigration methodsFor: 'downwards-migrations' stamp: 'tkow 3/5/2009 21:52'!
halloWelt2Down
	<version: '2009-03-05T21:52:45.797+00:00'>! !

!SqsTestMigration methodsFor: 'upwards-migrations' stamp: 'tkow 3/5/2009 21:52'!
halloWelt2Up
	<version: '2009-03-05T21:52:45.797+00:00'>! !

!SqsTestMigration methodsFor: 'downwards-migrations' stamp: 'tkow 3/5/2009 21:51'!
halloWeltDown
	<version: '2009-03-05T21:51:20.321+00:00'>! !

!SqsTestMigration methodsFor: 'upwards-migrations' stamp: 'tkow 3/5/2009 21:51'!
halloWeltUp
	<version: '2009-03-05T21:51:20.321+00:00'>! !

Object subclass: #SqsMigrationPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsMigrationPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrVersion
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'version';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'schema_migrations';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'version';
		 yourself! !

SqsMigrationPersistenceDescriptor subclass: #SqsTestMigrationPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

Object subclass: #SqsObjectCache
	instanceVariableNames: 'objectCache objectIdCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsObjectCache methodsFor: 'object-caching' stamp: 'tkow 12/4/2008 17:06'!
cacheObject: anObject withOid: oid
	(self objectCacheFor: anObject class) at: oid put: anObject.
	(self objectIdCacheFor: anObject class) at: anObject put: oid.
	! !

!SqsObjectCache methodsFor: 'object-caching' stamp: 'tkow 3/9/2009 13:13'!
cachedObjectOfClass: aClass withOid: oid 
	| object |
	object := (self objectCacheFor: aClass)
		at: oid
		ifAbsent: [nil].
	^ object! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:07'!
clear
	objectCache := Dictionary new.
	objectIdCache := Dictionary new.! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 3/9/2009 02:54'!
compact
	objectIdCache values do: [:wikd | wikd finalizeValues].
	objectCache := Dictionary new.! !

!SqsObjectCache methodsFor: 'initialization' stamp: 'tkow 12/4/2008 17:05'!
initialize
	super initialize.
	objectCache := Dictionary new.
	objectIdCache := Dictionary new.! !

!SqsObjectCache methodsFor: 'accessing' stamp: 'tkow 3/9/2009 02:32'!
objectCache
	^ objectCache! !

!SqsObjectCache methodsFor: 'accessing' stamp: 'tkow 3/9/2009 02:32'!
objectCache: anObject
	objectCache := anObject! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 3/9/2009 13:02'!
objectCacheFor: aClass
	^ objectCache 
		at: aClass name 
		ifAbsentPut: [SqsStaggeredIdCache new]! !

!SqsObjectCache methodsFor: 'accessing' stamp: 'tkow 3/9/2009 02:32'!
objectIdCache
	^ objectIdCache! !

!SqsObjectCache methodsFor: 'accessing' stamp: 'tkow 3/9/2009 02:32'!
objectIdCache: anObject
	objectIdCache := anObject! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 3/9/2009 11:44'!
objectIdCacheFor: aClass
	^ objectIdCache
		at: aClass name 
		ifAbsentPut: [SqsWeakStaggeredCache new]! !

!SqsObjectCache methodsFor: 'access to cache' stamp: 'tkow 3/9/2009 13:11'!
oidFor: anObject
	| classCache |
	classCache := objectIdCache at: anObject class name ifAbsent: [
		^ nil
	].
	^ classCache at: anObject ifAbsent: [nil]! !

Object subclass: #SqsPersistenceDescription
	uses: TSqsSelfPrinting
	instanceVariableNames: 'associatedClass manuallyMaintained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

SqsPersistenceDescription class
	uses: TSqsSelfPrinting classTrait
	instanceVariableNames: ''!

SqsPersistenceDescription subclass: #SqsCollectionDescription
	instanceVariableNames: 'collectionClass tableName ownerColumn referenceColumn maintainOrder simpleValues indexType referencedClass linkedVariable orderField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass
	^ collectionClass! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass: anObject
	collectionClass := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 7/23/2008 15:13'!
describesCollection
	^true! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/18/2008 16:10'!
indexType
	^ indexType! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/18/2008 16:10'!
indexType: anObject
	indexType := anObject! !

!SqsCollectionDescription methodsFor: 'initialization' stamp: 'tkow 11/10/2008 10:21'!
initialize
	super initialize.
	self simpleValues: false.! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/21/2008 21:54'!
linkedVariable
	^ linkedVariable! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 11/21/2008 21:54'!
linkedVariable: anObject
	linkedVariable := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 2/16/2009 16:11'!
maintainOrder
	^ maintainOrder ifNil: [false]! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder: anObject 
	maintainOrder := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 2/16/2009 16:22'!
orderField
	^ orderField! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 2/16/2009 16:22'!
orderField: aName
	orderField := aName! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn
	^ ownerColumn! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn: anObject
	ownerColumn := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn
	^ referenceColumn! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn: anObject
	referenceColumn := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/24/2008 15:48'!
referencedClass
	^ referencedClass! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/24/2008 15:48'!
referencedClass: anObject
	referencedClass := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/15/2008 14:05'!
simpleValues
	^ simpleValues! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 9/15/2008 14:05'!
simpleValues: anObject
	simpleValues := anObject! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 2/5/2009 14:20'!
tableName
	^ tableName! !

!SqsCollectionDescription methodsFor: 'accessing' stamp: 'tkow 2/5/2009 14:21'!
tableName: anObject 
	tableName := anObject! !

SqsPersistenceDescription subclass: #SqsColumn
	instanceVariableNames: 'columnName sqlType objectClass tableName foreignKey canBeNull isPrimaryKey autoIncrement linkedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 12/12/2008 12:56'!
= anotherColumn
	^(self class = anotherColumn class) ifTrue: [
		(self columnName = anotherColumn columnName) and: [self tableName = anotherColumn tableName]
	] ifFalse: [
		false
	]
	! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 10/7/2008 14:41'!
autoIncrement
	^ autoIncrement! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 10/7/2008 14:41'!
autoIncrement: anObject
	autoIncrement := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull
	^ canBeNull! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull: anObject
	canBeNull := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 2/22/2009 13:38'!
columnName
	^ columnName ifNil:[
		linkedVariable decamelized
	]! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName: anObject
	columnName := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:58'!
foreignKey
	^ foreignKey! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:16'!
foreignKey: anObject
	foreignKey := anObject.
	"being a foreign key, the column can not be null"
	self canBeNull: false.! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:07'!
hash
	^(self columnName hash + self sqlType hash + self tableName hash)! !

!SqsColumn methodsFor: 'initialization' stamp: 'tkow 11/3/2008 18:43'!
initialize
	super initialize.
	self canBeNull: true.
	self isPrimaryKey: false.
	self autoIncrement: false.! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey
	^ isPrimaryKey! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey: anObject
	isPrimaryKey := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 10/9/2008 10:33'!
linkedVariable
	^ linkedVariable! !

!SqsColumn methodsFor: 'accessing' stamp: 'tkow 10/9/2008 10:33'!
linkedVariable: anObject
	linkedVariable := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass
	^ objectClass! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass: anObject
	objectClass := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType
	^ sqlType! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType: anObject
	sqlType := anObject! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName
	^ tableName! !

!SqsColumn methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName: anObject
	tableName := anObject! !

SqsPersistenceDescription subclass: #SqsForeignKeyDescription
	instanceVariableNames: 'referencedColumns referencedTable updateActions deleteActions referencingColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions
	^ deleteActions! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions: anObject
	deleteActions := anObject! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tkow 2/19/2009 20:27'!
foreignKeyName
	| nameComps |
	nameComps := OrderedCollection new. 
	referencingColumns ifNotEmpty: [nameComps add: (referencingColumns join: '_')].
	nameComps add: 'fk'.
	^ nameComps join: '_'! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tkow 2/19/2009 20:27'!
foreignKeyName: tableName
	| nameComps |
	nameComps := OrderedCollection new.
	referencingColumns ifNotEmpty: [nameComps add: (referencingColumns join: '_')].
	nameComps add: tableName.
	nameComps add: 'fk'.
	^ nameComps join: '_'! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tkow 2/19/2009 15:08'!
initialize
	super initialize.
	updateActions := #().
	deleteActions := #().
	referencedColumns := Set new.
	referencingColumns := Set new.
	! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns
	^ referencedColumns! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns: anObject
	referencedColumns := anObject! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable
	^ referencedTable! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable: anObject
	referencedTable := anObject! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tkow 2/19/2009 15:09'!
referencingColumns
	^ referencingColumns! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tkow 2/19/2009 15:09'!
referencingColumns: anObject
	referencingColumns := anObject! !

!SqsForeignKeyDescription methodsFor: 'printing' stamp: 'tk 7/22/2008 13:54'!
storeOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;;
				nextPutAll: (String cr, String tab, String tab)
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions
	^ updateActions! !

!SqsForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions: anObject
	updateActions := anObject! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass
	^ associatedClass! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass: anObject
	associatedClass := anObject! !

!SqsPersistenceDescription methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 7/23/2008 15:12'!
describesCollection
	^false! !

!SqsPersistenceDescription methodsFor: 'initialization' stamp: 'tk 8/15/2008 16:37'!
initialize
	super initialize.
	self manuallyMaintained: false.! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained
	^ manuallyMaintained! !

!SqsPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained: anObject
	manuallyMaintained := anObject! !

SqsPersistenceDescription subclass: #SqsTable
	instanceVariableNames: 'tableName parent children columns structure oidColumn typeColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsTable class methodsFor: 'as yet unclassified' stamp: 'tkow 2/5/2009 19:26'!
objectIdLink
	^ 'SQSOID'! !

!SqsTable class methodsFor: 'as yet unclassified' stamp: 'tkow 2/5/2009 19:26'!
typeLink
	^ 'SQSTYPE'! !

!SqsTable methodsFor: 'comparing' stamp: 'tkow 2/5/2009 14:03'!
= anotherTable
	| equal |
	equal := (self tableName = anotherTable tableName) and: [self associatedClass = anotherTable associatedClass].
	^ equal and: [self columns size = anotherTable columns size].
	
	! !

!SqsTable methodsFor: 'special columns' stamp: 'tkow 2/19/2009 20:25'!
addLightOidColumnNamed: aString linkedTo: refTableName 
	| aColumn |
	aColumn := SqsColumn new
		columnName: aString;
		sqlType: #unsignedInteger;
		tableName: self tableName;
		canBeNull: false;
		isPrimaryKey: true;
		linkedVariable: self class objectIdLink;
		foreignKey: (SqsForeignKeyDescription new
				referencedColumns: (Set with: aString);
				referencingColumns: (Set with: aString);
				deleteActions: #(#CASCADE );
				referencedTable: refTableName).
	self columns add: aColumn.
	self oidColumn: aColumn! !

!SqsTable methodsFor: 'special columns' stamp: 'tkow 2/19/2009 20:26'!
addOidColumnNamed: aString 
	| newColumn |
	newColumn := SqsColumn new
		columnName: aString;
		sqlType: #unsignedInteger;
		canBeNull: false;
		tableName: self tableName;
		isPrimaryKey: true;
		autoIncrement: true;
		tableName: self tableName;
		linkedVariable: self class objectIdLink.
	self columns add: newColumn.
	self oidColumn: newColumn! !

!SqsTable methodsFor: 'special columns' stamp: 'tkow 12/12/2008 17:40'!
addTypeColumnNamed: aString 
	| aColumn |
	aColumn := SqsColumn new
		columnName: aString;
		sqlType: #string;
		canBeNull: false;
		isPrimaryKey: false;
		objectClass: #Symbol;
		tableName: self tableName;
		linkedVariable: self class typeLink.
	self columns add: aColumn.
	self typeColumn: aColumn! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 13:45'!
allChildTables
	| allChildren |
	allChildren := OrderedCollection withAll: self children.
	self children do: [:childTable |
		allChildren addAll: childTable allChildTables
	].
	^allChildren! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 12/4/2008 17:45'!
allColumns
	| allColumns |
	allColumns := self columns.
	self children do: [:childTable |
		allColumns addAll: childTable allColumns
	].
	^ allColumns! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 2/27/2009 16:20'!
allParentTables
	| allParents |
	allParents := OrderedCollection new.
	self parent ifNotNil: [
		allParents add: parent.
		allParents addAll: self parent allParentTables	
	].
	^ allParents! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 2/27/2009 16:29'!
allValueTables
	| tables |
	tables := OrderedCollection with: self.
	tables addAll: self allChildTables.
	tables addAll: self allParentTables.
	^ tables! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/9/2008 16:22'!
baseTable
	^self parent ifNil: [
		self
	] ifNotNil: [
		self parent baseTable
	]! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
children
	^ children! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
children: anObject
	children := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
columns
	^ columns! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
columns: anObject
	columns := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 18:39'!
initialize
	super initialize.
	self children: Set new.
	self columns: OrderedCollection new.! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
oidColumn
	^ oidColumn! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
oidColumn: anObject
	oidColumn := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
parent
	^ parent! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 14:48'!
parent: anObject
	parent := anObject.
	parent children add: self.
	! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
structure
	^ structure! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
structure: anObject
	structure := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
tableName
	^ tableName! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 10/6/2008 17:38'!
tableName: anObject
	tableName := anObject! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
typeColumn
	^ typeColumn! !

!SqsTable methodsFor: 'accessing' stamp: 'tkow 11/10/2008 14:49'!
typeColumn: anObject
	typeColumn := anObject! !

Object subclass: #SqsQuery
	instanceVariableNames: 'queryClass whereBuffer valueTables queryTables queryLevel previousQueryObject currentQueryObject loadStrategy orderBy ignoreTypeField distinct'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQuery class methodsFor: 'as yet unclassified' stamp: 'test 1/23/2009 17:55'!
classForType: aType 
	| |
	^ self classesForTypes
		keysAndValuesDetect: [ :classKey :subClass | aType includesBehavior: classKey]
		ifNone: [ SqsQueryObject ].
! !

!SqsQuery class methodsFor: 'as yet unclassified' stamp: 'test 1/26/2009 15:30'!
classesForTypes
	^ Dictionary new
		at: Boolean
			put: SqsQueryBoolean;
		at: Date
			put: SqsQueryDate;
		at: DateAndTime
			put: SqsQueryDateTime;
		at: Number
			put: SqsQueryNumber;
		at: String
			put: SqsQueryString;
		at: Collection
			put: SqsQueryCollection;
		yourself! !

!SqsQuery class methodsFor: 'initialize-release' stamp: 'tkow 10/14/2008 11:05'!
on: aClass
	^(self new
		on: aClass;
		yourself)! !

!SqsQuery class methodsFor: 'initialize-release' stamp: 'tkow 11/5/2008 17:04'!
on: aClass withStrategy: anSqsLoadStrategy
	^(self new
		on: aClass;
		loadStrategy: anSqsLoadStrategy;
		yourself)! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'tkow 3/9/2009 00:05'!
adapterClass
	^ (SqsClassInfo cachedFor: self queryClass) configuration adapterClass! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'test 1/29/2009 17:40'!
aliasSuffixForTableOfClass: aClass 
	| timesTaken |
	timesTaken := self queryLevel 
		at: aClass name
		ifAbsent: [ 0 ].
	^ timesTaken = 0 
		ifTrue: [ '' ]
		ifFalse: [ '_' , timesTaken asString ]! !

!SqsQuery methodsFor: 'enumerating' stamp: 'tkow 2/23/2009 17:32'!
analyze: aBlock
	| qo result |
	qo := (self class classForType: Object) new 
		query: self;
		depictedClass: self queryClass.
	result := aBlock value: qo.
	self whereBuffer: result whereBuffer.
	self queryClass sqsIsComplexClass ifTrue: [
		self findValueTables.	
	].
	
! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 11:00'!
currentQueryObject
	^ currentQueryObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 11:00'!
currentQueryObject: anObject
	currentQueryObject := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'test 1/26/2009 17:08'!
distinct
	^ distinct! !

!SqsQuery methodsFor: 'accessing' stamp: 'test 1/26/2009 17:08'!
distinct: anObject
	distinct := anObject! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'tkow 3/9/2009 00:05'!
findValueTables
	| queryBaseTable childQueryTable classInfo idField childLink classTable curTable |
	classInfo := SqsClassInfo cachedFor: self queryClass.
	classTable := classInfo cachedClassTable.
	queryBaseTable := SqsQueryTable 
		table: classTable
		alias: ''
		field: nil
		class: self queryClass.

	"we need the base table in the values (i.e. the SELECT ...) as well as in the query part (FROM ...)"
	"for eager loading, those tables would be added to the values as seperate tables and to the queries
	by linking them to the queryBaseTable via an SqSTableLink"
	self valueTables add: queryBaseTable.
	idField := classInfo configuration tableConfiguration idField.

	"the links to the child tables are merly a shortcut that simplifies the adapter handling of this stuff
	This way we can simply take all links a table has, and throw it into one giant join statement"
	curTable := classTable parent.
	[curTable isNil] whileFalse: [
		childQueryTable := SqsQueryTable 
			table: curTable
			alias: ''
			field: nil.
		childLink := SqsTableLink 
			table: childQueryTable
			fromField: idField
			toField: idField
			direction: 'LEFT OUTER'.
		queryBaseTable tableLinks add: childLink.
		curTable := curTable parent. 	
	].
	
	
	classTable allChildTables do: [:childTable | 
		childQueryTable := SqsQueryTable 
			table: childTable
			alias: ''
			field: nil.
		childLink := SqsTableLink 
			table: childQueryTable
			fromField: idField
			toField: idField
			direction: 'LEFT OUTER'.
		queryBaseTable tableLinks add: childLink
	].
	self queryTables add: queryBaseTable! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 12/5/2008 13:35'!
ignoreTypeField
	^ ignoreTypeField! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 12/5/2008 13:35'!
ignoreTypeField: anObject
	ignoreTypeField := anObject! !

!SqsQuery methodsFor: 'initialization' stamp: 'test 1/26/2009 17:08'!
initialize
	super initialize.
	self whereBuffer: ''.
	self valueTables: OrderedCollection new.
	self queryTables: OrderedCollection new.
	self queryLevel: Dictionary new.
	self ignoreTypeField: false.
	self distinct: false.! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:04'!
loadStrategy
	^ loadStrategy! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/5/2008 17:04'!
loadStrategy: anObject
	loadStrategy := anObject! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'test 1/30/2009 15:27'!
newAliasSuffixForTableOfClass: aClass 
	| timesTaken aliasedName |
	timesTaken := self queryLevel 
		at: aClass name
		ifAbsentPut: [ 0 ].

	timesTaken := timesTaken + 1.
	self queryLevel 
		at: aClass name
		put: timesTaken.
	aliasedName := self aliasSuffixForTableOfClass: aClass.
	^ aliasedName! !

!SqsQuery methodsFor: 'as yet unclassified' stamp: 'tkow 11/2/2008 21:59'!
newForType: aType
	self previousQueryObject: self currentQueryObject.
	^(self class classForType: aType) new 
		query: self;
		depictedClass: aType.! !

!SqsQuery methodsFor: 'initialize-release' stamp: 'tkow 11/5/2008 17:46'!
on: aClass 
	| |
	self queryClass: aClass.
! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/24/2008 11:15'!
orderBy
	^ orderBy! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/24/2008 11:15'!
orderBy: anObject
	orderBy := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:09'!
previousQueryObject
	^ previousQueryObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:09'!
previousQueryObject: anObject
	previousQueryObject := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:36'!
queryClass
	^queryClass! !

!SqsQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:34'!
queryClass: aClass
	queryClass _ aClass.! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/3/2008 10:09'!
queryLevel
	^ queryLevel! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/3/2008 10:09'!
queryLevel: anObject
	queryLevel := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:06'!
queryTables
	^ queryTables! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:06'!
queryTables: anObject
	queryTables := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/20/2008 16:01'!
valueTables
	^ valueTables! !

!SqsQuery methodsFor: 'accessing' stamp: 'tkow 10/20/2008 16:01'!
valueTables: anObject
	valueTables := anObject! !

!SqsQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:41'!
whereBuffer
	^whereBuffer.! !

!SqsQuery methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:42'!
whereBuffer: aString
	whereBuffer _ aString.! !

Object subclass: #SqsQueryTable
	instanceVariableNames: 'aliasSuffix field originalTable queryClass tableLinks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/3/2008 16:12'!
table: anSqsTable alias: anAliasName field: aFieldName 
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		yourself! !

!SqsQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/5/2008 16:03'!
table: anSqsTable alias: anAliasName field: aFieldName class: aClass
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		queryClass: aClass;
		yourself! !

!SqsQueryTable class methodsFor: 'instance creation' stamp: 'tkow 11/24/2008 14:44'!
table: anSqsTable alias: anAliasName field: aFieldName class: aClass ignoreValues: aBool
	^ self new
		originalTable: anSqsTable;
		aliasSuffix: anAliasName;
		field: aFieldName;
		queryClass: aClass;
		ignoreValues: aBool;
		yourself! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:12'!
aliasSuffix
	^ aliasSuffix! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:12'!
aliasSuffix: anObject 
	aliasSuffix := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 16:25'!
aliasedName
	^self originalTable tableName, self aliasSuffix! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 2/27/2009 16:32'!
allAliasedNames
	| aliasedNames |
	aliasedNames := OrderedCollection new.
	aliasedNames add: self aliasedName.
	self originalTable allValueTables do: [:table |
		aliasedNames add: (table tableName, self aliasSuffix)
	].
	^aliasedNames! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 2/27/2009 17:37'!
field
	^field ifNil: [queryClass name asUppercase, 'OBJECT' ].! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 10/13/2008 16:44'!
field: anObject
	field := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:35'!
ignoreValues
	^ ignoreValues! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:35'!
ignoreValues: anObject
	ignoreValues := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 16:11'!
initialize
	super initialize.
	self tableLinks: OrderedCollection new.! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:35'!
originalTable
	^ originalTable! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/3/2008 15:35'!
originalTable: anObject
	originalTable := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/5/2008 16:03'!
queryClass
	^ queryClass! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/5/2008 16:03'!
queryClass: anObject
	queryClass := anObject! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 15:53'!
tableLinks
	^ tableLinks! !

!SqsQueryTable methodsFor: 'accessing' stamp: 'tkow 11/25/2008 15:53'!
tableLinks: anObject 
	tableLinks := anObject! !

Object subclass: #SqsQueryValue
	instanceVariableNames: 'query whereBuffer depictedClass referencedColumn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

SqsQueryValue subclass: #SqsQueryBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryBoolean methodsFor: 'logical operations' stamp: 'tkow 10/30/2008 16:25'!
& anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: 'AND'! !

!SqsQueryBoolean methodsFor: 'testing' stamp: 'tkow 10/30/2008 16:25'!
isFalse
	^ self 
		booleanCompair: 0
		with: '='! !

!SqsQueryBoolean methodsFor: 'testing' stamp: 'tkow 10/30/2008 16:25'!
isTrue
	^ self 
		booleanCompair: 1
		with: '='! !

!SqsQueryBoolean methodsFor: 'logical operations' stamp: 'tkow 10/30/2008 16:25'!
| anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: 'OR'! !

SqsQueryValue subclass: #SqsQueryCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'tkow 2/27/2009 22:05'!
anySatisfy: aBlock
	| nextQuery |
	self sqsConcatQueryForSatisfy: aBlock andNegate: false.
	nextQuery := self query newForType: Boolean.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery
! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'tkow 2/19/2009 13:59'!
includes: anObject
	| valueField joinTable suffix sql nextQuery |
	"find the value field within the current join table"
	valueField := referencedColumn referenceColumn columnName.
	joinTable := referencedColumn tableName.
	suffix := self query aliasSuffixForTableOfClass: Collection.
	
	"create the sql query necessary to check if there is a value within the table that either directly
	matches anObject or matches anObject's oid (i.e. a reference to another complex object)"
	sql := '', joinTable, suffix, '.', valueField, ' = '.
	sql := sql, (referencedColumn simpleValues ifTrue: [anObject] ifFalse: [anObject oid]) asSqlValueString.

	"add the query to the where buffer and return the the query object for our result - a boolean"
	self addToWhereBuffer: ('AND (', sql,')').
	nextQuery := self query newForType: Boolean.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery
	! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'test 1/30/2009 15:59'!
noneSatisfy: aBlock
	| nextQuery |
	self sqsConcatQueryForSatisfy: aBlock andNegate: true.
	nextQuery := self query newForType: Boolean.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery

	! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'tkow 3/8/2009 23:59'!
size
	| sql tableName ownerColumn refColumn refTable nextQuery suffix refSuffix adapterClass |
	suffix := self query aliasSuffixForTableOfClass: Collection.
	tableName := self sqsReferencedColumn tableName, suffix.
	
	adapterClass := (SqsClassInfo cachedFor: self query queryClass) configuration adapterClass. 
		
	sql := 'SELECT ',adapterClass completeCount ,' FROM ', tableName, ' WHERE '.

	ownerColumn := referencedColumn ownerColumn columnName.
	refColumn := referencedColumn ownerColumn foreignKey referencedColumns anyOne.
	refTable := referencedColumn ownerColumn foreignKey referencedTable.
	refSuffix := query aliasSuffixForTableOfClass: depictedClass.
	
	sql := sql,'(', tableName, '.', ownerColumn, ' = ', refTable,refSuffix, '.', refColumn, ')'.
	
	self addToWhereBuffer: ('AND (', sql,')').
	nextQuery := self query newForType: Number.
	nextQuery whereBuffer: self whereBuffer.
	^ nextQuery! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'tkow 3/3/2009 13:22'!
sqsConcatQueryForSatisfy: aBlock andNegate: aBool
	
	| sql nextQuery negate |
	
	negate := aBool ifTrue: ['NOT '] ifFalse: [''].

	sql := self sqsCustomSqlToScopeToCollection.
	nextQuery := self sqsQueryForCollectionScoping: aBlock.
	
	referencedColumn simpleValues ifTrue: [
		self addToWhereBuffer: ('AND ',negate,'(', sql, nextQuery whereBuffer,')').
	] ifFalse: [
		self addToWhereBuffer: ('AND (', sql, ') AND ',negate,'(', nextQuery whereBuffer,')').
	].! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'tkow 3/8/2009 23:59'!
sqsCustomSqlToScopeToCollection

	| valueField joinTable suffix refClass sql refTable refSuffix |
	valueField := referencedColumn referenceColumn columnName.
	joinTable := referencedColumn tableName.
	suffix := self query aliasSuffixForTableOfClass: Collection.

	refClass := Smalltalk at: referencedColumn referencedClass.	
	referencedColumn simpleValues ifTrue: [
		sql := '', joinTable, suffix, '.', valueField.
	] ifFalse: [
		sql := '', joinTable, suffix, '.', valueField, ' = '.
		refTable := (SqsClassInfo cachedFor: refClass) tableName.
		refSuffix := query newAliasSuffixForTableOfClass: refClass.
		query queryTables add: (SqsQueryTable table: (SqsClassInfo for: refClass) cachedClassTable alias: refSuffix field: nil class: refClass ignoreValues: true ).
		sql := sql, (refTable, refSuffix, '.', (SqsClassInfo for: refClass) configuration tableConfiguration idField).
	].
	^ sql
! !

!SqsQueryCollection methodsFor: 'as yet unclassified' stamp: 'tkow 2/27/2009 21:47'!
sqsQueryForCollectionScoping: aBlock
	
	| refClass nextQuery |
	refClass := Smalltalk at: referencedColumn referencedClass.
	nextQuery := SqsQuery new
		queryLevel: query queryLevel;
		queryClass: refClass;
		previousQueryObject: nil;
		yourself.
	nextQuery analyze: aBlock.
	^ nextQuery! !

SqsQueryValue subclass: #SqsQueryDate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryDate methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:12'!
day
	^self dayOfYear.! !

!SqsQueryDate methodsFor: 'ansi protocol' stamp: 'tkow 3/6/2009 14:24'!
dayOfMonth
	^(query newForType: Integer) whereBuffer: (query adapterClass dayOfMonth),'(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'ansi protocol' stamp: 'tkow 3/6/2009 14:24'!
dayOfWeek
	^(query newForType: Integer) whereBuffer: (query adapterClass dayOfWeek),'(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'ansi protocol' stamp: 'tkow 3/6/2009 14:22'!
dayOfYear
	^(query newForType: Integer) whereBuffer: (query adapterClass dayOfYear),'(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'smalltalk-80' stamp: 'tkow 3/6/2009 14:29'!
monthIndex
	^(query newForType: Integer) whereBuffer: (query adapterClass month),'(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'ansi protocol' stamp: 'tkow 3/6/2009 14:30'!
monthName
	^(query newForType: Integer) whereBuffer: (query adapterClass monthName),'(',self encapsulatedWhere,')'.! !

!SqsQueryDate methodsFor: 'accessing' stamp: 'tkow 3/6/2009 14:30'!
year
	^(query newForType: Integer) whereBuffer: (query adapterClass year),'(',self encapsulatedWhere,')'.! !

SqsQueryDate subclass: #SqsQueryDateTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryDateTime methodsFor: 'ansi protocol' stamp: 'tkow 3/6/2009 14:31'!
hour
	^(query newForType: Integer)  whereBuffer: (query adapterClass hour),'(',self encapsulatedWhere,')'.! !

!SqsQueryDateTime methodsFor: 'ansi protocol' stamp: 'wh 8/16/2006 20:12'!
hour24
	^self hour.! !

!SqsQueryDateTime methodsFor: 'ansi protocol' stamp: 'tkow 3/6/2009 14:31'!
minute
	^(query newForType: Integer)  whereBuffer: (query adapterClass minute),'(',self encapsulatedWhere,')'.! !

!SqsQueryDateTime methodsFor: 'accessing' stamp: 'tkow 3/6/2009 14:32'!
second
	^(query newForType: Integer)  whereBuffer: (query adapterClass second),'(',self encapsulatedWhere,')'.! !

SqsQueryValue subclass: #SqsQueryNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:36'!
* aNumber
	^self mathWith: aNumber doOperator: '*'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:35'!
+ aNumber
	^self mathWith: aNumber doOperator: '+'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:35'!
- aNumber
	^self mathWith: aNumber doOperator: '-'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:36'!
/ aNumber
	^self mathWith: aNumber doOperator: '/'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'wh 8/16/2006 20:08'!
\\ anAttrib
	^self mathWith: anAttrib doOperator: '%'.! !

!SqsQueryNumber methodsFor: 'arithmetic' stamp: 'tkow 2/5/2009 10:43'!
abs
	^(query newForType: Integer) whereBuffer: 'ABS(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'tkow 2/5/2009 10:43'!
arcCos
	^(query newForType: Integer) whereBuffer: 'ACOS(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'tkow 2/5/2009 10:43'!
arcSin
	^(query newForType: Integer) whereBuffer: 'ASIN(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'tkow 2/5/2009 10:43'!
arcTan
	^(query newForType: Integer) whereBuffer: 'ATAN(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'tkow 2/5/2009 10:44'!
cos
	^(query newForType: Integer) whereBuffer: 'COS(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'as yet unclassified' stamp: 'wh 8/16/2006 20:29'!
mathWith: anAttrib doOperator: anOperator
	^self operator: anOperator returnType: Integer attribute: anAttrib! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'tkow 2/5/2009 10:44'!
sin
	^(query newForType: Integer) whereBuffer: 'SIN(',self encapsulatedWhere,')'.! !

!SqsQueryNumber methodsFor: 'mathematical functions' stamp: 'tkow 2/5/2009 10:44'!
tan
	^(query newForType: Integer ) whereBuffer: 'TAN(',self encapsulatedWhere,')'.! !

SqsQueryValue subclass: #SqsQueryObject
	instanceVariableNames: 'suffix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 3/9/2009 00:00'!
doesNotUnderstand: aMessage 
	| col nextObject |
	aMessage arguments size < 1 ifTrue: [ 
		col := (SqsClassInfo cachedFor: self depictedClass) descriptionHandler sqsDescriptionForInstVar: aMessage selector asString.
		col ifNotNil: [ 
			nextObject := col describesCollection ifTrue: [
				self sqsNextQueryCollection: col 
			] ifFalse: [
				self sqsNextQueryObject: col
			].
			nextObject sqsReferencedColumn: col.
			^ nextObject
		] 
	].
	super doesNotUnderstand: aMessage! !

!SqsQueryObject methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 00:00'!
oid
	"object id has to be overridden, because the objectID for the queryProxies surely
	won't be found anywhere in our caches'"
	| tableName aliasSuffix aliasedTableName classInfo |
	classInfo := SqsClassInfo cachedFor: self depictedClass.
	tableName := classInfo cachedClassTable baseTable tableName.
	aliasSuffix := self query aliasSuffixForTableOfClass: self depictedClass.
	aliasedTableName := tableName , aliasSuffix.
	self whereBuffer: self whereBuffer , aliasedTableName , '.' , classInfo configuration tableConfiguration idField! !

!SqsQueryObject methodsFor: 'as yet unclassified' stamp: 'tkow 1/16/2009 17:56'!
perform: aSymbol
	^(aSymbol = SqsSearch searchForIdField) ifTrue: [
		self oid	
	] ifFalse: [
		self doesNotUnderstand: (Message selector: aSymbol)
	]
	! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 10/21/2008 18:44'!
sqsFindColumnFor: instVarName inTable: table
	| column |
	column := table columns detect: [:col |
		col linkedVariable = instVarName asString
	] ifNone: [nil].
	column ifNil: [
		table children do: [:childTable |
			column ifNil: [
				column := self sqsFindColumnFor: instVarName inTable: childTable. 	
			]	
		]	
	].
	^column
	
	! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 3/9/2009 00:00'!
sqsFindColumnForMessage: aMessage 
	| table column |
	table := (SqsClassInfo cachedFor: self depictedClass) cachedClassTable baseTable.
	column := self 
		sqsFindColumnFor: aMessage selector
		inTable: table.
	^ column! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 3/9/2009 00:04'!
sqsJoin: tableName onColumn: column 
	| curTableName oidField |
	curTableName := tableName, suffix.
	oidField := (SqsClassInfo cachedFor: depictedClass) configuration tableConfiguration idField.
	"if we perform operations on objects that return objects themselves, we first need to scope
	back to the table where that new value resides"
	self addToWhereBuffer: '= ' , curTableName , '.' , oidField.
	whereBuffer := self encapsulatedWhere , ' AND '.
	"those tables simply have to added to the query tables, and need no links to other tables"
	query queryTables add: (SqsQueryTable 
			table: (SqsClassInfo cachedFor: depictedClass) cachedClassTable
			alias: suffix
			field: column columnName
			class: depictedClass)! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 3/9/2009 00:02'!
sqsJoinTablesForCollection: collectionDescription
	| curTableName baseClass idField |
	
	baseClass := depictedClass sqsBaseClass.

	idField := (SqsClassInfo cachedFor: depictedClass) configuration tableConfiguration idField.	
	query previousQueryObject class = SqsQueryObject ifTrue: [
		suffix ifNil: [suffix := (query newAliasSuffixForTableOfClass: depictedClass)].
		self 
			sqsJoin: referencedColumn tableName
			onColumn: referencedColumn.
		curTableName := collectionDescription ownerColumn foreignKey referencedTable.
		whereBuffer := whereBuffer, curTableName, suffix, '.', idField , ' '.
		
	] ifFalse: [
		curTableName := collectionDescription ownerColumn foreignKey referencedTable.
		suffix ifNil: [suffix := query aliasSuffixForTableOfClass: baseClass].
		whereBuffer := whereBuffer, curTableName, suffix, '.', idField, ' '.
	].! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 3/9/2009 00:03'!
sqsNextQueryCollection: collectionDescription
	| nextQueryClass nextQuery joinTableSuffix joinTableIdField joinTableName |
	nextQueryClass := SqsQuery classForType: Collection.
	joinTableSuffix := query aliasSuffixForTableOfClass: Collection.
	joinTableName := collectionDescription tableName, joinTableSuffix.
	joinTableIdField := collectionDescription ownerColumn columnName.
	
	query queryTables add: (SqsQueryTable 
		table: ((SqsClassInfo cachedFor: depictedClass) tableStructureHandler joinTableForDescription: collectionDescription)
		alias:  joinTableSuffix
		field:  collectionDescription linkedVariable asString 
		class:  (depictedClass)
		ignoreValues: true).
		
	query distinct: true.
	self sqsJoinTablesForCollection: collectionDescription.

	nextQuery := query newForType: Collection.
	whereBuffer := whereBuffer ,' = ', joinTableName , '.' , joinTableIdField.	
	nextQuery whereBuffer: whereBuffer copy.
	whereBuffer := ''.
	query previousQueryObject: query currentQueryObject.
	nextQuery depictedClass: depictedClass.
	^ nextQuery! !

!SqsQueryObject methodsFor: 'error handling' stamp: 'tkow 3/9/2009 00:03'!
sqsNextQueryObject: column 
	| nextType nextQueryClass curTableName nextQuery baseClass |

	nextType := Smalltalk at: (column associatedClass ifNil: [column objectClass]).
	nextQueryClass := SqsQuery classForType: nextType.
	baseClass := depictedClass sqsBaseClass.

	query previousQueryObject class = SqsQueryObject ifTrue: [ 
		suffix ifNil: [suffix := query newAliasSuffixForTableOfClass: baseClass].
		self 
			sqsJoin: column tableName
			onColumn: column.
	] ifFalse: [
		suffix ifNil: [suffix := query aliasSuffixForTableOfClass: baseClass].
	].

	curTableName := column tableName , suffix.
	whereBuffer := whereBuffer , curTableName , '.' , column columnName.
	nextQuery := query newForType: nextType.
	nextQuery whereBuffer: whereBuffer copy.
	whereBuffer := ''.
	^ nextQuery! !

SqsQueryValue subclass: #SqsQueryString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsQueryString methodsFor: 'copying' stamp: 'wh 8/16/2006 19:24'!
, aString
	" The standard is || yet MySQL used CONCAT 
		Impliment the standard here "
	^(self newForType: String) whereBuffer: 
			self encapsulatedWhere,' || ',aString asSqlValueString.! !

!SqsQueryString methodsFor: 'comparing' stamp: 'tkow 3/6/2009 13:55'!
beginsWith: aString
	^(query newForType: Boolean) whereBuffer: (self encapsulatedWhere),' LIKE ''',aString asEscapedSql,'%'''.! !

!SqsQueryString methodsFor: 'comparing' stamp: 'tkow 2/5/2009 10:45'!
endsWith: aString
	^(query newForType: Boolean) whereBuffer: self whereBuffer,' LIKE ''%',aString asEscapedSql,''''.! !

!SqsQueryString methodsFor: 'comparing' stamp: 'tkow 2/5/2009 13:37'!
includesSubString: aString
	^(query newForType: Boolean) whereBuffer: self whereBuffer,' LIKE ''%',aString asEscapedSql,'%'''.! !

!SqsQueryString methodsFor: 'accessing' stamp: 'tkow 2/5/2009 10:45'!
size
	"Postgres and MySQL handle this the same way "
	^(query newForType: Integer) whereBuffer: 'CHAR_LENGTH(',self whereBuffer,')'.! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
< anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '<'! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
<= anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '<='! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
= anAttrib 
	anAttrib ifNil: 
		[ ^ self 
			booleanCompair: anAttrib
			with: 'IS' ].
	^ self 
		booleanCompair: anAttrib
		with: '='! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
> anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '>'! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
>= anAttrib 
	^ self 
		booleanCompair: anAttrib
		with: '>='! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'wh 8/15/2006 09:59'!
addToWhereBuffer: aString
	
	self whereBuffer: (whereBuffer, ' ', aString).! !

!SqsQueryValue methodsFor: 'converting' stamp: 'wh 8/16/2006 20:52'!
asSqlValueString
	^self encapsulatedWhere.! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'wh 8/16/2006 20:50'!
asString
	^whereBuffer.! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
booleanCompair: anAttrib with: aDbOperator 
	^ self 
		operator: aDbOperator
		returnType: Boolean
		attribute: anAttrib! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'tkow 11/2/2008 21:55'!
depictedClass
	^ depictedClass! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'tkow 11/2/2008 21:55'!
depictedClass: anObject
	depictedClass := anObject! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'wh 8/16/2006 20:32'!
encapsulatedWhere
	whereBuffer size > 0 ifTrue:[
		^'(',whereBuffer,')'.
	] ifFalse:[
		^''.
	].! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'tkow 3/3/2009 11:36'!
inspectorClass
	"Answer the class of the inspector to be used on the receiver.  Called by inspect; 
	use basicInspect to get a normal (less useful) type of inspector."

	^ Inspector! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'tkow 3/3/2009 11:39'!
instVarAt: index 
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	variables corresponds to the named instance variables. Fail if the index 
	is not an Integer or is not the index of a fixed variable. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 73>
	"Access beyond fixed variables."
	^self basicAt: index - self class instSize	! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'tkow 3/3/2009 11:48'!
instVarAt: anInteger put: anObject 
	"Primitive. Store a value into a fixed variable in the receiver. The 
	numbering of the variables corresponds to the named instance variables. 
	Fail if the index is not an Integer or is not the index of a fixed variable. 
	Answer the value stored as the result. Using this message violates the 
	principle that each object has sovereign control over the storing of 
	values into its instance variables. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 74>
	"Access beyond fixed fields"
	^self basicAt: anInteger - self class instSize put: anObject! !

!SqsQueryValue methodsFor: 'testing' stamp: 'wh 8/15/2006 10:38'!
isNil
	self addToWhereBuffer: 'IS NULL'.! !

!SqsQueryValue methodsFor: 'testing' stamp: 'wh 8/15/2006 10:38'!
notNil
	self addToWhereBuffer: 'IS NOT NULL'.! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'tkow 2/23/2009 17:56'!
operator: aChar returnType: aType attribute: anAttrib
	| comp objScoping |

	objScoping := self sqsScopeToObjectIdField.
	
	comp := (anAttrib class includesBehavior: SqsQueryValue) ifTrue: [
		anAttrib whereBuffer	
	] ifFalse: [
		(anAttrib class sqsIsComplexClass) ifFalse: [
			anAttrib asSqlValueString		
		] ifTrue: [
			anAttrib oid asSqlValueString
		]	
	].
	
	^(query newForType: aType) whereBuffer:
			whereBuffer,objScoping,' ',aChar,' ',comp.
	! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:41'!
query
	^query! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'tkow 10/14/2008 10:12'!
query: aQuery
	query := aQuery.
	query currentQueryObject: self.
	self whereBuffer: ''.! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'test 1/26/2009 16:05'!
sqsReferencedColumn
	^ referencedColumn! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'test 1/26/2009 16:05'!
sqsReferencedColumn: anObject
	referencedColumn := anObject! !

!SqsQueryValue methodsFor: 'as yet unclassified' stamp: 'tkow 3/8/2009 23:58'!
sqsScopeToObjectIdField
	| ci |
	^(query previousQueryObject ifNil: [
		((depictedClass sqsIsComplexClass not) or: [whereBuffer notEmpty]) ifTrue: [
			''
		] ifFalse: [
			ci := SqsClassInfo cachedFor: depictedClass.
			ci tableName, (query aliasSuffixForTableOfClass: depictedClass), '.', ci configuration tableConfiguration idField.
		]
	] ifNotNil: [''])! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:57'!
whereBuffer 
	^whereBuffer.
! !

!SqsQueryValue methodsFor: 'accessing' stamp: 'wh 8/15/2006 09:57'!
whereBuffer: aString
	whereBuffer _ aString.! !

!SqsQueryValue methodsFor: 'comparing' stamp: 'tkow 10/30/2008 16:25'!
~= anAttrib 
	anAttrib ifNil: 
		[ ^ self 
			booleanCompair: anAttrib
			with: 'IS NOT' ].
	^ self 
		booleanCompair: anAttrib
		with: '<>'! !

Object subclass: #SqsSchemaImporter
	instanceVariableNames: 'conSpec classPrefix adapter mode tableNames tableColumns classCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsSchemaImporter subclass: #SqsActiveRecordSchemaImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:25'!
automaticMode
	^#auto! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:04'!
loggingMethods
	^OrderedCollection with: (
		'acceptsLoggingOfCompilation',String cr, String tab, '^ false'
	) with: (
		'wantsChangeSetLogging', String cr, String tab,'^ false'
	)! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:26'!
onConSpec: sqsConSpec withPrefix: aString
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: self safeMode;
		yourself! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:26'!
onConSpec: sqsConSpec withPrefix: aString inMode: aMode
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: aMode;
		yourself! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:41'!
onConSpec: sqsConSpec withPrefix: aString inMode: aMode withCategoryName: aString2
	^self new
		conSpec: sqsConSpec;
		classPrefix: aString;
		mode: aMode;
		classCategory: aString2;
		yourself! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:24'!
safeMode
	^#safe! !

!SqsSchemaImporter class methodsFor: 'as yet unclassified' stamp: 'tkow 11/18/2008 17:23'!
testMode
	^#test! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 2/23/2009 17:33'!
adapter
	adapter ifNil: 
		[ adapter := (SqsConnectionManager getInstance sessionForConfiguration: self configuration) sqsDbAdapter ].
	^ adapter! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
adapter: anObject
	adapter := anObject! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/21/2008 09:50'!
classCategory
	^ classCategory ifNil: [
		self classPrefix, '-Models'
	]! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/21/2008 09:49'!
classCategory: anObject
	classCategory := anObject! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:01'!
classNameForTable: tableName
	^(self classPrefix), ((tableName camelized allButLast: 1) capitalized)! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
classPrefix
	^ classPrefix! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
classPrefix: anObject
	classPrefix := anObject! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
conSpec
	^ conSpec! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 11:25'!
conSpec: anObject
	conSpec := anObject! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:15'!
createClass: className withInstVars: instVars
	"That's basically it - just create the class if it does not exist"
	
	Transcript show: ((instVars join: ' '), String cr).
	
	Smalltalk at: className asSymbol ifAbsent: [
		Object subclass: className asSymbol
			instanceVariableNames: (instVars join: ' ')
			classVariableNames: ''
			poolDictionaries: ''
			category: self classCategory	
	].
	self specialClassMethods: self class loggingMethods for: className asSymbol.
	! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:19'!
createClassForTable: tableName
	| instVars className curColumns |
	curColumns := self adapter showFieldsOfTable: tableName.
	instVars := self instVarsFromColumns: curColumns.
	className := self classNameForTable: tableName.
	self createClass: className withInstVars: instVars.! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:37'!
disableClassLogging
	^self mode = self class testMode
	
	
	! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:15'!
import
	| |
	self tableNames: self adapter allTableNames.
	Transcript show: ('Found ',tableNames size asString, 'tables', String cr).
	self tableNames doWithIndex: [:tableName :index | 
		self createClassForTable: tableName.
		Transcript show: 'Created class no. ', index asString, 'for table ', tableName, String cr.
	].
	"self createDescriptions."! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 14:42'!
instVarsFromColumns: curColumns
	| colName type isPrimary defaultValue instVars |
	
	instVars := Set new.
	
	curColumns do: [:row | 
		colName := row at: self adapter class fieldNameColumn.
		type := (row at: self adapter class typeColumn) asString.
		isPrimary := row at: self adapter class keyColumn.
		defaultValue := row at: self adapter class defaultColumn.
		(self isIdField: colName) ifTrue: [
			
		].
		instVars add: colName camelized.
	].

	^ instVars! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:25'!
mode
	^ mode! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:25'!
mode: anObject
	mode := anObject! !

!SqsSchemaImporter methodsFor: 'as yet unclassified' stamp: 'tkow 11/21/2008 13:18'!
specialClassMethods: anArrayOfMethodBodies for: className
	| klass |
	self disableClassLogging ifTrue: [
		klass := Smalltalk at: className.
		(anArrayOfMethodBodies ifNil: [self class loggingMethods]) do: [:methodBody |
			klass compile: methodBody classified: 'auto-generated'
		]		
	].
	
	
	! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:45'!
tableColumns
	^ tableColumns! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:45'!
tableColumns: anObject
	tableColumns := anObject! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:46'!
tableNames
	^ tableNames! !

!SqsSchemaImporter methodsFor: 'accessing' stamp: 'tkow 11/18/2008 17:46'!
tableNames: anObject
	tableNames := anObject! !

Object subclass: #SqsSearch
	instanceVariableNames: 'searchClass loadStrategy limit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsSearch class
	uses: TSqsSearch
	instanceVariableNames: ''!

!SqsSearch class methodsFor: 'access to cache' stamp: 'tkow 12/14/2008 20:51'!
eagerFor: aClass 
	^(self new)
		searchClass: aClass;
		loadStrategy: SqsLoadStrategy eager;
		yourself! !

!SqsSearch class methodsFor: 'as yet unclassified' stamp: 'test 1/22/2009 17:38'!
escapeMethods
	^ Dictionary new
		at: String 
			put: #printString;
		at: Timespan
			put: #asSqlValueString;
		at: DateAndTime
			put: #asSqlValueString;
		at: Time
			put: #asSqlValueString;
		at: Date
			put: #asSqlValueString;
		yourself! !

!SqsSearch class methodsFor: 'access to cache' stamp: 'tkow 9/24/2008 13:49'!
for: aClass
	^(self new)
		searchClass: aClass;
		yourself! !

!SqsSearch class methodsFor: 'access to cache' stamp: 'tkow 12/14/2008 20:51'!
for: aClass withLoadStrategy: anSqsLoadStrategy 
	^(self new)
		searchClass: aClass;
		loadStrategy: anSqsLoadStrategy;
		yourself! !

!SqsSearch class methodsFor: 'constants' stamp: 'tkow 11/4/2008 17:50'!
searchForIdField
	^'oid'! !

!SqsSearch methodsFor: 'block-searching' stamp: 'tkow 10/13/2008 16:48'!
anySatisfy: aBlock
	self detect: aBlock ifNone: [^false].
	^true! !

!SqsSearch methodsFor: 'value-searching' stamp: 'tkow 2/23/2009 17:56'!
blocksForAttributes: attributes andValues: values 
	| function |
	^ attributes withIndexCollect: 
		[ :attr :index | 
		| value escapedValue |
		value := values at: index.
		escapedValue := (value class sqsIsComplexClass) 
			ifFalse: 
				[ function := self class escapeMethods 
					keysAndValuesDetect: [ :classKey :functionName | value class includesBehavior: classKey ]
					ifNone: [ #asString ].
				value perform: function ]
			ifTrue: [ value oid asString ].
		Compiler evaluate: '[:anObject | anObject ' , attr , ' = ' , escapedValue , ']' ]! !

!SqsSearch methodsFor: 'block-searching' stamp: 'tkow 10/14/2008 11:12'!
detect: aBlock 
	| |
	^self detect: aBlock ifNone: [self error: 'no results found']
	
	
	
! !

!SqsSearch methodsFor: 'block-searching' stamp: 'tkow 3/5/2009 20:41'!
detect: aBlock ifNone: errorBlock 
	"we could somehow rty to leave out the objects we already have locally
	 but for now we'll query them anyway because they won't be instantiated 
	 again anyways"
	| query results base |
	base := SqsClassInfo for: self searchClass.
	base tableForClassExists ifTrue: [ 
		query := (SqsQuery on: self searchClass) analyze: aBlock.
		results := self searchSession 
			performSearch: query
			withLimit: 1
	] ifFalse: [results := #()].
	^ results ifEmpty: [ errorBlock value ] ifNotEmpty: [results first]! !

!SqsSearch methodsFor: 'error handling' stamp: 'tkow 1/9/2009 19:02'!
doesNotUnderstand: aMessage
	| attributes limit |
	attributes := self class findAttributesInSelector: aMessage selector forClass: self searchClass.
	attributes ifNil: [
		^super doesNotUnderstand: aMessage.
	] ifNotNil: [
		limit := self class findLimitInSelector: aMessage selector.
		^self searchBy: attributes withValues: (aMessage arguments) limit: limit.
	].! !

!SqsSearch methodsFor: 'value-searching' stamp: 'tkow 3/5/2009 22:33'!
findAll
	| query results classInfo |
	classInfo := SqsClassInfo for: self searchClass.
	classInfo tableForClassExists ifTrue: [
		query := (SqsQuery on: self searchClass) analyze: [:obj |].
		results := self searchSession performSearch: query.
		^ results
	] ifFalse: [
		^ #()
	]
	! !

!SqsSearch methodsFor: 'value-searching' stamp: 'tkow 3/5/2009 20:40'!
findAll: aLimit
	| query results classInfo |
	query := (SqsQuery on: self searchClass) analyze: [:obj |].
	classInfo := SqsClassInfo for: self searchClass.
	results := self searchSession
		performSearch: query
		withLimit: aLimit.
	^ results! !

!SqsSearch methodsFor: 'accessing' stamp: 'tkow 3/1/2009 00:04'!
limit
	^ limit! !

!SqsSearch methodsFor: 'accessing' stamp: 'tkow 3/1/2009 00:04'!
limit: anObject
	limit := anObject! !

!SqsSearch methodsFor: 'value-searching' stamp: 'test 1/23/2009 17:49'!
ofResult: result extract: anInteger
	^ anInteger ifNil: [ 
		result 
	] ifNotNil: [ 
		(anInteger = 1) ifTrue: [ 
			result at: 1 ifAbsent: [ nil ] 
		] ifFalse: [ 
			(anInteger < result size) 	ifTrue: [ 
				result copyFrom: 1 to: anInteger 
			] ifFalse: [ 
				result 
			] 
		] 
	] ! !

!SqsSearch methodsFor: 'value-searching' stamp: 'test 1/22/2009 17:41'!
queryUsingAttributes: attributes withValues: values 
	| blocks queries superWhereBuffer jointQuery |
	blocks := self 
		blocksForAttributes: attributes
		andValues: values.
	queries := blocks collect: 
		[ :aBlock | 
		| query |
		query := SqsQuery on: self searchClass.
		query analyze: aBlock.
		query ].
	superWhereBuffer := (queries collect: [ :query | query whereBuffer ]) join: ' AND '.
	jointQuery := SqsQuery on: self searchClass.
	jointQuery whereBuffer: superWhereBuffer.
	jointQuery valueTables: queries first valueTables.
	jointQuery queryTables: queries first queryTables.
	^ jointQuery! !

!SqsSearch methodsFor: 'value-searching' stamp: 'tkow 3/5/2009 20:40'!
searchBy: attributes withValues: values limit: anInteger 
	| base query result |
	base := SqsClassInfo for: self searchClass.
	^ base tableForClassExists ifTrue: [ 
		query := self queryUsingAttributes: attributes withValues: values.
		result := self searchSession performSearch: query.
		self ofResult: result extract: anInteger.
	] ifFalse: [ 
		anInteger ifNil: [#()] ifNotNil: [nil] 
	]! !

!SqsSearch methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:07'!
searchClass
	^ searchClass! !

!SqsSearch methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:07'!
searchClass: anObject
	searchClass := anObject! !

!SqsSearch methodsFor: 'accessing' stamp: 'tkow 3/5/2009 20:51'!
searchSession
	| conf |
	conf := (SqsClassInfo for: self searchClass) configuration.
	^ SqsConnectionManager getInstance sessionForConfiguration: conf! !

!SqsSearch methodsFor: 'block-searching' stamp: 'tkow 3/5/2009 20:39'!
select: aBlock 
	| query classInfo |
	classInfo := SqsClassInfo for: self searchClass.
	classInfo tableForClassExists ifTrue: [
		query := (SqsQuery on: self searchClass) analyze: aBlock.
		^ self searchSession
			performSearch: query
			withLimit: limit.
	
	] ifFalse: [^ #()]
	! !

Object subclass: #SqsSession
	instanceVariableNames: 'objectCache sqsDbAdapter configuration isInTransaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsSession methodsFor: 'object-assembling' stamp: 'tkow 3/9/2009 23:35'!
assembleObjectFrom: splitRows forSearch: anSqsQuery andTableConfigs: tableConfigs
	| targetClass targetObject currentValues oid tableConf objects |
	objects := OrderedCollection new.
	anSqsQuery valueTables withIndexDo: [ :aliasedTable :index| 
		currentValues := splitRows at: aliasedTable field.
		tableConf := tableConfigs at: index.
		oid := currentValues at: tableConf idField.
		
		targetClass := self 
			objectClassForRow: currentValues
			ofAliasedTable: aliasedTable
			withConfiguration: tableConf.
			
		targetClass ifNil: [
			objects add: nil.
		] ifNotNil: [
			targetObject := self cachedObjectOf: targetClass withOid: oid.
		
			targetObject ifNil: [ 
				targetObject := self 
					newObjectWithOid: oid
					ofClass: targetClass
					fromRow: currentValues
					ofTable: aliasedTable 
			].
			objects add: targetObject.
		]
	].
	"if we have created many objects for this search return them all, 
	otherwhise only the first one"
	^ (objects size = 1) ifTrue: [
		objects first
	] ifFalse: [
		objects
	]! !

!SqsSession methodsFor: 'transaction' stamp: 'tkow 12/15/2008 10:51'!
beginTransaction
	sqsDbAdapter beginTransaction! !

!SqsSession methodsFor: 'object-caching' stamp: 'tkow 2/27/2009 16:06'!
cacheObject: anObject withOid: oid
	SqsStorage 
		cacheObject: anObject
		withOid: oid! !

!SqsSession methodsFor: 'object-caching' stamp: 'tkow 12/12/2008 22:57'!
cachedObjectOf: targetClass withOid: oid 
	^ SqsStorage 
		cachedObjectOfClass: targetClass
		withOid: oid! !

!SqsSession methodsFor: 'transaction' stamp: 'tkow 12/15/2008 10:51'!
commitTransaction
	sqsDbAdapter commitTransaction! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 2/23/2009 16:57'!
configuration
	^ configuration! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 2/23/2009 16:58'!
configuration: anObject
	configuration := anObject.
	sqsDbAdapter := SqsConnectionManager adapterForConSpec: anObject connectionSpec.! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/13/2008 11:17'!
connectionIdentityString
	^ sqsDbAdapter 
		ifNil: [nil]
		ifNotNil: [sqsDbAdapter connectionIdentityString]! !

!SqsSession methodsFor: 'object-assembling' stamp: 'tkow 2/24/2009 19:52'!
createCollectionMapFor: descr from: resultDicts withSearch: search
	| orderField results indexKey index obj tmpKeyIndex |
	"creates a dictionary where the key is the index of the element within the collection and
	the value is the corresponding object"
	orderField := descr orderField.
	results := Dictionary new.
	
	resultDicts doWithIndex: [:resultDict :i |
		indexKey := resultDict keys detect: [:key | key matchesRegex: ('.*.', orderField) ] ifNone: [nil].
		index := indexKey ifNil: [ i ] ifNotNil: [
			tmpKeyIndex := resultDict at: indexKey.
			resultDict removeKey: indexKey.
			tmpKeyIndex
		].
		obj := search ifNil: [
			resultDict at: descr referenceColumn columnName ifAbsent: [nil]
		] ifNotNil: [
			(self createObjectsFrom: (OrderedCollection with: resultDict) forSearch: search) at: 1 ifAbsent: [nil]
		].
		results at: index put: obj.
	].
	^ results
	! !

!SqsSession methodsFor: 'object-assembling' stamp: 'tkow 3/9/2009 23:33'!
createObjectsFrom: rowDictionaries forSearch: anSqsQuery
	
	| objects tablePrefixes splitRows splitColName ix tableConfs |
	objects := OrderedCollection new.
	"skip all calculations, if we don't have any results'"
	rowDictionaries ifEmpty: [^ objects].

	"check which table prefixes hold the data for which objects"
	tablePrefixes := Dictionary new.
	tableConfs := Array new: anSqsQuery valueTables size.
	
	anSqsQuery valueTables withIndexDo: [:aliasedTable :index |
		tableConfs at: index put: (SqsClassInfo cachedFor: aliasedTable queryClass) configuration tableConfiguration.
		aliasedTable allAliasedNames do: [:tableName |
			tablePrefixes at: tableName put: aliasedTable field	
		]
	].

	"then iterate over all row dictionaries and create the objects encoded by this row"
	rowDictionaries do: [:rowDict |
		splitRows := Dictionary new.
		anSqsQuery valueTables do: [:valueTable | splitRows at: valueTable field put: Dictionary new].
		rowDict associationsDo: [:column |
			splitColName := column key splitBy: (self sqsDbAdapter class columnTableSeperator).
			ix := tablePrefixes at: splitColName first ifAbsent: [self error: 'unknown column in search result'].
			(splitRows at: ix) at: splitColName last put: column value.
		].
		objects add: (self assembleObjectFrom: splitRows forSearch: anSqsQuery andTableConfigs: tableConfs).
	].
	^objects! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 2/16/2009 16:52'!
deleteObject: anSqsStorage
	sqsDbAdapter
		removeObjectWithId: anSqsStorage oid
		fromTable: anSqsStorage classInfo cachedClassTable.
	"TODO: remove the object from cache here"! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 2/27/2009 16:07'!
getCollectionDescribedBy: descr forObject: anObject 
	| search results sql resultDicts |
	results := descr simpleValues ifTrue: [ 
		sql := sqsDbAdapter 
			queryForSimpleValuesOfCollection: descr
			ofObjectId: anObject oid.
		resultDicts := sqsDbAdapter executeQuery: sql.
		self createCollectionMapFor: descr from: resultDicts withSearch: nil.
	] ifFalse: [ 
		search := sqsDbAdapter 
			searchForCollectionDescribedBy: descr
			ofObject: anObject.
		resultDicts := sqsDbAdapter performSearch: search withLimit: nil.
		search valueTables removeLast.
		self createCollectionMapFor: descr from: resultDicts withSearch: search.
	].
	^ (Smalltalk at: descr collectionClass) sqsCreateFromResults: results.! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 3/6/2009 16:00'!
inTransactionDo: aBlock
	^ self inTransactionDo: aBlock ifError: [:err | self error: err].! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 3/5/2009 20:08'!
inTransactionDo: aBlock ifError: anErrorBlock
	| result |
	isInTransaction := true.
	result := sqsDbAdapter inTransactionDo: aBlock ifError: anErrorBlock.
	isInTransaction := false.
	^ result! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 3/5/2009 20:09'!
isInTransaction
	^ isInTransaction ifNil: [false]! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 3/5/2009 20:08'!
isInTransaction: anObject
	isInTransaction := anObject! !

!SqsSession methodsFor: 'object-assembling' stamp: 'tkow 3/9/2009 23:47'!
newObjectWithOid: oid ofClass: targetClass fromRow: currentValues ofTable: aliasedTable 
	| newObject storageHelper value |
	newObject := targetClass basicNew.
	self cacheObject: newObject withOid: oid.
	storageHelper := SqsStorage for: newObject.
	aliasedTable originalTable allColumns do: [ :col | 
		value := currentValues at: col columnName ifAbsent: [nil].
		storageHelper 
			setInstVarNamed: col linkedVariable
			withValue: value
	].
	storageHelper createInstVarMap.

	storageHelper ownedCollections do:[ :collectionDescr | 
		storageHelper 
			setInstVarNamed: collectionDescr linkedVariable
			withValue: nil 
	].
	^ newObject! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/12/2008 22:01'!
objectCache
	^ objectCache! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/12/2008 22:01'!
objectCache: anObject
	objectCache := anObject! !

!SqsSession methodsFor: 'object-assembling' stamp: 'tkow 2/27/2009 18:17'!
objectClassForRow: currentValues ofAliasedTable: aliasedTable withConfiguration: tableConf
	| cn |
	cn := currentValues at: tableConf typeField ifAbsent: [^ aliasedTable queryClass].
	^ cn ifNil: [
		nil	
	] ifNotNil: [
		Smalltalk at: cn asSymbol ifAbsent: [self error: (cn,' class not available in this image')]
	]
	! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/12/2008 22:57'!
performSearch: anSqsQuery
	^ self performSearch: anSqsQuery withLimit: nil! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 12/12/2008 22:57'!
performSearch: anSqsQuery withLimit: aLimit
	| rowDicts |
	rowDicts := self sqsDbAdapter performSearch: anSqsQuery withLimit: aLimit.
	^ self createObjectsFrom: rowDicts forSearch: anSqsQuery.! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 2/25/2009 15:52'!
resetDatabase
	sqsDbAdapter resetDatabase.
	SqsTableStructureHandler clearTableCacheFor: self connectionIdentityString.
	! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/12/2008 22:01'!
sqsDbAdapter
	^ sqsDbAdapter! !

!SqsSession methodsFor: 'accessing' stamp: 'tkow 12/12/2008 22:01'!
sqsDbAdapter: anObject
	sqsDbAdapter := anObject! !

!SqsSession methodsFor: 'database operations' stamp: 'tkow 2/28/2009 22:52'!
truncateDatabase
	sqsDbAdapter truncateDatabase.
	SqsStorage flushObjectCache.
	! !

Object subclass: #SqsSessionPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsSessionPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrConfiguration
	^ SqsColumn new associatedClass: #SqsConfiguration;
		 manuallyMaintained: false;
		 columnName: 'configuration_id';
		 sqlType: #integer;
		 objectClass: #SqsConfiguration;
		 tableName: 'sqs_sessions';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'configuration';
		 yourself! !

!SqsSessionPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsInTransaction
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_in_transaction';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'sqs_sessions';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isInTransaction';
		 yourself! !

!SqsSessionPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSqsDbAdapter
	^ SqsColumn new associatedClass: #SqsDatabaseAdapter;
		 manuallyMaintained: false;
		 columnName: 'sqs_db_adapter_id';
		 sqlType: #integer;
		 objectClass: #SqsDatabaseAdapter;
		 tableName: 'sqs_sessions';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'sqsDbAdapter';
		 yourself! !

Object subclass: #SqsStaggeredIdCache
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsStaggeredIdCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 13:14'!
at: anOid
	^ (self subCacheFor: anOid) at: (self subCacheIndexFor: anOid)! !

!SqsStaggeredIdCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 13:14'!
at: anOid ifAbsent: something
	^ (self subCacheFor: anOid) at: (self subCacheIndexFor: anOid) ifAbsent: something! !

!SqsStaggeredIdCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 13:10'!
at: anOid put: anObject
	(self subCacheFor: anOid) at: (self subCacheIndexFor: anOid) put: anObject! !

!SqsStaggeredIdCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 20:50'!
cacheIndexFor: anOid
	^ (anOid // 1024) + 1! !

!SqsStaggeredIdCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 13:03'!
initialize
	super initialize.
	cache := Array new: 1024.! !

!SqsStaggeredIdCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 13:09'!
subCacheFor: anOid
	| subCache cacheIndex |
	cacheIndex := self cacheIndexFor: anOid.
	subCache := cache at: cacheIndex ifAbsent: nil.
	subCache ifNil: [
		cache at: cacheIndex put: (WeakArray new: 1024)	
	].
	^ cache at: cacheIndex! !

!SqsStaggeredIdCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 20:59'!
subCacheIndexFor: anOid
	| tryValue |
	tryValue := anOid \\ 1024.
	^ tryValue == 0 ifTrue: [
		1024	
	] ifFalse: [
		tryValue
	]! !

Object subclass: #SqsStorage
	instanceVariableNames: 'storedObject oid classInfo tableStructureHandler descriptionHandler stored sqsSession instVarMap level'
	classVariableNames: 'ObjectCache ObjectIdCache TableCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsStorage class
	instanceVariableNames: 'InstanceCache'!

SqsStorage class
	instanceVariableNames: 'InstanceCache'!

SqsStorage subclass: #SqsDevStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsDevStorage methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 20:05'!
createClassDescription
	self descriptionHandler createDescriptions! !

!SqsDevStorage methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 20:08'!
createTableStructure
	self tableForClassExists
		ifTrue: [self tableStructureHandler updateTableStructure]
		ifFalse: [self tableStructureHandler createTableStructure].! !

SqsStorage subclass: #SqsProductionStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsProductionStorage methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 20:06'!
createClassDescription
	! !

!SqsProductionStorage methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 20:08'!
createTableStructure
	! !

!SqsStorage class methodsFor: 'object-caching' stamp: 'tkow 12/4/2008 17:13'!
cacheObject: anObject withOid: oid
	self objectCache cacheObject: anObject withOid: oid.
! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:18'!
cachedObjectOfClass: aClass withOid: oid 
	^self objectCache cachedObjectOfClass: aClass withOid: oid! !

!SqsStorage class methodsFor: 'proxy-creation' stamp: 'tkow 2/19/2009 22:09'!
createCollectionProxyFor: ivarName with: anObject in: proxyHolder description: description 
	^ (anObject class includesBehavior: SqsProxy)
		ifTrue: [ anObject ]
		ifFalse: 
			[ SqsCollectionProxy 
				for: anObject
				ofInstVar: ivarName
				in: proxyHolder
				simpleValues: description simpleValues ]! !

!SqsStorage class methodsFor: 'proxy-creation' stamp: 'tkow 3/5/2009 15:35'!
createProxyFor: ivarName with: anObject in: proxyHolder 
	^ (anObject class includesBehavior: SqsProxy) 
		ifTrue: [ anObject ]
		ifFalse: [ 
			SqsProxy 
				for: anObject
				ofInstVar: ivarName
				in: proxyHolder 
		]! !

!SqsStorage class methodsFor: 'as yet unclassified' stamp: 'tkow 1/6/2009 15:57'!
development
	"this somewhat brakes the iron 'no magic values' rule, but I think it is more elegant
	 than the if else stuff..."
	^ SqsDevStorage! !

!SqsStorage class methodsFor: 'cache-flushing' stamp: 'tkow 10/10/2008 14:59'!
flushInstanceCache
	InstanceCache := nil! !

!SqsStorage class methodsFor: 'cache-flushing' stamp: 'tkow 12/4/2008 17:11'!
flushObjectCache
	self objectCache clear.! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 3/10/2009 00:13'!
for: anObject
	| instance |
	instance := (self instanceCacheFor: anObject class) at: anObject ifAbsent: [nil].
	instance ifNil: [
		instance := (self storageClassFor: anObject) new
				storedObject: anObject;
				classInfo: (SqsClassInfo for: anObject class);
				yourself.
		(self instanceCacheFor: anObject class) at: anObject put: instance.
	].
	^ instance! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 3/9/2009 13:52'!
instanceCacheFor: aClass
	InstanceCache ifNil: [
		InstanceCache := Dictionary new.	
	].
	^ InstanceCache at: aClass name ifAbsentPut: [SqsWeakStaggeredCache new]! !

!SqsStorage class methodsFor: 'cache-flushing' stamp: 'tkow 12/12/2008 17:42'!
objectCache
	ObjectCache ifNil: [ ObjectCache := SqsObjectCache new ].
	^ ObjectCache! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 12/4/2008 17:22'!
oidFor: anObject
	^ self objectCache oidFor: anObject! !

!SqsStorage class methodsFor: 'as yet unclassified' stamp: 'tkow 1/6/2009 15:53'!
production
	^ SqsProductionStorage! !

!SqsStorage class methodsFor: 'access to cache' stamp: 'tkow 3/10/2009 00:13'!
storageClassFor: anObject
	| configuration |
	"instead of putting some sort of if-then-else here, I rely on the fact that the respective
	 storage classes will respond to a message named like the chosen mode"
	configuration := (SqsClassInfo for: anObject class) configuration. 
	^ self perform: configuration environment! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:35'!
baseClass
	^self classInfo baseClass! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:28'!
classInfo
	^classInfo ! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/29/2008 16:26'!
classInfo: anObject
	classInfo := anObject! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 11/21/2008 22:11'!
configuration
	^self classInfo configuration! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 3/6/2009 17:06'!
considerForUpdate: anObject
	^ anObject class sqsIsComplexClass ifTrue: [
		anObject isCollection	not
	] ifFalse: [
		true
	]! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 2/25/2009 20:04'!
createClassDescription
	self subclassResponsibility! !

!SqsStorage methodsFor: 'accessing' stamp: 'test 3/5/2009 16:53'!
createInstVarMap
	self storedObject instVarDict associationsDo: [ :assoc | 
		(self considerForUpdate: assoc value) ifTrue: [ 
			instVarMap 
				at: assoc key
				put: (self ivmValueFor: assoc value) 
		] 
	].
	instVarMap 
		at: SqsTable typeLink
		put: self storedObject class name! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 2/25/2009 20:18'!
createRecord
	self oid: self tableStructureHandler insertCurrentObject.
	self tableStructureHandler insertOwnedCollections.
! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 2/25/2009 20:07'!
createTableStructure
	self subclassResponsibility! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:10'!
descriptionHandler
	descriptionHandler ifNil: [
		descriptionHandler := self classInfo descriptionHandlerClass forObject: self
	].
	^descriptionHandler
	! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:17'!
descriptionHandler: anObject
	descriptionHandler := anObject! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 12/13/2008 10:48'!
destroy
	self oid ifNotNil: [ 
		self sqsSession deleteObject: self	
	]! !

!SqsStorage methodsFor: 'object-information' stamp: 'tkow 9/29/2008 15:29'!
directlyReferencedObjects
	^self descriptionHandler directlyReferencedObjects! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 3/5/2009 15:51'!
dirtyAttributes
	| dirtyVars |
	"the trivial case - new object, store everything"
	self newRecord ifTrue: [ ^ self descriptionHandler persistedInstanceVariables ].
	dirtyVars := Set new.
	self descriptionHandler persistedInstanceVariables do: [ :ivn | 
		| value |
		value := self valueOfInstVar: ivn.
		(self considerForUpdate: value) ifTrue: [ 
			(instVarMap includesKey: ivn) 
				ifTrue: [ (self ivmValueFor: value) = (instVarMap at: ivn) ifFalse: [ dirtyVars add: ivn ]]
				ifFalse: [ dirtyVars add: ivn ] ] ].
	self storedObject class name ~= (instVarMap at: SqsTable typeLink) ifTrue: [ dirtyVars add: SqsTable typeLink ].
	^ dirtyVars! !

!SqsStorage methodsFor: 'iterating' stamp: 'tkow 9/30/2008 14:21'!
doForAllSuperclasses: aBlock
	self classInfo doForAllSuperclasses: aBlock! !

!SqsStorage methodsFor: 'object-access' stamp: 'tkow 2/23/2009 17:46'!
escapedValueForInstVar: instVarName 
	| ivarValue objectId |
	" get the current value of the instance variable"
	ivarValue := self valueOfInstVar: instVarName.

	" if an object has an asSqlValueString method, fine - use this
	 the other objects are treated as complex ones and we should already have an oid for them"
	^ (ivarValue class sqsIsComplexClass) 
		ifFalse: [ ivarValue asSqlValueString ]
		ifTrue: 
			[ objectId := self class oidFor: ivarValue.
			objectId 
				ifNil: [ nil asSqlValueString ]
				ifNotNil: [ objectId ] ]! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 3/5/2009 15:39'!
flatSave
	^ self saveToLevel: 0! !

!SqsStorage methodsFor: 'object-information' stamp: 'tkow 9/29/2008 15:30'!
indirectlyReferencedObjects
	^self descriptionHandler indirectlyReferencedObjects! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 1/19/2009 17:28'!
initialize
	super initialize.
	instVarMap := Dictionary new.! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 3/5/2009 15:50'!
isDirty
	self newRecord ifTrue: [ ^ true ].
	self storedObject instVarDict associationsDo: 
		[ :assoc | 
		(self considerForUpdate: assoc value) ifTrue: 
			[ (instVarMap includesKey: assoc key) 
				ifTrue: [ (self ivmValueFor: assoc value) = (instVarMap at: assoc key) ifFalse: [ ^ true ] ]
				ifFalse: [ ^ true ] ] ].
	^ false! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 3/5/2009 15:49'!
ivmValueFor: anObject
	^ anObject class sqsIsComplexClass ifTrue: [
		anObject oid	
	] ifFalse: [
		anObject
	]! !

!SqsStorage methodsFor: 'object-access' stamp: 'tkow 2/23/2009 18:16'!
loadProxiedCollectionFor: ivarName 
	| descr |
	descr := self descriptionHandler sqsDescriptionForInstVar: ivarName.
	^ self sqsSession 
		getCollectionDescribedBy: descr
		forObject: self.
	! !

!SqsStorage methodsFor: 'object-access' stamp: 'tkow 3/6/2009 17:01'!
loadProxiedObjectFor: ivarName withOid: anObjectId 
	| descr |
	descr := self descriptionHandler sqsDescriptionForInstVar: ivarName.
	^ (SqsSearch for: (Smalltalk at: descr associatedClass)) detect: [:obj | obj oid = anObjectId] ifNone: [nil]
		! !

!SqsStorage methodsFor: 'accessing' stamp: 'tk 5/26/2008 15:18'!
newRecord
	^self oid isNil.! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:29'!
oid
	oid ifNil: [
		oid := self class oidFor: self storedObject.
	].
	^oid! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 14:30'!
oid: anInteger
	oid := anInteger.
	self class cacheObject: self storedObject withOid: oid.! !

!SqsStorage methodsFor: 'object-information' stamp: 'tkow 2/19/2009 22:17'!
ownedCollections
	^self descriptionHandler ownedCollections! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 2/28/2009 13:41'!
save
	"just to avoid circular calls of the save function"
	self saveToLevel: 1.! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'test 3/3/2009 14:09'!
saveAssociations
	self directlyReferencedObjects do: [:obj | obj save: self sqsSession toLevel: (level - 1)].
	self indirectlyReferencedObjects do: [:collectionInfo |
		collectionInfo collectionDescription simpleValues ifFalse: [
			collectionInfo collection do: [:obj | obj ifNotNil: [obj save: self sqsSession toLevel: (level - 1)]]
		]
	]! !

!SqsStorage methodsFor: 'as yet unclassified' stamp: 'tkow 2/25/2009 20:06'!
saveObject
	self newRecord
		ifTrue: [self createRecord]
		ifFalse: [self updateRecord].! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'test 3/3/2009 19:43'!
saveToLevel: aLevel
	level := aLevel.
	"just to avoid circular calls of the save function"
	self stored ifFalse: [
		self stored: true.
		self createClassDescription.
		(level > 0) ifTrue: [self saveAssociations].
		self createTableStructure.
		self saveObject.
		self createInstVarMap.
		self stored: false
	] ifTrue: [
		self createTableStructure.
		self saveObject.
		self stored: false.
	].
! !

!SqsStorage methodsFor: 'object-access' stamp: 'tkow 2/22/2009 14:02'!
setInstVarNamed: ivarName withValue: anObject 
	"only set instvars of ourselves and ignore those of subclasses"
	| object |
	(self storedObject class allInstVarNames includes: ivarName) ifTrue: 
		[ object := self descriptionHandler 
			adaptObject: anObject
			toSpecificationOfInstVar: ivarName.
		self descriptionHandler useInstVarAccessors 
			ifTrue: 
				[ self storedObject 
					perform: (ivarName , ':') asSymbol
					with: object ]
			ifFalse: 
				[ self storedObject 
					instVarNamed: ivarName
					put: object ] ].
	"and update the instvarmap if we don't have a proxy or another complex object'"
	(anObject class includesSelector: SqsDescriptionHandler sqlValueStringSelector) ifTrue: 
		[ instVarMap 
			at: ivarName
			put: anObject ]! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 3/5/2009 20:31'!
sqsSession
	sqsSession ifNil: [ 
		sqsSession := SqsConnectionManager getInstance sessionForConfiguration: self classInfo configuration
	].
	^ sqsSession! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 12/12/2008 23:09'!
sqsSession: aConnection 
	sqsSession := aConnection! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 16:35'!
stored
	stored ifNil: [stored := false].
	^stored! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 16:26'!
stored: anObject
	stored := anObject! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 2/19/2009 22:38'!
storedObject
	^ storedObject at: 1 ifAbsent: [nil]! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 2/19/2009 22:38'!
storedObject: anObject
	storedObject := WeakArray with: anObject.
	self createInstVarMap.! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 1/18/2009 16:06'!
tableForClassExists
	^ self tableStructureHandler tableForClassExists! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 12/12/2008 17:44'!
tableStructureHandler
	tableStructureHandler ifNil: [ tableStructureHandler := SqsTableStructureHandler forObject: self ].
	^ tableStructureHandler! !

!SqsStorage methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:17'!
tableStructureHandler: anObject
	tableStructureHandler := anObject! !

!SqsStorage methodsFor: 'object-persistence' stamp: 'tkow 2/25/2009 19:50'!
updateRecord
	self isDirty ifTrue: [
		self tableStructureHandler updateObject.	
	].
	self class cacheObject: self storedObject withOid: oid.
	self tableStructureHandler updateOwnedCollections.
	! !

!SqsStorage methodsFor: 'object-access' stamp: 'tkow 10/7/2008 18:46'!
valueOfInstVar: instVarName 
	^(self storedObject class allInstVarNames includes: instVarName) ifTrue: [
		self descriptionHandler useInstVarAccessors 
			ifTrue: [ self storedObject perform: instVarName asSymbol ]
			ifFalse: [ self storedObject instVarNamed: instVarName asSymbol ].
	] ifFalse: [
		nil
	]! !

Object subclass: #SqsTableCache
	instanceVariableNames: 'tableCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsTableCache class methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:00'!
classTableKey
	^ #classTable! !

!SqsTableCache class methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
existenceKey
	^ #exists! !

!SqsTableCache class methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
joinTableKey
	^ #joinTables! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/6/2009 11:16'!
allTableNames
	| names |
	names := OrderedCollection new.
	self tableCache valuesDo: [:classCache |
		| curTable |
		curTable := classCache at: self class classTableKey ifAbsent: [nil].
		curTable ifNotNil: [names add: curTable tableName].
		(classCache includesKey: self class joinTableKey) ifTrue: [
			names addAll: (classCache at: self class joinTableKey) keys.
		]	
	].
	^ names! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 12/6/2008 15:48'!
cacheForClass: aClassName
	^ self tableCache at: aClassName ifAbsentPut: [Dictionary new]! !

!SqsTableCache methodsFor: 'accessing' stamp: 'tkow 12/6/2008 11:16'!
initialize
	super initialize.
	self tableCache: Dictionary new. ! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
insertJoinTable: joinTable forClass: aClassName 
	| tCache jtCache |
	tCache := self cacheForClass: aClassName.
	jtCache := tCache 
		at: self class joinTableKey
		ifAbsentPut: [ Dictionary new ].
	jtCache 
		at: joinTable tableName
		ifAbsentPut: joinTable! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'test 1/22/2009 19:43'!
insertTable: classTable forClass: aClassName 
	| tCache |
	tCache := self cacheForClass: aClassName.
	tCache 
		at: self class existenceKey
		put: true.
	tCache 
		at: self class classTableKey
		put: classTable! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
joinTableNamed: aName forClass: aClassName 
	| tCache jCache |
	tCache := self cacheForClass: aClassName.
	tCache 
		at: self class existenceKey
		put: true.
	jCache := tCache 
		at: self class joinTableKey
		ifAbsentPut: [ Dictionary new ].
	^ jCache 
		at: aName
		ifAbsent: [ nil ]! !

!SqsTableCache methodsFor: 'accessing' stamp: 'tkow 12/5/2008 21:01'!
tableCache
	^ tableCache! !

!SqsTableCache methodsFor: 'accessing' stamp: 'tkow 12/5/2008 21:01'!
tableCache: anObject
	tableCache := anObject! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:01'!
tableExistsForClass: aClassName 
	^ (self cacheForClass: aClassName) 
		at: self class existenceKey
		ifAbsent: [ false ]! !

!SqsTableCache methodsFor: 'as yet unclassified' stamp: 'tkow 1/19/2009 15:00'!
tableForClass: aClassName 
	^ (self cacheForClass: aClassName) 
		at: self class classTableKey
		ifAbsent: [ nil ]! !

Object subclass: #SqsTableChanges
	instanceVariableNames: 'oldTable newTable addedColumns removedColumns alteredColumns renamedColumns addedConstraints removedConstraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

!SqsTableChanges class methodsFor: 'as yet unclassified' stamp: 'tkow 10/9/2008 11:29'!
oldTable: anSqSTable newTable: anotherSqSTable
	^self new
		oldTable: anSqSTable;
		newTable: anotherSqSTable;
		yourself! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
addedColumns
	^ addedColumns! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
addedColumns: anObject
	addedColumns := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 2/19/2009 14:50'!
addedConstraints
	^ addedConstraints! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 2/19/2009 14:50'!
addedConstraints: anObject
	addedConstraints := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
alteredColumns
	^ alteredColumns! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
alteredColumns: anObject
	alteredColumns := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 2/19/2009 16:35'!
calculateChanges
	| oldColumns newColumns |
	oldColumns := oldTable columns.
	newColumns := newTable columns.
	oldColumns do: [ :oldColumn | 
		| curColumn |
		curColumn := newColumns detect: [:col | col linkedVariable = oldColumn linkedVariable] ifNone: [nil].
		self checkColumnChangeFrom: oldColumn to: curColumn. 
		self checkConstraintChangesFrom: oldColumn to: curColumn.
	].
	addedColumns addAll: (newColumns select: [ :newColumn | 
		(oldColumns anySatisfy: [:oldColumn | oldColumn linkedVariable = newColumn linkedVariable]) not 
	]).! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 2/19/2009 16:34'!
checkColumnChangeFrom: oldColumn to: curColumn
	curColumn ifNil: [ 
		removedColumns add: oldColumn
	] ifNotNil: [ 
		curColumn columnName ~= oldColumn columnName ifTrue: [ 
			renamedColumns add: (OrderedCollection 
				with: oldColumn
				with: curColumn)
		].
		(curColumn sqlType ~= oldColumn sqlType and: [ curColumn sqlType isNil not ]) ifTrue: [ 
			alteredColumns add: curColumn 
		].
	]! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 2/19/2009 19:50'!
checkConstraintChangesFrom: oldColumn to: curColumn
	| newFk oldFk |
	newFk := curColumn ifNil: [nil] ifNotNil: [curColumn foreignKey].
	oldFk := oldColumn ifNil: [nil] ifNotNil: [oldColumn foreignKey].
	
	newFk ifNil: [
		oldFk ifNotNil: [removedConstraints add: oldFk]	
	] ifNotNil: [
		oldFk ifNil: [
			addedConstraints add: newFk.
		] ifNotNil: [
			(oldFk foreignKeyName = newFk foreignKeyName) ifFalse: [
				removedConstraints add: oldFk.
				addedConstraints add: newFk.	
			]
		]
	] ! !

!SqsTableChanges methodsFor: 'initialization' stamp: 'tkow 2/19/2009 19:34'!
initialize
	super initialize.
	addedColumns := OrderedCollection new.
	alteredColumns := OrderedCollection new.
	removedColumns := OrderedCollection new.
	renamedColumns := OrderedCollection new.
	removedConstraints := OrderedCollection new.
	addedConstraints := OrderedCollection new.! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
newTable
	^ newTable! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
newTable: anObject
	newTable := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 14:46'!
newTableName
	^(self oldTable tableName ~= self newTable tableName) ifTrue: [
		self newTable tableName
	] ifFalse: [
		nil
	]! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
oldTable
	^ oldTable! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:30'!
oldTable: anObject
	oldTable := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
removedColumns
	^ removedColumns! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
removedColumns: anObject
	removedColumns := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 2/19/2009 14:50'!
removedConstraints
	^ removedConstraints! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 2/19/2009 14:50'!
removedConstraints: anObject
	removedConstraints := anObject! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
renamedColumns
	^ renamedColumns! !

!SqsTableChanges methodsFor: 'accessing' stamp: 'tkow 10/9/2008 11:20'!
renamedColumns: anObject
	renamedColumns := anObject! !

Object subclass: #SqsTableConfiguration
	uses: TSqsSelfPrinting
	instanceVariableNames: 'inheritanceMode typeField idField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base-Structures'!

SqsTableConfiguration class
	uses: TSqsSelfPrinting classTrait
	instanceVariableNames: ''!

!SqsTableConfiguration class methodsFor: 'presets' stamp: 'tkow 12/12/2008 17:44'!
activeRecordStyle
	^ self new
		typeField: 'type';
		idField: 'id';
		inheritanceMode: SqsTableStructureHandler singleTableInheritance;
		yourself! !

!SqsTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:09'!
standardIdField
	^'sqs_oid'! !

!SqsTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 12/12/2008 17:44'!
standardInheritanceMode
	^ SqsTableStructureHandler singleTableInheritance! !

!SqsTableConfiguration class methodsFor: 'standard values' stamp: 'tkow 11/7/2008 15:09'!
standardTypeField
	^'sqs_type_field'! !

!SqsTableConfiguration methodsFor: 'printing' stamp: 'test 1/27/2009 11:29'!
codeForObjectCreation
	| aStream |
	aStream := TextStream on: String new.
	aStream nextPut: $(.
	aStream nextPutAll: self class name , ' new'.
	aStream nextPutAll: String crlf , String tab.
	1 
		to: self class instSize
		do: 
			[ :i | 
			(self instVarAt: i) ifNotNil: 
				[ aStream
					nextPutAll: String cr , String tab;
					nextPutAll: ' ' , (self class allInstVarNames at: i) , ': ';
					store: (self instVarAt: i);
					nextPut: $; ] ].
	aStream nextPutAll: String cr , String tab , ' yourself)'.
	^ aStream contents! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
idField
	^ idField! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
idField: anObject
	idField := anObject! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
inheritanceMode
	^ inheritanceMode! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
inheritanceMode: anObject
	inheritanceMode := anObject! !

!SqsTableConfiguration methodsFor: 'as yet unclassified' stamp: 'tkow 11/7/2008 15:06'!
initialize
	super initialize.
	self idField: self class standardIdField.
	self inheritanceMode: self class standardInheritanceMode.
	self typeField: self class standardTypeField.! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
typeField
	^ typeField! !

!SqsTableConfiguration methodsFor: 'accessing' stamp: 'tkow 11/7/2008 15:05'!
typeField: anObject
	typeField := anObject! !

Object subclass: #SqsTableLink
	instanceVariableNames: 'joinDirection fromFields toFields toTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Query'!

!SqsTableLink class methodsFor: 'as yet unclassified' stamp: 'tkow 11/25/2008 13:12'!
table: aTable fromField: aString toField: anotherString direction: joinSql
	| instance |
	instance := self new
		toTable: aTable;
		joinDirection: joinSql;
		yourself.
		
	instance fromFields add: aString.
	instance toFields add: anotherString.
	^ instance! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
fromFields
	^ fromFields! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
fromFields: anObject
	fromFields := anObject! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 14:23'!
initialize
	super initialize.
	self fromFields: OrderedCollection new.
	self toFields: OrderedCollection new.! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
joinDirection
	^ joinDirection! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
joinDirection: anObject
	joinDirection := anObject! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
toFields
	^ toFields! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/25/2008 13:10'!
toFields: anObject
	toFields := anObject! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
toTable
	^ toTable! !

!SqsTableLink methodsFor: 'accessing' stamp: 'tkow 11/24/2008 14:34'!
toTable: anObject
	toTable := anObject! !

Object subclass: #SqsTableStructureHandler
	instanceVariableNames: 'currentObject classInfo'
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'SqSave-Base'!

SqsTableStructureHandler subclass: #SqsClassTableInheritanceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'test 2/3/2009 18:40'!
classTable
	| table baseInfo t |
	baseInfo := SqsClassInfo for: self classInfo baseClass.
	table := self tableForClassInfo: baseInfo.
	t := self createChildrenForTable: table ofClass: baseInfo.
	t ifNotNil: [table := t].
	^ table
! !

!SqsClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'test 2/3/2009 18:39'!
createChildrenForTable: table ofClass: baseInfo 
	| childInfo childTable currentTable t |
	currentTable := nil.
	baseInfo currentClass subclasses do: [ :subClass | 
		childInfo := SqsClassInfo for: subClass.
		childTable := self tableForClassInfo: childInfo.
		subClass = classInfo currentClass ifTrue: [currentTable := childTable].
		childTable parent: table.
		t := self createChildrenForTable: childTable ofClass: childInfo.
		t ifNotNil: [currentTable := t].
	].
	^ currentTable! !

!SqsClassTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 12/12/2008 17:38'!
createParentsForTable: table ofClass: classInf 
	| parentInfo parentTable |
	classInf currentClass ~= classInf baseClass ifTrue: 
		[ parentInfo := SqsClassInfo for: classInf currentClass superclass.
		parentTable := self tableForClassInfo: parentInfo.
		table parent: parentTable.
		self 
			createParentsForTable: parentTable
			ofClass: parentInfo ]! !

SqsTableStructureHandler subclass: #SqsSingleTableInheritanceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsSingleTableInheritanceHandler methodsFor: 'table-operations' stamp: 'tkow 12/12/2008 17:38'!
classTable
	| table baseClassInfo newColumns |
	baseClassInfo := SqsClassInfo for: self classInfo baseClass.
	table := self tableForClassInfo: baseClassInfo.
	baseClassInfo currentClass allSubclasses do: 
		[ :subClass | 
		newColumns := (SqsClassInfo for: subClass) classTableColumns.
		table columns addAll: newColumns ].
	table columns do: [ :column | column tableName: table tableName ].
	^ table! !

!SqsSingleTableInheritanceHandler methodsFor: 'as yet unclassified' stamp: 'tkow 1/18/2009 17:00'!
tableForClassExists
	^ self tableCache tableExistsForClass: self classInfo baseClass name.! !

!SqsSingleTableInheritanceHandler methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:14'!
tableName
	^self classInfo baseClass name asSqSaveTableName! !

!SqsTableStructureHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 15:56'!
classTableInheritance
	^#classTableInheritance! !

!SqsTableStructureHandler class methodsFor: 'cache-access' stamp: 'test 2/25/2009 16:25'!
clearTableCacheFor: aConnectionIdentityString
	TableCache ifNotNil: [
		TableCache at: aConnectionIdentityString put: SqsTableCache new.	
	]
	
! !

!SqsTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 10/6/2008 18:25'!
forClassInfo: aClassInfo
	| targetClass |
	targetClass := self targetClassForClassInfo: aClassInfo.
	"initialize the table cache (if not already done...)"
	TableCache ifNil: [TableCache := Dictionary new].
	^ targetClass new 
		classInfo: aClassInfo;
		yourself! !

!SqsTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 9/30/2008 11:47'!
forObject: anSqSStorageObject 
	| targetClass |
	targetClass := self targetClassForClassInfo: anSqSStorageObject classInfo.
	TableCache ifNil: [TableCache := Dictionary new].
	^ targetClass new 
		currentObject: anSqSStorageObject;
		classInfo: anSqSStorageObject  classInfo;
		yourself! !

!SqsTableStructureHandler class methodsFor: 'constants' stamp: 'tkow 9/10/2008 15:56'!
singleTableInheritance
	^#singleTableInheritance! !

!SqsTableStructureHandler class methodsFor: 'cache-access' stamp: 'tkow 2/25/2009 16:21'!
tableCache
	^ TableCache! !

!SqsTableStructureHandler class methodsFor: 'cache-access' stamp: 'tkow 3/6/2009 11:17'!
tableCacheFor: aConnectionIdentityString
	^ TableCache ifNil: [
		SqsTableCache new		
	] ifNotNil: [
		TableCache at: aConnectionIdentityString ifAbsent: [SqsTableCache new]
	]
	
! !

!SqsTableStructureHandler class methodsFor: 'cached-creation' stamp: 'tkow 12/12/2008 17:47'!
targetClassForClassInfo: classInfo 
	| targetClass |
	targetClass := SqsSingleTableInheritanceHandler.
	classInfo inheritanceMode = self classTableInheritance ifTrue: [ targetClass := SqsClassTableInheritanceHandler ].
	^ targetClass! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'test 1/22/2009 19:43'!
changesOfClassTable: anSqSTable 
	| oldTable changes |
	oldTable := self tableCache tableForClass: anSqSTable associatedClass.
	oldTable 
		ifNil: [ self createTable: anSqSTable ]
		ifNotNil: 
			[ changes := (SqsTableChanges 
				oldTable: oldTable
				newTable: anSqSTable) calculateChanges ].
	^ changes! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/12/2008 17:40'!
changesOfJoinTable: joinTable 
	| oldTable changes |
	oldTable := self tableCache 
		joinTableNamed: joinTable tableName
		forClass: self classInfo baseClass name.
	oldTable 
		ifNil: [ self createTable: joinTable ]
		ifNotNil: 
			[ changes := (SqsTableChanges 
				oldTable: oldTable
				newTable: joinTable) calculateChanges ].
	^ changes! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 17:30'!
classInfo
	^classInfo! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/29/2008 17:26'!
classInfo: anObject 
	classInfo := anObject! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 10/6/2008 17:40'!
classTable
	^self subclassResponsibility! !

!SqsTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 2/5/2009 16:57'!
columnValueDictionaryFor: classTable
	| columnValueDictionary |
	columnValueDictionary := Dictionary new.
	classTable columns do: [:column |
		| value |
		column ~= classTable oidColumn ifTrue: [
			value := self currentObject escapedValueForInstVar: column linkedVariable.
			columnValueDictionary at: column columnName put: value.
		]
	].
	^ columnValueDictionary! !

!SqsTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 2/27/2009 16:44'!
columnValueDictionaryFor: classTable withOnly: dirtyVars
	| columnValueDictionary |
	columnValueDictionary := Dictionary new.
	classTable columns do: [:column |
		| value |
		(dirtyVars includes: column linkedVariable) ifTrue: [
			value := self currentObject escapedValueForInstVar: column linkedVariable.
			columnValueDictionary at: column columnName put: value.
		]
	].
	^ columnValueDictionary! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 2/16/2009 16:57'!
createClassTable: anSqSTable
	self createTable: anSqSTable.
	self insertClassTableToCache: anSqSTable.
	anSqSTable children do: [ :childTable | self createClassTable: childTable ].! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/13/2008 10:46'!
createJoinTableFromDescription: collectionDescription 
	| joinTable |
	joinTable := self joinTableForDescription: collectionDescription.
	self currentAdapter createTable: joinTable.
	self insertJoinTableToCache: joinTable! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 12/13/2008 10:44'!
createTable: anSqSTable 
	| |
	self currentAdapter createTable: anSqSTable! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'test 2/3/2009 18:21'!
createTableStructure
	| table |
	table := self classTable baseTable.
	self createClassTable: table.
	
	self currentObject indirectlyReferencedObjects do: [ :collectionInfo | 
		self createJoinTableFromDescription: (collectionInfo collectionDescription) 
	]! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 3/5/2009 20:30'!
currentAdapter
	^ self currentSession sqsDbAdapter! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 3/6/2009 19:02'!
currentObject
	^ currentObject at: 1 ifAbsent: [nil]! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 3/6/2009 19:01'!
currentObject: anObject 
	currentObject := WeakArray with: anObject! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 3/6/2009 19:04'!
currentSession
	^self currentObject sqsSession! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 2/25/2009 19:32'!
getTableChanges
	| allChanges classTable curChanges |
	allChanges := OrderedCollection new.

	"first collect the change objects for all class tables"
	classTable := self classTable.
	
	[ curChanges := self changesOfClassTable: classTable.
	curChanges ifNotNil: [ allChanges add: curChanges ].
	self insertClassTableToCache: classTable.
	classTable := classTable parent ] doWhileTrue: [ classTable isNil not ].

	"but also the join tables can change, so we have to take this into account, too"
	self currentObject indirectlyReferencedObjects do: 
		[ :collectionInfo | 
		| joinTable |
		joinTable := self joinTableForDescription: collectionInfo collectionDescription.
		curChanges := self changesOfJoinTable: joinTable.
		curChanges ifNotNil: [ allChanges add: curChanges ].
		self insertJoinTableToCache: joinTable ].
	^ allChanges! !

!SqsTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 2/16/2009 16:43'!
insertClassTableToCache: classTable
	| |
	self tableCache insertTable: classTable forClass: classTable associatedClass.
! !

!SqsTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 3/5/2009 21:03'!
insertCurrentObject
	| baseTable classTable adapter columnDictionary oid |
	classTable := classInfo cachedClassTable.
	baseTable := classTable baseTable.
	adapter := self currentAdapter.
	"first store the data that belongs into the base table along with the type field"
	columnDictionary := self columnValueDictionaryFor: baseTable.
	columnDictionary 
		at: baseTable typeColumn columnName
		put: self currentObject storedObject class name asSqlValueString.
	oid := adapter 
		storeColumns: columnDictionary
		inTable: baseTable
		andReturnOId: true.
	
	"then walk the inheritance chain up from the real class table and insert those values, too"
	[ classTable = baseTable ] whileFalse: 
		[ columnDictionary := self columnValueDictionaryFor: classTable.
		columnDictionary 
			at: classTable oidColumn columnName
			put: oid asSqlValueString.
		adapter 
			storeColumns: columnDictionary
			inTable: classTable.
		classTable := classTable parent ].
	^ oid! !

!SqsTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 3/9/2009 13:36'!
insertIndirectlyReferencedObject: collectionInformation 
	| connection columnDict collectionDescription counter collection columnDicts |
	connection := self currentAdapter.
	columnDict := Dictionary new.
	collectionDescription := collectionInformation collectionDescription.
	counter := 1.
	collection := collectionInformation collection ifNil: [ OrderedCollection new ].
	columnDicts := OrderedCollection new.
	collection do: [ :obj | 
		| index |
		collection isDictionary 
			ifTrue: [ index := collection keyAtValue: obj ]
			ifFalse: [ index := counter ].
		columnDict := Dictionary new.
		columnDict 
			at: collectionDescription referenceColumn columnName
			put: (self valueForObject: obj ofCollectionDescribedBy: collectionDescription).
		columnDict 
			at: collectionDescription ownerColumn columnName
			put: self currentObject oid.
		collectionDescription maintainOrder ifTrue: 
			[ columnDict 
				at: classInfo configuration collectionConfiguration orderField
				put: index asSqlValueString ].
		counter := counter + 1.
		columnDicts add: columnDict.
	].
	columnDicts ifNotEmpty: [
		connection 
			storeBulkColumns: columnDicts 
			inTable: (self joinTableForDescription: collectionDescription)
	]
	! !

!SqsTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 12/6/2008 15:47'!
insertJoinTableToCache: anSqSTable
	| |
	self tableCache insertJoinTable: anSqSTable forClass: self classInfo baseClass name.! !

!SqsTableStructureHandler methodsFor: 'object-insertion' stamp: 'tkow 2/25/2009 19:51'!
insertOwnedCollections
	self currentObject indirectlyReferencedObjects do: [:collectionInfo | 
		self insertIndirectlyReferencedObject: collectionInfo.
		self currentObject 
			setInstVarNamed: collectionInfo collectionDescription linkedVariable
			withValue: (SqsStorage 
					createCollectionProxyFor: collectionInfo collectionDescription linkedVariable
					with: collectionInfo collection
					in: self currentObject storedObject
					description: collectionInfo collectionDescription) 
	]! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 2/19/2009 14:33'!
joinTableForDescription: collectionDescription 
	| table orderColumn |
	table := SqsTable new
		tableName: collectionDescription tableName;
		associatedClass: self classInfo baseClass name.
	table columns add: collectionDescription ownerColumn.
	collectionDescription referenceColumn canBeNull: true.
	
	table columns add: collectionDescription referenceColumn.
	collectionDescription maintainOrder ifTrue: 
		[ orderColumn := SqsColumn new
			columnName: classInfo configuration collectionConfiguration orderField;
			sqlType: collectionDescription indexType.
		table columns add: orderColumn ].
	table columns do: [ :col | col tableName: table tableName ].
	"the oid field is there to maintain compatibility with AR
	 the join table objects can be instances of separate classes if they have a unique id"
	table addOidColumnNamed: self classInfo configuration tableConfiguration idField.
	^ table! !

!SqsTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 12/13/2008 10:53'!
storeCollectionChanges: collectionChanges withDescription: aDescription 
	| adapter oid |
	adapter := self currentAdapter.
	oid := self currentObject oid.
	collectionChanges deletedObjects ifNotEmpty: 
		[ adapter 
			removeEntries: collectionChanges deletedObjects
			fromJoinTable: aDescription
			forOwnerId: oid ].

	"only move the Entries if the order is important"
	(collectionChanges movedObjects isEmpty not and: [ aDescription maintainOrder ]) ifTrue: 
		[ adapter 
			moveEntries: collectionChanges movedObjects
			inJoinTable: aDescription
			forOwnerId: oid ].
	collectionChanges addedObjects ifNotEmpty: 
		[ adapter 
			addEntries: collectionChanges addedObjects
			inJoinTable: aDescription
			forOwnerId: oid ]! !

!SqsTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 3/5/2009 20:50'!
tableCache
	TableCache ifNil: [ TableCache := Dictionary new ].
	^ TableCache 
		at: classInfo configuration connectionIdentityString
		ifAbsentPut: [ SqsTableCache new ]! !

!SqsTableStructureHandler methodsFor: 'cache-operations' stamp: 'tkow 10/7/2008 17:05'!
tableCacheForClass: aClass
	^TableCache at: aClass name ifAbsentPut: [Dictionary new].
! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 1/18/2009 16:21'!
tableForClassExists
	^ self tableCache tableExistsForClass: self classInfo currentClass name.
	"TODO: if there is no entry in the cache, we should ask the adapter and create reverse
	engineer the current table structure"! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 2/16/2009 16:58'!
tableForClassInfo: classInf 
	| table baseTableName oidColumnName typeColumnName |
	table := SqsTable new.
	table tableName: classInf tableName.
	table structure: self class classTableInheritance.
	table columns: classInf classTableColumns.
	oidColumnName := self classInfo configuration tableConfiguration idField.
	typeColumnName := self classInfo configuration tableConfiguration typeField.
	table columns do: [ :col | col tableName: table tableName ].
	table associatedClass: classInf currentClass name.
	classInf baseClass = classInf currentClass 
		ifTrue: 
			[ table addTypeColumnNamed: typeColumnName.
			table addOidColumnNamed: oidColumnName ]
		ifFalse: 
			[ baseTableName := (SqsClassInfo for: classInf baseClass) tableName.
			table 
				addLightOidColumnNamed: oidColumnName
				linkedTo: baseTableName ].
	classInf cachedClassTable: table.
	^ table! !

!SqsTableStructureHandler methodsFor: 'accessing' stamp: 'tkow 9/30/2008 13:14'!
tableName
	^self classInfo currentClass name asSqSaveTableName ! !

!SqsTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 2/27/2009 16:44'!
updateObject
	"store all directly associated objects right now"
	| adapter classTable columnValueDictionary typeField oidField dirtyVars |
	adapter := self currentAdapter.
	oidField := self classInfo configuration tableConfiguration idField.
	typeField := self classInfo configuration tableConfiguration typeField.
	dirtyVars := self currentObject dirtyAttributes.
	
	"the go along for each class table and insert the values into the table"
	classTable := self classInfo cachedClassTable.
	
	[ columnValueDictionary := self columnValueDictionaryFor: classTable withOnly: dirtyVars.
	  columnValueDictionary ifNotEmpty: [
		adapter 
			updateFields: columnValueDictionary
			ofObjectWithId: self currentObject oid
			inTable: classTable.	
	].	
	classTable := classTable parent ] doWhileTrue: [ classTable isNil not ].
! !

!SqsTableStructureHandler methodsFor: 'object-updating' stamp: 'tkow 3/9/2009 15:52'!
updateOwnedCollections
	| proxy colChanges descr |
	self currentObject indirectlyReferencedObjects do: [ :collectionInfo | 
		"this object should always be an SqSaveCollectionProxy that 
		knows how the object looked like at the last save"
		proxy := collectionInfo collection ifNil: [ OrderedCollection new ].
		descr := collectionInfo collectionDescription.
		(proxy class includesBehavior: SqsProxy) ifTrue: [
			"only write changes if the proxy object has already been loaded. 
			Otherwhise simply do nothing"
			proxy sqsProxiedObject ifNotNil: [
				colChanges := proxy sqsGetCollectionChanges.
				self storeCollectionChanges: colChanges withDescription: descr	
				]
		] ifFalse: [ 
			"someone removed the proxy ... bastard ... well, then. 
			drop all objects and insert the collection once again"
			"self currentAdapter log: 'collection proxy removed from object'."
			self currentAdapter 
				deleteEntriesFromJoinTable: descr
				forObjectId: self currentObject oid.
			self insertIndirectlyReferencedObject: collectionInfo 
		] 
	]! !

!SqsTableStructureHandler methodsFor: 'table-operations' stamp: 'tkow 2/27/2009 16:42'!
updateTableStructure
	| tableChanges adapter |
	tableChanges := self getTableChanges.
	adapter := self currentAdapter.
	tableChanges do: [ :tableChange | 
		adapter removeConstraints: tableChange removedConstraints from: tableChange oldTable tableName.
		tableChange newTableName ifNotNil: [ 
			adapter 
				renameTable: tableChange oldTable tableName
				to: tableChange newTableName 
		].
		adapter renameColumns: tableChange renamedColumns.
		adapter alterColumns: tableChange alteredColumns.
		adapter removeColumns: tableChange removedColumns.
		adapter addColumns: tableChange addedColumns.
		adapter addConstraints: tableChange addedConstraints to: tableChange newTable tableName.
	]! !

!SqsTableStructureHandler methodsFor: 'object-access' stamp: 'tkow 2/25/2009 19:52'!
valueForObject: anObject ofCollectionDescribedBy: collectionDescription 
	| objectValue |
	"return the object itself if it is a simple one
	or the oid on complex objects"
	collectionDescription simpleValues ifTrue: [ 
		objectValue := anObject 
	] ifFalse: [ 
		anObject ifNil: [ 
			objectValue := nil
		] ifNotNil: [ 
			objectValue := anObject oid 
		] 
	].
	^ objectValue asSqlValueString! !

Object subclass: #SqsTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething testBool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsTestObject class
	uses: TSqsSearch
	instanceVariableNames: ''!

!SqsTestObject class methodsFor: 'compiling' stamp: 'tk 8/25/2008 12:03'!
acceptsLoggingOfCompilation
	^false! !

!SqsTestObject class methodsFor: 'persistence-description' stamp: ''!
sqsConfiguration
	^ SqsConfiguration new descriptionHandlerClass: SqsStandardExternDescriptionHandler;
		 collectionConfiguration: (SqsCollectionConfiguration new valueField: 'value';
			 orderField: 'sqs_order_number';
			 yourself);
		 tableConfiguration: (SqsTableConfiguration new inheritanceMode: #singleTableInheritance;
			 typeField: 'type';
			 idField: 'id';
			 yourself);
		 environment: #development;
		 useInstVarAccessors: true;
		 warnOnAlteration: false;
		 yourself! !

!SqsTestObject class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestInteger
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test_integer';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testInteger';
		 yourself! !

!SqsTestObject class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestSomething
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'sqs_test_objects_test_something';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'sqs_test_object_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'sqs_test_objects';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'sqs_test_object_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'test_something_id';
			 sqlType: #integer;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #SqsTestObject;
		 linkedVariable: 'testSomething';
		 orderField: 'sqs_order_number';
		 yourself! !

!SqsTestObject class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestString
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test_string';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testString';
		 yourself! !

!SqsTestObject class methodsFor: 'persistence-description' stamp: ''!
tableInheritance
	^ #classTableInheritance! !

!SqsTestObject class methodsFor: 'compiling' stamp: ''!
wantsChangeSetLogging
	^ false! !

!SqsTestObject methodsFor: 'comparing' stamp: ''!
= t1 
	self class instVarNames
		do: [:t2 | (t1 class instVarNames includes: t2)
				and: [(self instVarNamed: t2)
							= (t1 instVarNamed: t2)
						ifFalse: [^ false]]].
	^ true! !

!SqsTestObject methodsFor: 'accessing' stamp: ''!
testBool
	^ testBool! !

!SqsTestObject methodsFor: 'accessing' stamp: ''!
testBool: t1 
	testBool := t1! !

!SqsTestObject methodsFor: 'accessing' stamp: ''!
testDate
	<type: #dateTime>
	<linkTo: #SqSaveTestObject>
	^ testDate! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate: anObject
	testDate := anObject! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger
	^ testInteger! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger: anObject
	testInteger := anObject! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething
	^ testSomething! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething: anObject
	testSomething := anObject! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString
	^ testString! !

!SqsTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString: anObject
	testString := anObject! !

SqsTestObject subclass: #SqsTestObjectChild
	instanceVariableNames: 'testSubString testUnstoredVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestObjectChild class methodsFor: 'magritte-description' stamp: ''!
sqSaveUnpersistedInstVars
	^ #('testUnstoredVariable' )! !

!SqsTestObjectChild class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestSubString
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test_sub_string';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_test_object_childs';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testSubString';
		 yourself! !

!SqsTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString
	^ testSubString! !

!SqsTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString: anObject
	testSubString := anObject! !

!SqsTestObjectChild methodsFor: 'accessing' stamp: ''!
testUnstoredVariable
	^ testUnstoredVariable! !

!SqsTestObjectChild methodsFor: 'accessing' stamp: ''!
testUnstoredVariable: t1 
	testUnstoredVariable := t1! !

SqsTestObjectChild subclass: #SqsTestObjectEvenDeeperChild
	instanceVariableNames: 'testExtremelyDeepSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString
	^ testExtremelyDeepSubString! !

!SqsTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString: anObject
	testExtremelyDeepSubString := anObject! !

Object subclass: #SqsTestObjectConnector
	instanceVariableNames: 'test1 test2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestObjectConnector class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTest1
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test1';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_test_object_connectors';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'test1';
		 yourself! !

!SqsTestObjectConnector class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTest2
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test2';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_test_object_connectors';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'test2';
		 yourself! !

!SqsTestObjectConnector methodsFor: 'accessing' stamp: 'tkow 2/25/2009 19:41'!
test1
	^ test1! !

!SqsTestObjectConnector methodsFor: 'accessing' stamp: 'tkow 2/25/2009 19:41'!
test1: anObject
	test1 := anObject! !

!SqsTestObjectConnector methodsFor: 'accessing' stamp: 'tkow 2/25/2009 19:41'!
test2
	^ test2! !

!SqsTestObjectConnector methodsFor: 'accessing' stamp: 'tkow 2/25/2009 19:41'!
test2: anObject
	test2 := anObject! !

Object subclass: #SqsTestObjectConnectorPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestObjectConnectorPersistenceDescriptor class methodsFor: 'persistence-description' stamp: 'test 2/27/2009 21:14'!
sqsDescrTest1
^(SqsColumn new
	
	 manuallyMaintained: false;
	 columnName: 'test1';
	 sqlType: #string;
	 objectClass: #ByteString;
	 tableName: 'sqs_test_object_connectors';
	 canBeNull: true;
	 isPrimaryKey: false;
	 autoIncrement: false;
	 linkedVariable: 'test1';
	 yourself)! !

!SqsTestObjectConnectorPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTest2
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test2';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_test_object_connectors';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'test2';
		 yourself! !

Object subclass: #SqsTestObjectPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsTestObjectPersistenceDescriptor subclass: #SqsTestObjectChildPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

SqsTestObjectChildPersistenceDescriptor subclass: #SqsTestObjectEvenDeeperChildPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Tests'!

!SqsTestObjectPersistenceDescriptor class methodsFor: 'compiling' stamp: 'tkow 10/10/2008 14:17'!
acceptsLoggingOfCompilation
	^false! !

!SqsTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestDate
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test_date';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'sqs_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testDate';
		 yourself! !

!SqsTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestInteger
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test_integer';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'sqs_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testInteger';
		 yourself! !

!SqsTestObjectPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTestString
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'test_string';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'sqs_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'testString';
		 yourself! !

!SqsTestObjectPersistenceDescriptor class methodsFor: 'compiling' stamp: ''!
wantsChangeSetLogging
	^ false! !

Object subclass: #SqsUsageAnalyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #SqsUsageOptimizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #SqsUsageStatistic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Analysis'!

Object subclass: #SqsUser
	instanceVariableNames: 'accountData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

SqsUser subclass: #SqsAdmin
	instanceVariableNames: 'administeredBlogs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

!SqsAdmin methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:49'!
administeredBlogs
	^ administeredBlogs! !

!SqsAdmin methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:49'!
administeredBlogs: anObject
	administeredBlogs := anObject! !

!SqsAdmin methodsFor: 'initialization' stamp: 'tkow 3/1/2009 23:50'!
initialize
	super initialize.
	administeredBlogs := OrderedCollection new.! !

!SqsAdmin methodsFor: 'as yet unclassified' stamp: 'tkow 3/2/2009 00:13'!
isAdmin
	^ true! !

SqsUser subclass: #SqsAuthor
	instanceVariableNames: 'blogs followers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

!SqsAuthor methodsFor: 'accessing' stamp: 'tkow 2/27/2009 18:24'!
blogs
	^ blogs! !

!SqsAuthor methodsFor: 'accessing' stamp: 'tkow 2/27/2009 18:24'!
blogs: anObject
	blogs := anObject! !

!SqsAuthor methodsFor: 'accessing' stamp: 'tkow 3/1/2009 17:30'!
followers
	^ followers! !

!SqsAuthor methodsFor: 'accessing' stamp: 'tkow 3/1/2009 17:30'!
followers: anObject
	followers := anObject! !

!SqsAuthor methodsFor: 'as yet unclassified' stamp: 'tkow 3/1/2009 23:49'!
initialize
	super initialize.
	blogs := OrderedCollection new.
	followers := OrderedCollection new.! !

!SqsUser methodsFor: 'accessing' stamp: 'tkow 3/1/2009 17:53'!
accountData
	^ accountData! !

!SqsUser methodsFor: 'accessing' stamp: 'tkow 3/1/2009 17:52'!
accountData: anObject
	accountData := anObject! !

!SqsUser methodsFor: 'initialization' stamp: 'tkow 3/2/2009 00:14'!
initialize
	super initialize.
	accountData := SqsAccountData new.! !

!SqsUser methodsFor: 'testing' stamp: 'tkow 3/2/2009 00:12'!
isAdmin
	^ false! !

Object subclass: #SqsUserPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

SqsUserPersistenceDescriptor subclass: #SqsAdminPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

SqsUserPersistenceDescriptor subclass: #SqsAuthorPersistenceDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Models'!

!SqsUserPersistenceDescriptor class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAccountData
	^ SqsColumn new associatedClass: #SqsAccountData;
		 manuallyMaintained: false;
		 columnName: 'account_data_id';
		 sqlType: #integer;
		 objectClass: #SqsAccountData;
		 tableName: 'sqs_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'accountData';
		 yourself! !

Object subclass: #SqsWeakStaggeredCache
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Base'!

!SqsWeakStaggeredCache methodsFor: 'initialization' stamp: 'tkow 3/9/2009 13:12'!
at: anObject
	^ self at: anObject ifAbsent: [self error: 'Element not found']! !

!SqsWeakStaggeredCache methodsFor: 'initialization' stamp: 'tkow 3/9/2009 13:12'!
at: anObject ifAbsent: something
	^ (self subCacheFor: anObject) at: anObject ifAbsent: something! !

!SqsWeakStaggeredCache methodsFor: 'initialization' stamp: 'tkow 3/9/2009 11:43'!
at: anObject put: anotherObject
	| |
	(self subCacheFor: anObject) at: anObject put: anotherObject.! !

!SqsWeakStaggeredCache methodsFor: 'accessing' stamp: 'tkow 3/9/2009 11:16'!
cache
	^ cache! !

!SqsWeakStaggeredCache methodsFor: 'accessing' stamp: 'tkow 3/9/2009 11:16'!
cache: anObject
	cache := anObject! !

!SqsWeakStaggeredCache methodsFor: 'initialization' stamp: 'tkow 3/9/2009 11:40'!
hashKeyFor: anObject
	| hash |
	hash := anObject identityHash.
	^ (hash \\ 1024) + 1.
! !

!SqsWeakStaggeredCache methodsFor: 'as yet unclassified' stamp: 'tkow 3/9/2009 11:17'!
initialize
	super initialize.
	cache := Array new: 1024.! !

!SqsWeakStaggeredCache methodsFor: 'initialization' stamp: 'tkow 3/9/2009 13:08'!
subCacheFor: anObject
	| subCache hashKey |
	hashKey := self hashKeyFor: anObject.
	subCache := cache at: hashKey ifAbsent: nil.
	subCache ifNil: [
		cache at: hashKey put: WeakIdentityKeyDictionary new.
	].
	^ cache at: hashKey! !

Object subclass: #StSqueakSaveDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-UsageExamples'!

!StSqueakSaveDatabase commentStamp: 'tkow 9/24/2008 16:51' prior: 0!
A StSqueakSaveDatabase is another database variation for the SWA Seaside Tutorial application.

Instance Variables
!

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 11/11/2008 13:42'!
addTask: aTask toUser: aUser
	aUser addTask: aTask.
	aTask save.
	aUser save.
	^aTask! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 9/24/2008 15:00'!
addUser: aUser
	aUser save.
	^aUser! !

!StSqueakSaveDatabase methodsFor: 'accessing' stamp: 'tkow 9/24/2008 14:06'!
connectionFailed
	^ false! !

!StSqueakSaveDatabase methodsFor: 'connection' stamp: 'tkow 9/24/2008 16:05'!
disconnect
	^true! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 12/12/2008 17:45'!
findUserByEmail: anEmail 
	^ (SqsSearch for: StUser) 
		findBy: #email
		withValues: anEmail! !

!StSqueakSaveDatabase methodsFor: 'initialization' stamp: 'tkow 2/23/2009 16:55'!
initialize
	| conSpec |
	super initialize.
	conSpec := SqsConnectionSpecification 
		user: 'thomas'
		password: 'test'
		database: 'ToDoApp'.
	SqsConnectionManager getInstance 
		setConfiguration: (SqsConfiguration conSpec: conSpec)
		for: 'STTutTodoApp'! !

!StSqueakSaveDatabase methodsFor: 'public' stamp: 'tkow 9/24/2008 13:58'!
save: anObject
	anObject save! !

Object subclass: #WeblogDb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Database'!

WeblogDb subclass: #SqsWeblogDb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Database'!

!SqsWeblogDb methodsFor: 'storing' stamp: 'tkow 3/2/2009 00:18'!
addUser: aUser 
	aUser save! !

!SqsWeblogDb methodsFor: 'storing' stamp: 'tkow 3/2/2009 00:33'!
dbConfig
	| conSpec |
	conSpec := SqsConnectionSpecification 
		user: 'test' 
		password: 'test' 
		port: 3306 
		database: 'SqsBlog'
		hostname: 'localhost' 
		driver: #SqsMysqlAdapter.
		
	"or: conSpec := SqsConnectionSpecification user: 'test' password: 'test' database: 'SqsBlog'"
	^ SqsConfiguration conSpec: conSpec.! !

!SqsWeblogDb methodsFor: 'connection-status' stamp: 'tkow 3/3/2009 13:24'!
disconnect
	! !

!SqsWeblogDb methodsFor: 'searching' stamp: 'tkow 3/3/2009 14:19'!
findUserByEmail: anEmail
	| user |
	user := (SqsSearch for: SqsUser) detect: [:author | author accountData email = anEmail] ifNone: [nil].
	^ user! !

!SqsWeblogDb methodsFor: 'storing' stamp: 'tkow 3/2/2009 00:29'!
initialize
	super initialize.
	self setupDbConfig.! !

!SqsWeblogDb methodsFor: 'storing' stamp: 'tkow 3/1/2009 17:46'!
saveBlog: aBlog forUser: aUser
	aUser blogs add: aBlog.
	aUser deepSave.! !

!SqsWeblogDb methodsFor: 'storing' stamp: 'tkow 3/1/2009 17:45'!
saveComment: aComment forBlog: aBlog
	aBlog comments add: aComment.
	aBlog save.! !

!SqsWeblogDb methodsFor: 'storing' stamp: 'tkow 3/1/2009 17:45'!
saveEntry: blogEntry for: blog
	blog entries add: blogEntry.
	blog save.! !

!SqsWeblogDb methodsFor: 'storing' stamp: 'tkow 3/2/2009 00:31'!
setupDbConfig
	SqsConnectionManager getInstance setConfiguration: self dbConfig for: 'SqSave-Apps-Weblog'! !

!WeblogDb methodsFor: 'storing' stamp: 'tkow 3/2/2009 00:18'!
addUser: aUser 
	self subclassResponsibility! !

!WeblogDb methodsFor: 'connection-status' stamp: 'tkow 3/1/2009 23:43'!
connectionFailed
	^ false! !

!WeblogDb methodsFor: 'connection-status' stamp: 'tkow 3/3/2009 13:24'!
disconnect
	self subclassResponsiblity! !

!WeblogDb methodsFor: 'searching' stamp: 'tkow 3/1/2009 17:37'!
findUserByEmail: email
	self subclassResponsibility! !

!WeblogDb methodsFor: 'storing' stamp: 'tkow 3/1/2009 17:47'!
saveBlog: aBlog forUser: aUser
	self subclassResponsibility! !

!WeblogDb methodsFor: 'storing' stamp: 'tkow 3/1/2009 17:38'!
saveComment: comment forBlog: aBlog
	self subclassResponsibility! !

!WeblogDb methodsFor: 'storing' stamp: 'tkow 3/1/2009 17:39'!
saveEntry: blogEntry for: blog
	self subclassResponsibility! !

!UndefinedObject class methodsFor: '*sqsave' stamp: 'tkow 2/27/2009 12:48'!
sqsType
	^ #integer! !

!UndefinedObject methodsFor: '*sqsave' stamp: 'wh 8/10/2006 11:38'!
asSqlValueString
	^'NULL'.! !

!Date class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:24'!
sqsType
	^#date! !

!Date methodsFor: '*sqsave' stamp: 'wh 3/2/2006 15:23'!
asSqlValueString
	^'''', self yyyymmdd,''''. ! !

!Dictionary class methodsFor: '*sqsave' stamp: 'tkow 2/24/2009 17:43'!
sqsCreateFromResults: resultDict
	| dict |
	dict := self new: resultDict size.
	resultDict keysAndValuesDo: [ :key :value |
		dict at: key put: value
	].
	^ dict! !

!Dictionary class methodsFor: '*sqsave' stamp: 'tkow 2/16/2009 20:54'!
sqsRequiresOrderField
	^ true! !

!Dictionary methodsFor: '*sqsave' stamp: 'test 1/22/2009 17:33'!
keysAndValuesDetect: aBlock 
	"returns not the association but the value of the association for which aBlock
	 evaluates to true for the first time"
	^ self 
		keysAndValuesDetect: aBlock
		ifNone: [ self errorNoMatch ]! !

!Dictionary methodsFor: '*sqsave' stamp: 'test 1/22/2009 17:34'!
keysAndValuesDetect: aBlock ifNone: errorBlock 
	"returns not the association but the value of the association for which aBlock
	 evaluates to true for the first time"
	self associationsDo: [ :assoc | 
		(aBlock value: assoc key value: assoc value) ifTrue: [ ^ assoc value ] 
	].
	^ errorBlock value! !

!Dictionary methodsFor: '*sqsave' stamp: 'tkow 9/12/2008 17:10'!
keysSelect: aBlock
	| newCollection |

	newCollection := self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each key) ifTrue: [newCollection add: each]].
	^newCollection! !

!Dictionary methodsFor: '*sqsave' stamp: 'tk 8/15/2008 14:55'!
valueJoin: anotherDictionary
	"really joins two dictionaries with collections as values"
	| ownValue mergeValue |
	anotherDictionary associationsDo: [ :assoc |
		(self includesKey: assoc key) ifTrue: [
			ownValue := (self at: assoc key) isCollection ifTrue:[
				self at: assoc key
			] ifFalse: [
				OrderedCollection with: (self at: assoc key)
			].
			mergeValue := (assoc value) isCollection ifTrue:[
				assoc value
			] ifFalse: [
				OrderedCollection with: (assoc value).
			].
			self at: assoc key put: (ownValue union: mergeValue).
		] ifFalse: [
			self at: assoc key put: assoc value
		]
	].
	^self! !

!Symbol class methodsFor: '*sqsave' stamp: 'tkow 1/19/2009 17:47'!
fromSqlValue: anObject
	^ anObject asSymbol! !

!Symbol class methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 01:53'!
sqsType
	^#string! !

!Symbol methodsFor: '*sqsave' stamp: 'tkow 11/11/2008 01:53'!
asSqlValueString
	^'''', self asString ,''''! !

!Bag class methodsFor: '*sqsave' stamp: 'tkow 2/16/2009 20:54'!
sqsRequiresOrderField
	^ false! !

!Integer class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:28'!
sqsType
	^#integer ! !

!Integer methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:44'!
asSqlValueString
	^self asString.! !

!Set class methodsFor: '*sqsave' stamp: 'tkow 2/16/2009 20:54'!
sqsRequiresOrderField
	^ false! !

!Collection class methodsFor: '*sqsave' stamp: 'tkow 2/24/2009 17:39'!
sqsCreateFromResults: resultDict
	| |
	^ self withAll: resultDict values.
	! !

!Collection class methodsFor: '*sqsave' stamp: 'tkow 2/16/2009 20:53'!
sqsRequiresOrderField
	^ true! !

!Collection methodsFor: '*sqsave' stamp: 'tk 7/14/2008 19:02'!
join: joinString
	| joiner |
	joiner := joinString ifNil:[''] ifNotNil: [joinString].
	^String streamContents: [:s | self asStringOn: s delimiter: joiner]! !

WAFileLibrary subclass: #SqsBlogLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogLibrary class methodsFor: 'accessing' stamp: 'tkow 3/1/2009 23:32'!
applicationName

	^ 'Squeak Save Blog Sample'! !

!SqsBlogLibrary methodsFor: 'accessing' stamp: 'micper 4/9/2008 13:53'!
selectorsToInclude

	^ #( todoCss )! !

!SqsBlogLibrary methodsFor: 'uploaded' stamp: 'dt 4/13/2008 13:07'!
todoCss

	^ '
body {
	font: normal 100% Arial, Helvetica, Verdana, sans-serif;
}
	
.generic {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-style: normal;
	font-weight: normal;
	font-size: 14px;
	color : #663300;
	padding: 20px;
	margin-top: 20px;
	margin-left: 20px;
	border: 1px solid #663300;
	width: 500px;
}

.lightbox {
	background-color:#FFFFFF;
}

.errorMessage {
	background-color: #ffb0b0;
	border: 1px solid #ee0000;
	padding: 5px;
	margin-bottom: 10px;
}

.infoMessage {
	background-color: #fbffcc;
	border: 1px solid #eda33a;
	padding: 5px;
	margin-bottom: 10px;
}

a {
	color : #663300;
	text-decoration: underline;
}'! !

WATask subclass: #SqsBlogRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogRootTask class methodsFor: 'testing' stamp: 'micper 4/9/2008 11:39'!
canBeRoot

	^ true! !

!SqsBlogRootTask class methodsFor: 'testing' stamp: 'tkow 3/1/2009 23:52'!
initialize

	(self registerAsApplication: 'todo')
		addLibrary: SULibrary;
		addLibrary: SqsBlogLibrary;
		preferenceAt: #sessionClass put: SqsBlogSession.! !

!SqsBlogRootTask methodsFor: 'processing' stamp: 'tkow 3/1/2009 23:35'!
go

	| loginAnswer user |
	loginAnswer := self call: SqsBlogLoginComponent new.
	loginAnswer = #registerUser
		ifTrue: [user := self call: SqsBlogRegisterComponent new]
		ifFalse: [user := loginAnswer].
	user ifNotNil: [
		self session login: user.
		self call: SqsBlogLoggedInComponent new].! !

WASession subclass: #SqsBlogSession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSave-Apps-Weblog-Components'!

!SqsBlogSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
database

	^ database! !

!SqsBlogSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
database: anObject

	database := anObject.! !

!SqsBlogSession methodsFor: 'actions' stamp: 'micper 4/9/2008 14:28'!
findUserByEmail: anEmail

	^ self database findUserByEmail: anEmail! !

!SqsBlogSession methodsFor: 'initializing' stamp: 'tkow 3/1/2009 23:43'!
initialize
	
	super initialize.
	self database: SqsWeblogDb new.! !

!SqsBlogSession methodsFor: 'comparing' stamp: 'micper 4/9/2008 11:22'!
isLoggedIn

	^ self user isNil not! !

!SqsBlogSession methodsFor: 'actions' stamp: 'micper 4/9/2008 11:22'!
login: aUser
	
	self user: aUser.! !

!SqsBlogSession methodsFor: 'actions' stamp: 'micper 4/9/2008 11:22'!
logout

	self user: nil.! !

!SqsBlogSession methodsFor: 'request handling' stamp: 'micper 4/9/2008 14:29'!
responseForRequest: aRequest

	self database connectionFailed
		ifTrue: [^ WAResponse new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!SqsBlogSession methodsFor: 'private' stamp: 'micper 4/9/2008 14:21'!
unregistered

	self database disconnect.
	super unregistered.! !

!SqsBlogSession methodsFor: 'updating' stamp: 'micper 4/9/2008 13:54'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
	anHtmlRoot title: StToDoLibrary applicationName.! !

!SqsBlogSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user

	^ user! !

!SqsBlogSession methodsFor: 'accessing' stamp: 'dt 4/13/2008 12:39'!
user: anObject

	user := anObject.! !

!Boolean class methodsFor: '*sqsave' stamp: 'test 1/19/2009 17:56'!
fromSqlValue: anObject
	(anObject class includesBehavior: Boolean) ifTrue: [
		^ anObject	
	] ifFalse: [
		anObject = 1 ifTrue: [
			^ true	
		] ifFalse: [
			^ false
		]
	]
	! !

!Boolean class methodsFor: '*sqsave' stamp: 'tkow 11/10/2008 16:27'!
sqsType
	^#boolean! !

!Boolean methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:57'!
asSqlValueString
	self ifTrue:[
		^'TRUE'.
	] ifFalse:[
		^'FALSE'.
	].! !

!Float class methodsFor: '*sqsave' stamp: 'tkow 1/20/2009 14:33'!
sqsType
	^#float! !

!Float methodsFor: '*sqsave' stamp: 'wh 8/8/2006 15:46'!
asSqlValueString
	^self asString.! !
SqsBlogRootTask initialize!
